# Beech Tree

Vétyem Woodsը հայտնի վայր է, որը ծածկված է գունավոր ծառերով։ Ամենահին և ամենաբարձր ծառերից մեկը Ős Vezérն է։

Ős Vezér ծառը կարող է ներկայացվել որպես $N$ **գագաթների** և $N-1$ **կողերի** բազմություն։
Գագաթները համարակալված են $0$-ից $N-1$ թվերով, կողերը համարակալված են $1$-ից $N-1$ թվերով։
Ամեն կող միացնում է երկու իրարից տարբեր գագաթներ` $v$ ($1 \le v \lt N$) համարի կողը միացնում է $v$ գագաթը $P[v]$ գագաթին, որտեղ $0 \le P[v] \lt v$։
 $P[i]$ գագաթը կոչվում է $i$ գագաթի **ծնող**, իսկ $i$ գագաթը կոչվում է  $P[i]$ գագաթի **զավակ**.։
 
Կողերը ներկված են գույներով։ Կան $M$ հնարավոր գույներ, որոնք համարակալված են $1$-ից $M$ թվերով։ $i$ համարի կողի գույնը $C[i]$ է։ Տարբեր կողեր կարող են լինել նույն գույնի։

Նկատեք, որ ըստ սահմանման $v = 0$-ին կող չի համապաատսխանում ծառի որևէ կողի։ Հարմարավետության համար թող $P[0] = -1$ և $C[0] = 0$.

Դիտարկենք օրինակ $N = 18$ հատ գագաթով և $M = 3$ հատ հնարավոր գույնով։ $17$ կողերը նկարագրվում են $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ հաջորդականությամբ, իսկ գույները $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$ հաջորդականությամբ։ Ծառը պատկերված է հետևյալ նկարում։

![Tree](beechtree-tree.png "550")

Արպադը անտառապահ է ում հետաքրքրում են ծառի հատուկ մասեր, որոնց անվանում են **ենթածառեր**։
Յուրաքանչյուր $r$ գագաթի համար, այնպիսին, որ $0 \le r \lt N$, $r$-ի ենթածառը (նշանակենք $T(r)$) գագաթների բազմություն է, որն ունի այսպիսի հատկություններ․

* $r$ գագաթը պատկանում է $T(r)$-ին,
* եթե $x$-ը պատկանում է $T(r)$,-ին, ապա $x$-ի բոլոր զավակները նույնպես պատկանում են $T(r)$-ին։
* Ուրիշ որևէ գագաթ չի պատկանում $T(r)$ բազմությանը։

$T(r)$ բազմության չափը նծանակենք $|T(r)|$։

Արպադը վերջերս հայտնաբերել է ենթածառի բարդ, բայց հետաքրքիր  հատկություն: Արպադը իր հայտնագործության ընթացքում թղթով և գրիչով շատ աշխատեց, և նա ենթադրում է, որ Դուք կարող եք նույնն անել դա հասկանալու համար: Նա նաև Ձեզ ցույց կտա բազմաթիվ օրինակներ, որոնք այնուհետև կարող եք մանրամասն վերլուծել:

Ենթադրենք մենք ունենք ֆիքսված $r$ և $T(r)$-ում գագաթների  $[v_0, v_1, \ldots, v_{|T(r)|-1}]$ տեղափոխությունը։ 

Յուրաքանչյուր  $i$ համար, որ $1 \le i \lt |T(r)|$, թող $f(i)$ լինի $C[v_1], C[v_2], \ldots, C[v_{i-1}]$ գույների հաջորդականությունում $C[v_i]$ գույնի հանդիպումների քանակը։

(Նկատեք, որ $f(1)$-ը միշտ $0$ է, որովհետև նրա սահմանման մեջ գույների հաջորդականությունը դատարկ է)։

$v_0, v_1, \ldots, v_{|T(r)|-1}$ տեղափոխությունը **գեղեցիկ տեղափոխություն է** այն և միայն այն դեպքում, եթե տեղի ունեն հետևյալ բոլոր հատկությունները․
* $v_0 = r$.
* Յուրաքանչյուր $i$-ի համար, որ $1 \le i \lt |T(r)|$, $v_i$ գագաթի ծնողը $v_{f(i)}$ գագաթն է։

Ցանկացած $r$-ի համար, որ  $0 \le r \lt N$, $T(r)$ ենթածառը **գեղեցիկ ենթածառ** է այն և միայն այն դեպքում, եթե $T(r)$-ում գոյություն ունի գագաթների գեղեցիկ տեղափոխություն։ Նկատեք, որ ըստ սահմանման, մեկ գագաթից կազմված յուրաքանչյուր ենթածառ գեղեցիկ է։

Դիտարկենք վերոհիշյալ օրինակը։ Կարելի է ցույց տալ,  որ այս ծառի $T(0)$ և $T(3)$ ենթածառերը գեղեցիկ չեն։ $T(14)$ ենթածառը գեղեցիկ է, որովհետև այն բաղկացած է մեկ գագաթից։ Ներքևում ցույց կտրվի, որ $T(1)$ ենթածառը նույնպես գեղեցիկ է։

Դիտարկենք $[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$ հաջորդականությունը։ Այս հաջորդականությունը $T(1)$-ում գագաթների տեղափոխություն է։ Գագաթներից յուրաքանչյուրի վերևում գրված է հաջորդականությունում նրա ինդեքսը։

![Tree](beechtree-label1.png "500")

Ցույց տանք, որ $T(1)$ ենթածառը գեղեցիկ է․
* $v_0 = r = 1$.
* $f(1) = 0$, որովհետև $C[v_1] = C[4] = 1$ գույնը $0$ անգամ է հանդիպում $[]$ հաջորդականության մեջ, և $P[v_1] = P[4] = 1 = v_0$ (այսինքն, 4-ի ծնողը 1-ն է)
* $f(2) = 0$, որովհետև $C[v_2] = C[5] = 2$ գույնը $0$ անգամ է հանդիպում $[1]$ հաջորդականության մեջ, և $P[v_2] = P[5] = 1 = v_0$ (այսինքն, 5-ի ծնոը 1-ն է)։
* $f(3) = 1$, որովհետև $C[v_3] = C[12] = 1$ գույնը $1$ անգամ է հանդիպում $[1, 2]$ հաջորդականության մեջ, և $P[v_3] = P[12] = 4 = v_1$ (այսինքն, 12-ի ծնողը 4-ն է)
* $f(4) = 1$, որովհետև $C[v_4] = C[13] = 2$ գույնը $1$ անգամ է հանդիպում $[1, 2, 1]$ հաջորդականության մեջ, և $P[v_4] = P[13] = 4 = v_1$ (այսինքն, 13-ի ծնողը 4-ն է)
* $f(5) = 0$, որովհետև $C[v_5] = C[6] = 3$ գույնը $0$ անգամ է հանդիպում $[1, 2, 1, 2]$ հաջորդականության մեջ, և $P[v_5] = P[6] = 1 = v_0$, (այսինքն, 6-ի ծնողը 1-ն է)
* $f(6) = 2$, որովհտեև $C[v_6] = C[14] = 2$ գույնը $2$ անգամ է հանդիպում $[1, 2, 1, 2, 3]$ հաջորդականության մեջ, և $P[v_6] = P[14] = 5 = v_2$ (այսինքն, 14-ի ծնողը 5-ն է)։

Քանի որ մենք  $T(1)$-ում գտանք գագաթների գեղեցիկ տեղափոխություն, $T(1)$ ենթածառը գեղեցիկ է։

Ձեր խնդիրն է օգնել Արպադին ամեն ենթածառի համար հասկանալ արդյոք այն գեղեցիկ է, թե ոչ։

## Իրականացման մանրամասներ

Դուք պետք է ծրագրավորեք հետևյալ ֆունկցիան։

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$․ Ծառի գագաթների քանակը։
* $M$․ Հնարավոր գույների քանակը։
* $P$, $C$․ $N$ երկարության զանգվածներ որոնք նկարագրում են ծառի կողերը և դրանց գույները։
* Ֆունկցիան պետք է վերադարձնի $N$ երկարության $b$ զանգված։ $b[r]$-ը ($0 \le r \lt N$) պետք է հավասար լինի $1$-ի, եթե $T(r)$-ը գեղեցիկ է, և $0$-ի հակառակ դեպքում։
* Այս ֆունկցիան կանչվում է ճիշտ մեկ անգամ ամեն թեստի համար։

## Օրինակներ

### Օրինակ 1

Դիտարկենք հետևյալ կանչը։

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

Ծառը պատկերված է հետևյալ նկարում․

![Tree](beechtree-ex1.png "350")

$T(1)$, $T(2)$, և $T(3)$ երթածառերը պարունակում են մեկական գագաթ և հետևաբար գեղեցիկ են։
$T(0)$-ն գեղեցիկ է։ Այսպիսով, ֆունկացիան պետք է վերադարձնի $[0, 1, 1, 1]$.

### Օրինակ 2

Դիտարկենք հետևյալ կանչը։

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

Օրինակը ներկայացված է խնդրի նկարագրության մեջ։

Ֆունկցիան պետք է վերադարձնի $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$.

### Օրինակ 3

Դիտարկենք հետևյալ կանչը։

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

Ծառը պատկերված է հետևյալ նկարում․

![Tree](beechtree-ex3.png "400")

$T(0)$-ն միակ ենթածառն է, որ գեղեցիկ չէ։ Ֆունկցիան պետք է վերադարձնի $[0, 1, 1, 1, 1, 1, 1]$.


## Սահմանափակումներ

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[v] \lt v$ ($1 \le v \lt N$)
* $1 \le C[v] \le M$ ($1 \le v \lt N$)
* $P[0] = -1$ և $C[0] = 0$

## Ենթախնդիրներ

1. (9 միավոր) $N \le 8$ և $M \le 500$
1. (5 միավոր) $v$ կողը իրար է միացնում $v$ և $v-1$ գագաթները։ Այսինքն, $P[v] = v-1$ ($1 \le v \lt N$)։
1. (9 միավոր) $0$-ից տարբեր գագաթները կա՛մ միացված են $0$-ին, կա՛մ միացված են այնպիսի գագաթի, որը միացված է $0$-ին։ Այսինքն, $P[v]=0$ կամ $P[P[v]]=0$ ($1 \le v \lt N$):
1. (8 միավոր) Յուրաքանչյուր $c$ ($1 \le c \le M$) գույնի համար այդ գույնի առավերագույնը երկու կող կա:
1. (14 միավոր) $N \le 200$ և $M \le 500$
1. (14 միավոր) $N \le 2\,000$ և $M = 2$
1. (12 միավոր) $N \le 2\,000$
1. (17 միավոր) $M = 2$
1. (12 միավոր) Հավելյալ սահմանափակումներ չկան։

## Գրեյդերի նմուշ

Գրեյդերի նմուշը մուտքային տվյալները ներածում է հետևյալ ձևաչափով․

* Տող $1$: $N \; M$
* Տող $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* Տող $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

Դիցուք  `beechtree`-ն վերադարձնում է  $b[0], \; b[1], \; \ldots$ զանգվածի տարրերը։
Գրեյդերի նմուշը տպում է Ձեր պատասխանը մի տողում հետևյալ ձևաչափով․ 
* Տող $1$: $b[0] \; b[1] \; \ldots$
