# Fıstıq Ağacı

Hirkan milli parkı çoxlu rəngli ağacları ilə məşhurdur.
Ən köhnə və uzun ağaclarından birinin adı Vəzirdir.

Vəziri $N$ düyün nöqtəsi və onlar arasında olan $N-1$ əlaqə ilə göstərmək olar. 
Düyün nöqtələri $0$'dan $N-1$'ə, əlaqələr isə $1$'dən $N-1$'ə nömrələnib. 
Hər bir əlaqə iki müxtəlif nöqtəni birləşdirir.
Daha dəqiq olsaq, $i$ ($1 \le i \lt N$) əlaqəsi $i$ düyün nöqtəsini onun **atası** sayılacaq $P[i]$ ($0 \le P[i] \lt i$) nöqtəsinə birləşdirir və $i$ nöqtəsi $P[i]$ nöqtəsinin **uşağı** olacaq.

Hər bir əlaqənin rəngi var. $1$'dən $M$'ə nömrələnmiş $M$ sayda mümkün rəng var. 
$i$ əlaqəsinin rəngi $C[i]$'dir.
Müxtəlif əlaqələrin eyni rəngi ola bilər.

Qeyd edək ki, yuxarıdakı izaha görə $i = 0$ ağacdakı heç bir əlaqəni göstərmir.
Rahatlıq üçün $P[0] = -1$ və $C[0] = 0$ təyin edəcəyik.

Məsələn, fərz edək ki Vəzirin $N = 18$ düyün nöqtəsi var və mümkün rənglərin sayı $M = 3$'dür. Əlaqələr və onların rəngləri bu formadadır: $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$, $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$. 

Ağac aşağıdakı şəkildə göstərilib:

![Tree](beechtree-tree.png "550") 

Atakişi bacarıqlı meşəbəyidir və ağacın **altağac** adlanan hissələrini araşdırmağı sevir.
$0 \le r \lt N$ şərtini ödəyən bütün $r$'lər üçün onun altağacı aşağıdakı şərtləri ödəyən $T(r)$ çoxluğudur:
* $r$ düyün nöqtəsi $T(r)$'a aiddir;
* $x$ düyün nöqtəsi $T(r)$'a aid olarsa, $x$'in bütün uşaqları da $T(r)$'a aiddir;
* Başqa heç bir düyün nöqtəsi $T(r)$'a aid deyil.

$T(r)$'in ölçüsünü $|T(r)|$ olaraq göstərəcəyik.

Atakişi altağacların çətin amma maraqlı bir özəlliyini tapdı. Onun bu kəşfi vərəq üzərində çoxlu şəkil çəkməklə əmələ gəldi və sizdən də həmin özəlliyi başa düşməyiniz üçün eynisini etməyinizi gözləyir. O həmçinin sizə üzərində daha detallı analiz apara bilməyiniz üçün müxtəlif nümunələr göstərəcək.

Fərz edək ki bir $r$, və $T(r)$ altağacından $v_0, v_1, \ldots, v_{|T(r)|-1}$ permutasiyası seçmişik. 

$1 \le i \lt |T(r)|$ şərtini ödəyən bütün $i$'lər üçün $f(i)$ $C[v_i]$ rənginin $i-1$ uzunluqlu $C[v_1], C[v_2], \ldots, C[v_{i-1}]$ massivində neçə dəfə rast gəldiyini göstərsin. 

(Qeyd edək ki $f(1)$ həmişə $0$'dır, çünki onun üçün olan rəng ardıcıllığı boşdur.)

$v_0, v_1, \ldots, v_{|T(r)|-1}$ permutasiyası yalnız aşağıdakı şərtləri ödəyərsə **gözəl permutasiya** adlanır:
* $v_0 = r$.
* $1 \le i \lt |T(r)|$ şərtini ödəyən hər $i$ üçün $v_i$ düyün nöqtəsinin atası $v_{f(i)}$'dir.

$0 \le r \lt N$ şərtini ödəyən $r$ üçün $T(r)$ altağacı o zaman **gözəl altağac** sayılır ki, $T(r)$'də olan düyün nöqtələrinin gözəl permutasiyası olsun. Qeyd edək ki, bu izaha görə bir nöqtədən ibarət altağacların hamısı gözəldir.

Yuxarıdakı ağaca nəzər yetirin.
Göstərmək olar ki $T(0)$ və $T(3)$ altağacları gözəl deyil.
$T(14)$ altağacında yalnız bir düyün nöqtəsi olduğu üçün o, gözəl altağacıdır.
Aşağıda $T(1)$'in də gözəl altağac olduğunu göstərəcəyik.

Müxtəlif ədədlərdən ibarət $[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$ massivinə nəzər yetirin. Bu ardıcıllıq $T(1)$'də olan nöqtələrin permutasiyasıdır. Aşağıdakı şəkil həmin permutasiyanı göstərir. Düyün nöqtələrinin sağ üstündə qeyd olunan ədədlər həmin nöqtələrin permutasiyadakı sıralarını göstərir.

![Tree](beechtree-label1.png "500") 

İndi isə niyə *gözəl* olduğunu göstərəcəyik.

* $v_0 = 1$.
* $f(1) = 0$, çünki $C[v_1] = C[4] = 1$ ədədinə $[]$ massivində $0$ dəfə rast gəlinir.
  * Nəticə olaraq, $v_1$'in atası $v_0$'dır. Yəni $4$'ün atası $1$ nöqtəsidir. ($P[4] = 1$)
* $f(2) = 0$ çünki $C[v_2] = C[5] = 2$ ədədinə $[1]$ massivində $0$ dəfə rast gəlinir.
  * Nəticə olaraq, $v_2$'nin atası $v_0$'dır. Yəni $5$'in atası $1$ nöqtəsidir.
* $f(3) = 1$ çünki $C[v_3] = C[12] = 1$ ədədinə $[1, 2]$ massivində $1$ dəfə rast gəlinir.
  * Nəticə olaraq, $v_3$'ün atası $v_1$'dır. Yəni $12$'nin atası $4$ nöqtəsidir. 
* $f(4) = 1$ çünki $C[v_4] = C[13] = 2$ ədədinə $[1, 2, 1]$ massivində $1$ dəfə rast gəlinir.
  * Nəticə olaraq, $v_4$'ün atası $v_1$'dır. Yəni $13$'ün atası $4$ nöqtəsidir.
* $f(5) = 0$ çünki $C[v_5] = C[6] = 3$ ədədinə $[1, 2, 1, 2]$ massivində $0$ dəfə rast gəlinir.
  * Nəticə olaraq, $v_5$'in atası $v_0$'dır. Yəni $6$'nın atası $1$ nöqtəsidir.
* $f(6) = 2$ çünki $C[v_6] = C[14] = 2$ ədədinə $[1, 2, 1, 2, 3]$ massivində $2$ dəfə rast gəlinir.
  * Nəticə olaraq, $v_6$'nın atası $v_2$'dır. Yəni $14$'ün atası $5$ nöqtəsidir. 

$T(1)$'in gözəl permutasiyasını tapa bildiyimiz üçün $T(1)$ gözəl altağac olur.

Sizin vəzifəniz hər bir altağac üçün Atakişiyə həmin altağacın gözəl olub olmadığını bildirməkdir.


## İmplementasiya detalları

Aşağıdakı proseduru implement etməlisiniz.

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: Ağacdakı düyün nöqtələrinin sayı.
* $M$: Mümkün əlaqə rənglərinin sayı.
* $P$, $C$: ağacın əlaqələrini izah edən $N$ uzunluqlu massivlər.
* Bu prosedur $N$ uzunluqlu $b$ massivini qaytarmalıdır.
   $0 \le r \lt N$ şərtini ödəyən bütün $r$'lər üçün əgər $T(r)$ gözəl altağac olarsa $b[r] = 1$, əks halda $b[r] = 0$ olmalıdır.
* Hər test üçün bu prosedur tam olaraq bir dəfə çağırılır.

## Nümunələr

### Nümunə 1

Aşağıdakı çağırışa nəzər yetirin:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

Ağac aşağıdakı şəkildə göstərilib:

![Tree](beechtree-ex1.png "350") 

$T(1)$, $T(2)$, və $T(3)$ hər biri yalnızca bir düyün nöqtəsindən ibarətdir, ona görə də gözəldirlər. 
$T(0)$ gözəl deyil.
Buna görə də prosedur $[0, 1, 1, 1]$ qaytarmalıdır.

### Nümunə 2

Aşağıdakı çağırışa nəzər yetirin:

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

Bu nümunə tapşırığın şərtində yuxarıda göstərilib.

Bu prosedur $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$ qaytarmalıdır.

### Nümunə 3

Aşağıdakı çağırışa nəzər yetirin:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

Bu nümunə aşağıdakı şəkildə göstərilib.

![Tree](beechtree-ex3.png "400") 

$T(0)$ gözəl olmayan yeganə altağacdır.
Prosedur $[0, 1, 1, 1, 1, 1, 1]$ qaytarmalıdır.


## Məhdudiyyətlər

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[i] \lt i$ ($1 \le i \lt N$ şərtini ödəyən hər $i$ üçün)
* $1 \le C[i] \le M$ ($1 \le i \lt N$ şərtini ödəyən hər $i$ üçün)
* $P[0] = -1$ və $C[0] = 0$

## Alt tapşırıqlar

1. (9 bal) $N \le 8$ və $M \le 500$
2. (5 bal) $i$ əlaqəsi $i$ və $i-1$ düyün nöqtələrini bir birinə qoşur. Yəni $1 \le i \lt N$ şərtini ödəyən hər $i$ üçün $P[i] = i-1$.
3. (9 bal) $0$ xaric hər bir düyün nöqtəsi ya $0$ nöqtəsinə, ya da $0$'a qoşulmuş hansısa nöqtəyə qoşulub. Yəni $1 \le i \lt N$ şərtini ödəyən hər $i$ üçün ya $P[i]=0$ ya da $P[P[i]]=0$.
4. (8 bal) $1 \le c \le M$ şərtini ödəyən hər $c$ üçün $c$ rəngində ən çox 2 əlaqə var.
5. (14 bal) $N \le 200$ və $M \le 500$
6. (14 bal) $N \le 2\,000$ və $M = 2$
7. (12 bal) $N \le 2\,000$
8. (17 bal) $M = 2$
9. (12 bal) Əlavə məhdudiyyət yoxdur.

## Nümunə Qreyder

Nümunə qreyder giriş verilənlərini aşağıdakı formada oxuyur:

* sətir $1$: $N \; M$
* sətir $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* sətir $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

$b[0], \; b[1], \; \ldots$ ədədləri `beechtree` tərəfindən qaytarılan massiv olsun.
Nümunə qreyder sizin cavabınızı çıxışa aşağıdakı formada verir:
* sətir $1$: $b[0] \; b[1] \; \ldots$