# Δένδρο Οξιάς (Beech Tree)

Το Vétyem Woods είναι ένα ξακουστό δάσος με πολλά πολύχρωμα δέντρα.
Ένα απο τα παλαιότερα και ψηλότερα δέντρα οξιάς ονομάζεται Ős Vezér.

Το δένδρο Ős Vezér μπορεί να περιγραφεί σαν ένα σύνολο από $N$ **κόμβους** και $N-1$ **ακμές**.
Οι κόμβοι αριθμούνται από $0$ έως $N-1$ και οι ακμές απο $1$ έως $N-1$.
Κάθε ακμή ενώνει δύο διαφορετικούς κόμβους του δένδρου.
Πιο συγκεκριμένα, η ακμή $i$ ($1 \le i \lt N$) συνδέει τον κόμβο $i$ με τον $P[i]$, όπου  $0 \le P[i] \lt i$. Ο κόμβος $P[i]$ ονομάζεται **γονιός (parent)** του κόμβου $i$, και ο κόμβος $i$ ονομάζεται **παιδί (child)** του $P[i]$.

Κάθε ακμή έχει ένα χρώμα. Υπάρχουν $M$ πιθανά χρώματα αριθμημένα από $1$ έως $M$.
Το χρώμα της ακμής $i$ είναι $C[i]$.
Διαφορετικές ακμές μπορεί να έχουν το ίδιο χρώμα.

Παρατηρήστε ότι με τους παραπάνω ορισμούς, η ακμή $i = 0$ δεν υπάρχει. Για λόγους απλότητας, θέτουμε $P[0] = -1$ και $C[0] = 0$.

Για παράδειγμα, υποθέστε ότι το Ős Vezér έχει $N = 18$ κόμβους και $M = 3$ πιθανά χρώματα ακμών, με $17$ ακμές που περιγράφονται με τις συνδέσεις $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ και τα χρώματα $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$. Το δένδρο εμφανίζεται στην παρακάτω εικόνα:

![Tree](beechtree-tree.png "550")

Ο Árpád είναι ένας ταλαντούχος δασολόγος που του αρέσει να παρατηρεί συγκεκριμένα τμήματα του δένδρου που ονομάζονται **υπόδεντρα (subtrees)**.
Για κάθε $r$ τέτοιο ώστε $0 \le r \lt N$, το υπόδενδρο του κόμβου  $r$ είναι το σύνολο $T(r)$ κόμβων με τις ακόλουθες ιδιότητες:
* Ο κόμβος $r$ περιέχεται στο $T(r)$.
* Αν ένας κόμβος $x$ περιέχεται στο $T(r)$, τότε όλα τα παιδιά του $x$ περιέχονται και αυτά στο $T(r)$.
* Δεν περιέχονται άλλοι κόμβοι στο $T(r)$.

Το μέγεθος του συνόλου $T(r)$ συμβολίζεται ως $|T(r)|$.

Ο Árpád πρόσφατα ανακάλυψε μια σύνθετη αλλά ενδιαφέρουσα ιδιότητα των υπόδεντρων. Η ανακάλυψη του Árpád's περιλάμβανε εκτεταμένη ενασχόληση με μολύβι και χαρτί, και υποψιάζεται ότι μάλλον **θα χρειαστεί να κάνεις και εσύ το ίδιο για να το καταλάβεις**. Θα σου παρουσιάσει επίσης, πολλά παραδείγματα ώστε να μπορείς **να τα αναλύσεις με λεπτομέρεια**.

Ας υποθέσουμε ότι έχουμε ένα συγκεκριμένο $r$ και μια μετάθεση (permutation) $v_0, v_1, \ldots, v_{|T(r)|-1}$ των κόμβων του υπόδενδρου $T(r)$.

Για κάθε $i$ τέτοιο ώστε $1 \le i \lt |T(r)|$, ας ορίσουμε ως $f(i)$ το πλήθος που συναντάμε το χρώμα $C[v_i]$ στο σύνολο των $i-1$ χρωμάτων: $C[v_1], C[v_2], \ldots, C[v_{i-1}]$. 

(Σημειώστε ότι το $f(1)$ είναι πάντα $0$ διότι το σύνολο των χρωμάτων όπως ορίζεται θα είναι κενό).

Το permutation $v_0, v_1, \ldots, v_{|T(r)|-1}$ είναι ένα **όμορφο permutation** αν και μόνο αν όλες οι παρακάτω ιδιότητες ισχύουν:
* $v_0 = r$.
* Για κάθε $i$ τέτοιο ώστε $1 \le i \lt |T(r)|$, ο γονιός του κόμβου $v_i$ είναι ο κόμβος $v_{f(i)}$.

Για κάθε $r$ τέτοιο ώστε $0 \le r \lt N$, το υπόδενδρο $T(r)$ είναι ένα **όμορφο υπόδενδρο** αν και μόνο αν υπάρχει ένα όμορφο permutation των κόμβων του $T(r)$. Παρατηρήστε ότι σύμφωνα με τον ορισμό, κάθε υπόδενδρο που αποτελείται από ένα μόνο κόμβο, είναι όμορφο.

Σκεφτείτε το παραπάνω δένδρο.
Μπορεί να δειχθεί ότι τα υπόδενδρα $T(0)$ και $T(3)$ του δένδρου δεν είναι όμορφα.
Το υπόδενδρο $T(14)$ είναι όμορφο, καθώς περιέχει μόνο έναν κόμβο.
Ακολούθως, θα δούμε γιατί το υπόδενδρο $T(1)$ είναι επίσης όμορφο.

Έστω ακολουθία διακριτών (distinct) ακεραίων $[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$. Η ακολουθία αυτή είναι ένα permutation των κόμβων του $T(1)$. Η παρακάτω εικόνα απεικονίζει το permutation αυτό. Οι ετικέτες που προστέθηκαν στους κόμβους είναι οι θέσεις στις οποίες οι κόμβοι αυτοί εμφανίζονται στο permutation.

![Tree](beechtree-label1.png "500")

Είναι φανερό ότι η παραπάνω ακολουθία είναι ένα permutation των κόμβων του $T(1)$. Θα επαληθεύσουμε ότι το υπόδενδρο είναι *όμορφο*.

* $v_0 = 1$.
* Το $f(1) = 0$ εφόσον το $C[v_1] = C[4] = 1$ εμφανίζεται $0$ φορές στο σύνολο $[]$.
  * Αντίστοιχα, ο γονιός του $v_1$ είναι ο $v_0$. Αυτό σημαίνει ότι ο γονιός του κόμβου $4$ είναι ο κόμβος $1$. ( $P[4] = 1$.)
* Το $f(2) = 0$ εφόσον το $C[v_2] = C[5] = 2$ εμφανίζεται $0$ φορές στο σύνολο $[1]$.
  * Αντίστοιχα, ο γονιός του $v_2$ είναι ο $v_0$. Αυτό σημαίνει ότι ο γονιός του $5$ είναι ο $1$.
* Το $f(3) = 1$ εφόσον το $C[v_3] = C[12] = 1$ εμφανίζεται $1$ φορά στο σύνολο $[1, 2]$.
  * Αντίστοιχα, ο γονιός του $v_3$ είναι ο $v_1$. Αυτό σημαίνει ότι ο γονιός του $12$ είναι ο $4$.
* Το $f(4) = 1$ εφόσον το $C[v_4] = C[13] = 2$ εμφανίζεται $1$  φορά στο σύνολο $[1, 2, 1]$.
  * Αντίστοιχα, ο γονιός του  $v_4$ είναι $v_1$. Αυτό σημαίνει ότι ο γονιός του $13$ είναι $4$.
* $f(5) = 0$ εφόσον $C[v_5] = C[6] = 3$ εμφανίζεται $0$ φορές στο σύνολο $[1, 2, 1, 2]$.
  * Αντίστοιχα, ο γονιός του  $v_5$ είναι $v_0$. Αυτό σημαίνει ότι ο γονιός του $6$ είναι $1$.
* $f(6) = 2$ εφόσον $C[v_6] = C[14] = 2$ εμφανίζεται $2$  φορές στο σύνολο $[1, 2, 1, 2, 3]$.
  * Αντίστοιχα, ο γονιός του  $v_6$ είναι $v_2$. Αυτό σημαίνει ότι ο γονιός του $14$ είναι $5$.

Εφόσον βρήκαμε ένα όμορφο permutation των κόμβων του $T(1)$, το υπόδενδρο $T(1)$ είναι πράγματι όμορφο.

Βοηθήστε τον Árpád να αποφασίσει για κάθε υπόδενδρο του Ős Vezér, αν το υπόδενδρο είναι όμορφο.

## Λεπτομέρειες Υλοποίησης

Θα πρέπει να υλοποιήσετε την επόμενη συνάρτηση

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: ο αριθμός των κόμβων του δέντρου.
* $M$: ο αριθμός των πιθανών χρωμάτων των ακμών.
* $P$, $C$: πίνακες μήκους $N$ που περιγράφουν τις ακμές του δέντρου.
* Η συνάρτηση επιστρέφει έναν πίνακα $b$ μήκους $N$.
Για κάθε $r$ έτσι ώστε $0 \le r \lt N$, το $b[r]$ θα πρέπει να είναι $1$ αν το $T(r)$ είναι όμορφο και $0$ διαφορετικά.
* Η συνάρτηση καλείται ακριβώς μία φορά για κάθε test case.

## Παραδείγματα

### Παράδειγμα 1

Σκεφτείτε την ακόλουθη κλήση:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

Το δέντρο παρουσιάζεται στο ακόλουθο σχήμα:

![Tree](beechtree-ex1.png "350")

Τα $T(1)$, $T(2)$, και $T(3)$ αποτελούνται από έναν μόνο κόμβο και επομένως είναι όμορφα.
Το $T(0)$ δεν είναι όμορφο.
Έτσι, η συνάερτηση θα επιστρέψει $[0, 1, 1, 1]$.

### Παράδειγμα 2

Σκεφτείτε την ακόλουθη κλήση:

```
beechtree(18, 3,
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

Το παράδειγμα αυτό απεικονίζεται στην περιγραφή προηγουμένως.

Η συνάρτηση θα επιστρέψει $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$.

### Παράδειγμα 3

Σκεφτείτε την ακόλουθη κλήση:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

Αυτό το παράδειγμα απεικονίζεται στο ακόλουθο σχήμα.

![Tree](beechtree-ex3.png "400")

Το $T(0)$ είναι το μόνο υποδέντρο που δεν είναι όμορφο.<br>
Η συνάρτηση θα επιστρέψει $[0, 1, 1, 1, 1, 1, 1]$.


## Περιορισμοί

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[v] \lt v$ (για κάθε $v$ έτσι ώστε $1 \le v \lt N$)
* $1 \le C[v] \le M$ (για κάθε $v$ έτσι ώστε $1 \le v \lt N$)
* $P[0] = -1$ και $C[0] = 0$


## Υποπροβλήματα

1. (9 βαθμοί) $N \le 8$ και $M \le 500$
1. (5 βαθμοί) Η ακμή $v$ συνδέει τον κόμβο $v$ με τον κόμβο $v-1$. Δηλαδή, για κάθε $v$ έτσι ώστε $1 \le v \lt N$, $P[v] = v-1$.
1. (9 βαθμοί) Κάθε κόμβος εκτός από τον κόμβο $0$ είτε συνδέεται με τον κόμβο $0$, είτε συνδέεται με έναν κόμβο που συνδέεται με τον κόμβο $0$.
Δηλαδή, για κάθε $vi$ έτσι ώστε  $1 \le vi \lt N$, είτε $P[vi]=0$  είτε $P[P[vi]]=0$.
1. (8 βαθμοί) Για κάθε $c$ έτσι ώστε $1 \le c \le M$, υπάρχουν το πολύ δύο ακμές χρώματος $c$.
1. (14 βαθμοί) $N \le 200$ και $M \le 500$
1. (14 βαθμοί) $N \le 2\,000$ και $M = 2$
1. (12 βαθμοί) $N \le 2\,000$
1. (17 βαθμοί) $M = 2$
1. (12 βαθμοί) Χωρίς άλλους περιορισμούς.

## Δειγματικός Grader

Ο δειγματικός Grader διαβάζει την είσοδο με την ακόλουθη μορφή:

* γραμμή $1$: $N \; M$
* γραμμή $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* γραμμή $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

Έστω $b[0], \; b[1], \; \ldots$ που υποδηλώνουν τα στοιχεία του πίνακα που επιστρέφει η `beechtree`.<br>
Ο δειγματικός Grader εκτυπώνει την απάντησή σε μία μόνο γραμμή, με την ακόλουθη μορφή:
* γραμμή $1$: $b[0] \; b[1] \; \ldots$