# Pöögipuu

Vétyemi mets on kuulus oma mitmesuguste puude poolest.
Ős Vezér on selle metsa üks vanemaid ja kõrgemaid pöögipuid.

Ős Vezérit võib vaadelda $N$ **tipust** ja $N-1$ **servast** koosneva süsteemina,
kus tipud on nummerdatud $0$ kuni $N-1$ ja servad $1$ kuni $N-1$.
Iga serv ühendab kaht erinevat tippu.
Täpsemalt ühendab serv $i$ (kus $1 \le i \lt N$) tippe $i$ ja $P[i]$, kus $0 \le P[i] \lt i$.
Tippu $P[i]$ nimetame tipu $i$ **ülemuseks** ja tippu $i$ tipu $P[i]$ **alluvaks**.

Iga serv on mingit värvi. Kokku on $M$ värvi, mis on nummerdatud $1$ kuni $M$.
Serva $i$ värv on $C[i]$ ja võib juhtuda, et mitu serva on sama värvi.

Pane tähele, et eelnevate definitsioonide kohaselt ei ole puus serva $i = 0$.
Mugavuse huvides loeme, et $P[0] = -1$ ja $C[0] = 0$.

Oletame näiteks, et Ős Vezéril on $N = 18$ tippu ja $M = 3$ võimalikku servavärvi. Lisaks olgu selle $17$ serva ühendused $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ ja värvid $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$. Seega on Ős Vezér järgmine:

![Tree](beechtree-tree.png "550")

Árpád on andekas metsavaht, kellele meeldib uurida puu osi, mida nimetatakse **alampuudeks**.
Iga $0 \le r \lt N$ korral on tipu $r$ alampuu tippude hulk $T(r)$, mille defineerime järgmiselt:
* Tipp $r$ kuulub hulka $T(r)$.
* Kui tipp $x$ kuulub hulka $T(r)$, siis kuuluvad hulka $T(r)$ ka kõik tipu $x$ alluvad.
* Muid tippe hulka $T(r)$ ei kuulu.

Hulga $T(r)$ elementide arvu tähistatakse $|T(r)|$.

Árpád avastas hiljuti alampuudel keerulise, aga huvitava omaduse.
Selle omaduse avastamiseks pidi Árpád päris palju puid paberile joonistama ja võib juhtuda, et sul tuleb selle omaduse mõistmiseks sama teha. Lisaks annab ta sulle analüüsimiseks mõned näited.

Olgu meil fikseeritud mingi $r$ ja alampuu $T(r)$ tippude mingi permutatsioon $[v_0, v_1, \ldots, v_{|T(r)|-1}]$.

Olgu iga $1 \le i \lt |T(r)|$ korral $f(i)$ värvi $C[v_i]$ esinemiste arv $i-1$ elemendiga jadas $C[v_1], C[v_2], \ldots, C[v_{i-1}]$.

(Pane tähele, et $f(1)$ on alati $0$, sest selle definitsioonis olev värvide jada on tühi.)

Permutatsioon $[v_0, v_1, \ldots, v_{|T(r)|-1}]$ on **eriline permutatsioon** siis ja ainult siis, kui
* $v_0 = r$ ja
* iga $1 \le i \lt |T(r)|$ korral on tipu $v_i$ ülemus tipp $v_{f(i)}$.

Iga $0 \le r \lt N$ korral ütleme, et $T(r)$ on **eriline alampuu** siis ja ainult siis, kui leidub $T(r)$ tippude eriline permutatsioon. Pane tähele, et eelneva definitsiooni kohaselt on iga ühest tipust koosnev alampuu eriline.

Vaatleme uuesti eelpool näitena toodud puud.
Saab näidata, et selle alampuud $T(0)$ ja $T(3)$ ei ole erilised.
Alampuu $T(14)$ on eriline, sest see koosneb ainult ühest tipust.
Järgmiseks näitame, et alampuu $T(1)$ on ka eriline.

Selleks vaatleme paarikaupa erinevate täisarvude jada $[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$.
See on alampuu $T(1)$ tippude permutatsioon.
See permutatsioon on kujutatud ka järgneval joonisel, kus iga tipu juures oleval sildil on selle tipu indeks jadas.

![Tree](beechtree-label1.png "500")

Eeltoodud jada on ilmselt $T(1)$ tippude permutatsioon. Kontrollime nüüd, et see on *eriline*:
* $v_0 = 1$.
* $f(1) = 0$, sest $C[v_1] = C[4] = 1$ esinemiste arv jadas $[]$ on $0$.
 * Sellele vastavalt on tipu $v_1$ ülemus tipp $v_0$ (s.t tipu $4$ ülemus on tipp $1$, ehk formaalsemalt $P[4] = 1$).
* $f(2) = 0$, sest $C[v_2] = C[5] = 2$ esinemiste arv jadas $[1]$ on $0$.
 * Sellele vastavalt on tipu $v_2$ ülemus tipp $v_0$ (s.t tipu $5$ ülemus on tipp $1$).
* $f(3) = 1$, sest $C[v_3] = C[12] = 1$ esinemiste arv jadas $[1, 2]$ on $1$.
 * Sellele vastavalt on tipu $v_3$ ülemus tipp $v_1$ (s.t tipu $12$ ülemus on tipp $4$).
* $f(4) = 1$, sest $C[v_4] = C[13] = 2$ esinemiste arv jadas $[1, 2, 1]$ on $1$.
 * Sellele vastavalt on tipu $v_4$ ülemus tipp $v_1$ (s.t tipu $13$ ülemus on tipp $4$).
* $f(5) = 0$, sest $C[v_5] = C[6] = 3$ esinemiste arv jadas $[1, 2, 1, 2]$ on $0$.
 * Sellele vastavalt on tipu $v_5$ ülemus tipp $v_0$ (s.t tipu $6$ ülemus on tipp $1$).
* $f(6) = 2$, sest $C[v_6] = C[14] = 2$ esinemiste arv jadas $[1, 2, 1, 2, 3]$ on $2$.
 * Sellele vastavalt on tipu $v_6$ ülemus tipp $v_2$ (s.t tipu $14$ ülemus on tipp $5$).

Kuna me leidsime $T(1)$ tippude erilise permutatsiooni, on ka alampuu $T(1)$ eriline.

Sinu ülesanne on aidata Árpádil otsustada Ős Vezéri iga alampuu kohta, kas see on eriline või mitte.

## Realisatsioon

Lahendusena tuleb realiseerida funktsioon

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: puu tippude arv.
* $M$: puu servade võimalike värvide arv.
* $P$, $C$: $N$ elemendiga massiivid, puu servade kirjeldused.
* Funktsioon peab tagastama $N$ elemendiga massiivi $b$.
  Iga $0 \le r \lt N$ korral peab $b[r]$ olema $1$, kui $T(r)$ on eriline, ja $0$, kui ei ole.
* Seda funktsiooni käivitatakse igas testis täpselt üks kord.

## Näited

### Näide 1

Vaatleme väljakutset

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

Sellele vastab puu

![Tree](beechtree-ex1.png "350")

$T(1)$, $T(2)$ ja $T(3)$ koosnevad igaüks ühest tipust ja on seega erilised.
$T(0)$ ei ole eriline.
Seega peab funktsioon tagastama $[0, 1, 1, 1]$.

### Näide 2

Vaatleme väljakutset

```
beechtree(18, 3,
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

Sellele vastab ülesande tekstis näitena toodud puu.

Sel juhul peab funktsioon tagastama $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$.

### Näide 3

Vaatleme väljakutset

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

Sellele vastab puu

![Tree](beechtree-ex3.png "400")

$T(0)$ on ainus alampuu, mis pole eriline.
Seega peab funktsioon tagastama $[0, 1, 1, 1, 1, 1, 1]$.

## Piirangud

* $3 \le N \le 200\,000$.
* $2 \le M \le 200\,000$.
* $0 \le P[i] \lt i$ iga $1 \le i \lt N$ korral.
* $1 \le C[i] \le M$ iga $1 \le i \lt N$ korral.
* $P[0] = -1$ ja $C[0] = 0$.

## Alamülesanded

1. (9 punkti) $N \le 8$ ja $M \le 500$.
1. (5 punkti) Iga serv $i$ ühendab tippe $i$ ja $i-1$. Teisisõnu, iga $1 \le i \lt N$ korral $P[i] = i-1$.
1. (9 punkti) Iga tipp peale tipu $0$ on ühendatud kas tipuga $0$ või mingi tipuga, mis on omakorda ühendatud tipuga $0$.
  Teisisõnu, iga $1 \le i \lt N$ korral kehtib kas $P[i]=0$ või $P[P[i]]=0$.
1. (8 punkti) Iga $1 \le c \le M$ korral on maksimaalselt kaks serva, mille värv on $c$.
1. (14 punkti) $N \le 200$ ja $M \le 500$.
1. (14 punkti) $N \le 2\,000$ ja $M = 2$.
1. (12 punkti) $N \le 2\,000$.
1. (17 punkti) $M = 2$.
1. (12 punkti) Lisapiirangud puuduvad.

## Hindamisprogramm

Arhiivis olev hindamisprogramm loeb sisendi järgmises vormingus:

* rida $1$: $N \; M$
* rida $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* rida $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

Hindamisprogramm väljastab vastuse järgmises vormingus:

* rida $1$: $b[0] \; b[1] \; \ldots$

kus $b[0], \; b[1], \; \ldots$ on funktsiooni `beechtree` tagastatud massiivi elemendid.
