# წიფლის ხე

"Vétyem Woods" არის ცნობილი ტყე, რომელშიც იზრდება უამრავი სხვადასხვა ფერის ხე.   ყველაზე ძველი და მაღალი ხის სახელია "Ős Vezér".

ხე Ős Vezér შეიძლება წარმოვიდგინოთ როგორც სიმრავლე, რომელიც შედგება $N$ **წვეროსგან** და  $N-1$ **წიბოსაგან**. წვეროები გადანომრილია $0$-დან  $(N-1)$-მდე,
ხოლო წიბოები -  $1$-დან $(N-1)$-მდე. ყოველი წიბო აკავშირებს ხის ორ განსხვავებულ წვეროს. კერძოდ, წიბო $v$ ($1 \le v \lt N$) აკავშირებს $v$ და  $P[v]$ წვეროებს, სადაც  $0 \le P[v] \lt v$.

ყოველ წიბოს აქვს ფერი. არსებობს წიბოების  $M$ შესაძლო ფერი, გადანომრილი $1$-დან  $M$ -მდე. $v$ წიბოს ფერი არის  $C[v]$. განსხვავებულ წიბოებს შესაძლოა ჰქონდეს ერთი და იგივე ფერი.

ზემოთ მოცემულ განსაზღვრებაში მნიშვნელობა $v = 0$ არ შეესაბამება წიბოს. ამიტომ, მოხერხებულობისათვის ვთვლით, რომ  $P[0] = -1$ და $C[0] = 0$.

მაგალითად, დავუშვათ Ős Vezér ხეს აქვს $N = 18$ წვერო, $M = 3$ წიბოთა შესაძლო ფერების რაოდენობა და $17$ წიბო აღწერილი შემდეგი შეერთებებით $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ და ფერებით $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$. 
ხე ასახულია შემდეგ სურათზე:

![Tree](beechtree-tree.png "550")

არპადი ნიჭიერი მეტყევეა. ის შეისწავლის ხის ნაწილებს, რომლებსაც **ქვეხეები** ეწოდებათ. მისმა აღმოჩენამ მოითხოვა უამრავი მუშაობა და ნახაზების გაკეთება ფურცელზე. არპადი გირჩევთ, რომ იგივე გააკეთოთ თქვენც.
ასევე დეტალური ანალიზისთვის მას აქვს მოყვანილი რამდენიმე მაგალითი.

ყოველი $r$-სათვის, სადაც $0 \le r \lt N$,  $r$ წვეროს ქვეხე (რომელიც ავღნიშნოთ $T(r)$-ით) წარმოადგენს წვეროების სიმრავლეს.
წვერო $s$ არის  $T(r)$ სიმრავლის წევრი მაშინ და მხოლოდ მაშინ, თუ:
* $s$ = $r$
* თუ წვერო $x$ ეკუთნის სიმრავლეს $T(r)$, მაშინ მისი ყველა შვილი ასევე ეკუთნის ამ $T(r)$ სიმრავლეს და, ასევე, არც ერთი სხვა წვერო არ ეკუთნის  $T(r)$ სიმრავლეს.

$T(r)$ სიმრავლის ზომა აღვნიშნოთ $|T(r)|$-ით.

არპადმა აღმოაჩინა ქვეხის საინტერესო თვისება.
ყოველი $r$-სათვის, სადაც $0 \le r \lt N$, ქვეხე $T(r)$-ს ვუწოდოთ **ლამაზი** მაშინ და მხოლოდ მაშინ, თუ არსებობს  *განსხვავებული მთელი*  რიცხვების ისეთი $[v_0, v_1, \ldots, v_{|T(r)|-1}]$ მიმდევრობა, რომ:
* ყოველი $i$-სათვის, სადაც $0 \le i \lt |T(r)|$, წვერო $v_i$ არის $T(r)$ ქვეხის წევრი.
* $v_0 = r$.
* ყოველი $i$-სათვის, სადაც $1 \le i \lt |T(r)|$, $P[v_i] = v_{f(i)}$ და $f(i)$ არის რაოდენობა, რამდენჯერაც $C[v_i]$ ფერი გვხდება $[C[v_1], C[v_2], \ldots, C[v_{i-1}]]$ მიმდევრობაში.

აღვნიშნოთ, რომ განსაზღვრის თანახმად:
* ყველა ქვეხე, რომელიც მოიცავს მხოლოდ ერთ წვეროს, ლამაზია.
* ნებისმიერი ქვეხისთვის, რომელიც მოიცავს ორ ან მეტ წვეროს, შესრუდება $f(1) = 0$, რადგან მივიღებთ ფერების ცარიელ სიმრავლეს.

განვიხილოთ ზემოთ მოცემული ხე.
ამ ხის ქვეხეები $T(0)$ და $T(3)$ არ არიან ლამაზები.
ქვეხე $T(14)$ ლამაზია, რადგან მოიცავს მხოლოდ ერთ წვეროს.
ქვემოთ დავასაბუთებთ, რომ ქვეხე $T(1)$ ასევე ლამაზია.

განვიხილოთ განსხვავებული მთელი რიცხვების მიმდევრობა:
$[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$.

ეს მიმდევრობა წარმოდგენილია შემდეგ ნახაზზე.
ამ მიმდევრობაში ყველა წვეროს ინდექსი ნაჩვენებია წვეროზე მიბმული ჭდის სახით.

![Tree](beechtree-label1.png "500")

ზემოთ მოყვანილი მთელი რიცხვების მიმდევრობა გვიჩვენებს, რომ $T(1)$ არის ლამაზი:
* $v_0 = r = 1$.
* $f(1) = 0$, რადგან $C[v_1] = C[4] = 1$ გვხდება $0$-ჯერ მიმდევრობაში $[]$, ასევე $P[v_1] = P[4] = 1 = v_0$.
* $f(2) = 0$, რადგან $C[v_2] = C[5] = 2$ გვხდება $0$-ჯერ მიმდევრობაში $[1]$, ასევე $P[v_2] = P[5] = 1 = v_0$.
* $f(3) = 1$, რადგან $C[v_3] = C[12] = 1$ გვხდება $1$-ჯერ მიმდევრობაში $[1, 2]$, ასევე $P[v_3] = P[12] = 4 = v_1$.
* $f(4) = 1$, რადგან $C[v_4] = C[13] = 2$ გვხვდება $1$-ჯერ მიმდევრობაში $[1, 2, 1]$, ასევე $P[v_4] = P[13] = 4 = v_1$.
* $f(5) = 0$, რადგან $C[v_5] = C[6] = 3$ გვხდება $0$-ჯერ მიმდევრობაში $[1, 2, 1, 2]$, ასევე $P[v_5] = P[6] = 1 = v_0$.
* $f(6) = 2$, რადგან $C[v_6] = C[14] = 2$ გვხდება $2$-ჯერ მიმდევრობაში $[1, 2, 1, 2, 3]$, ასევე $P[v_6] = P[14] = 5 = v_2$.

თქვენი დავალებაა დაეხმაროთ არპადს ყველა ქვეხისთვის გადაწყვიტოს, არის თუ არა ის ლამაზი.

## იმპლემენტაციის დეტალები

თქვენ უნდა მოახდინოთ შემდეგი პროცედურის იმპლემენტაცია.

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: ხეში წვეროების რაოდენობა.
* $M$: რკალების ფერების შესაძლო რაოდენობა.
* $P$, $C$: მასივი სიგრძით $N$, რომელიც აღწერს ხის რკალებს.
* ამ პროცედურამ უნდა დააბრუნოს მასივი $b$ სიგრძით $N$. 
  ყველა $r$-ისთვის, სადაც $0 \le r \lt N$, $b[r]$ უნდა იყოს $1$, თუ $T(r)$ არის ლამაზი, ხოლო $0$ წინააღმდეგ შემთხვევაში.
* ყველა ტესტისთვის ეს პროცედურა იქნება გამოძახებული ზუსტად ერთხელ.

## მაგალითები

### მაგალითი 1

განვიხილოთ შემდეგი გამოძახება:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

ხე ასახულია შემდეგ ნახატზე:

![Tree](beechtree-ex1.png "350")

$T(1)$, $T(2)$ და $T(3)$ ყველა მოიცავს მხოლოდ ერთ წვეროს და ამიტომ ლამაზებია.
$T(0)$ არ არის ლამაზი.
ამიტომ პროცედურამ უნდა დააბრუნოს $[0, 1, 1, 1]$.

### მაგალითი 2

განვიხილოთ შემდეგი გამოძახება:

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

ეს მაგალითი განხილულია ზემოთ, ამოცანის პირობაში.

პროცედურამ უნდა დააბრუნოს $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$.

### მაგალითი 3

განვიხილოთ შემდეგი გამოძახება:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

მაგალითის ილუსტრაცია მოყვანილია შემდეგ ნახაზზე.

![Tree](beechtree-ex3.png "400")

$T(0)$ ერთადერთი ქვეხეა, რომელიც არ არის ლამაზი.
პროცედურამ უნდა დააბრუნოს $[0, 1, 1, 1, 1, 1, 1]$.


## შეზღუდვები

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[v] \lt v$ (ყველა $v$-სათვის, სადაც $1 \le v \lt N$)
* $1 \le C[v] \le M$ (ყველა $v$-სათვის, სადაც  $1 \le v \lt N$)
* $P[0] = -1$ და $C[0] = 0$

## ქვეამოცანები

1. (9 ქულა) $N \le 8$ და $M \le 500$.
1. (5 ქულა) $v$ წიბო აკავშირებს $v$ წვეროს $v-1$ წვეროსთან. ესე იგი, ყველა $v$-სათვის , სადაც $1 \le v \lt N$, $P[v] = v-1$.
1. (9 ქულა) ყველა წვერო $0$-ის გარდა, დაკავშირებულია ან წვეროსთან $0$, ან $0$-თან დაკავშირებულ წვეროსთან.
  ეს ნიშნავს, რომ ყველა $v$-სათვის, სადაც  $1 \le v \lt N$, სრულდება ან $P[v]=0$, ან $P[P[v]]=0$.
1. (8 ქულა) ყველა $c$-სათვის, სადაც $1 \le c \le M$, არსებობს $c$ ფერის მაქსიმუმ ორი წიბო.
1. (14 ქულა) $N \le 200$ და $M \le 500$.
1. (14 ქულა) $N \le 2\,000$ და $M = 2$.
1. (12 ქულა) $N \le 2\,000$.
1. (17 ქულა) $M = 2$.
1. (12 ქულა) დამატებითი შეზღუდვების გარეშე.

## სანიმუშო გრადერი

სანიმუშო გრადერი კითხულობს მონაცემებს შემდეგი ფორმატით:

* სტრიქონი $1$: $N \; M$
* სტრიქონი $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* სტრიქონი $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

დავუშვათ $b[0], \; b[1], \; \ldots$ წარმოადგენენ მასივის ელემენტებს, რომლებიც დააბრუნა პროცედურამ `beechtree`.
სანიმუშო გრადერი ბეჭდავს თქვენს პასუხს ერთ სტრიქონში ფორმატით:
* სტრიქონი $1$: $b[0] \; b[1] \; \ldots$
