# Stablo bukve
Medvednica je ukrašena predivnom šumom s mnoštvom šarolikog drveća.
Jedno od najstarijih i najviših stabala bukve naziva se **DODO**.

Dodo se može prikazati kao skupo od $N$ **čvorova** i $N - 1$ **bridova**.
Čvorovi su označeni do $0$ do $N - 1$ i bridovi od $1$ do $N - 1$.
Svaki brid spaja dva različita čvora u stablu.
Točnije, brid $i$ ($1 \le i \lt N$) spaja čvor $i$ s čvorom $P[i]$ gdje je $0 \le P[i] \lt i$. Čvor $P[i]$ naziva se **roditeljem** čvora $i$, a čvor $i$ naziva se **djetetom** čvora $P[i]$.

Svaki brid ima svoju boju. Postoji $M$ mogućih boja bridova označenih brojevima od $1$ do $M$.
Svaki brid $i$ ima svoju boju $C[i]$.
Različiti bridovi mogu biti iste boje.

Primijetite da u gore opisanim definicijama, slučaj $i = 0$ ne opisuje nijedan brid stabla. Stoga, bez smanjenja općenitosti, neka je $P[0] = -1$ te $C[0] = 0$.

Primjerice, neka Dodo stablo ima $N = 18$ čvorova i $M = 3$ mogućih boja bridova, gdje je $17$ bridova opisano roditeljima 
$P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ i bojama $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$.
Opisano stablo prikazano je na sljedećoj slici:

![Tree](beechtree-tree.png "550")

Krešimir je talentirani šumar koji voli proučavati specifične dijelova svoga stabla nazvanih **podstablima**.
Za svaki $r$ takav da je $0 \le r \lt N$, podstablo čvora $r$ je skup čvorova $T(r)$ sa sljedećim svojstvom:
* Čvor $r$ pripada skupu $T(r)$.
* Kadgod čvor $x$ pripada skupu $T(r)$, tada sva djeca od $x$ također pripadaju $T(r)$.
* Nijedan drugi čvor ne pripada skupu $T(r)$.


Veličina skupa $T(r)$ označava se sa $|T(r)|$.

Krešimir je nedavno otkrio zanimljivo svojstvo podstabala. Krešino otrkiće uključivalo je puno igranja s papirom i olovkom, i misli da će tebi trebati kako bi ga shvatio. Također će vam pokazati par primjera kako biste ih mogli detaljno analizrati.

Neka su fiksni broj $r$ i permutacija  $v_0, v_1, \ldots, v_{|T(r)|-1}$ svih čvorova u podstablu $T(r)$.

Za svaki $i$ takav da $1 \le i \lt |T(r)|$, neka je $f(i)$ broj pojavljivanja boje $C[v_i]$ u sljedećem nizu $i - 1$ boja: 
$C[v_1], C[v_2], \ldots, C[v_{i-1}]$. 

(Primijetite da je $f(1)$ uvijek $0$ je niz boja uvijek prazan.)

Permutacija $v_0, v_1, \ldots, v_{|T(r)|-1}$ je **lijepa permutacija** ako i samo ako vrijede sva navedena svojstva:
* $v_0 = r$.
* Za svaki $i$ takav da $1 \le i \lt |T(r)|$, roditelj čvora $v_i$ je $v_{f(i)}$.

Za svaki $r$ takav da $0 \le r \lt N$, podstablo $T(r)$ je **lijepo podstablo** ako i samo ako postoji lijepa permutacija čvorova u $T(r)$. Primijetite da prema gornjoj definiciji, podstablo koje se sastoji od jednog čvora lijepo.

Promatrajte primjerice gore navedeno stablo.
Može se pokazati da podstabla $T(0)$ i $T(3)$ nisu lijepa.
Podstablo $T(14)$ je lijepo, jer se sastoji od jednog čvora.
Ispod, pokazat ćemo da je podstablo $T(1)$ također lijepo.

Promatrajte niz različitih brojeva $[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$. Taj niz je permutacija čvorova
skupa $T(1)$. Donja slika prikazuje navedenu permutaciju. Dopisane oznake su redni brojevi čvorova u permutaciji.

![Tree](beechtree-label1.png "500")

Sad ćemo potvrditi da je to *lijepa permutacija*.

* $v_0 = 1$.
* $f(1) = 0$ jer $C[v_1] = C[4] = 1$ se pojavljuje $0$ puta u nizu $[]$.
  * Stoga, roditelj čvora $v_1$ je $v_0$. Točnije, roditelj čvora $4$ je čvor $1$. (Formalnije, $P[4] = 1$.)
* $f(2) = 0$ jer $C[v_2] = C[5] = 2$ pojavljuje se $0$ puta u nizu $[1]$.
  * Stoga, roditelj čvora  $v_2$ je $v_0$. Točnije, roditelj čvora $5$ je $1$.
* $f(3) = 1$ jer $C[v_3] = C[12] = 1$ pojavljuje se $1$ puta u nizu $[1, 2]$.
  * Stoga, roditelj čvora  $v_3$ je $v_1$. Točnije, roditelj čvora $12$ je $4$.
* $f(4) = 1$ jer $C[v_4] = C[13] = 2$ pojavljuje se $1$ puta u nizu $[1, 2, 1]$.
  * Stoga, roditelj čvora  $v_4$ je $v_1$. Točnije, roditelj čvora $13$ je $4$.
* $f(5) = 0$ jer $C[v_5] = C[6] = 3$ pojavljuje se $0$ puta u nizu $[1, 2, 1, 2]$.
  * Stoga, roditelj čvora  $v_5$ je $v_0$. Točnije, roditelj čvora $6$ je $1$.
* $f(6) = 2$ jer $C[v_6] = C[14] = 2$ pojavljuje se $2$ puta u nizu $[1, 2, 1, 2, 3]$.
  * Stoga, roditelj čvora  $v_6$ je $v_2$. Točnije, roditelj čvora $14$ je $5$.

Jer smo pronašli *lijepu permutaciju* čvorova skupa $T(1)$, podstablo $T(1)$ je *lijepo podstablo*.

Vaš je zadatak pomoći Krešimiru, ordediti za svako podstablo Dode je li lijepo.

## Implementacijski detalji

Morate implementirati sljedeću funkciju.

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: broj čvorova u stablu.
* $M$: broj mogućih boja bridova.
* $P$, $C$: nizovi duljine $N$ koji opisuju bridove stabla.
* Funkcija mora vratiti niz $b$ duljine $N$.
  Za svaki $r$ takav da $0 \le r \lt N$, $b[r]$ mora biti $1$ ako je $T(r)$ lijepo podstablo, i $0$ inače.
* Ova funkcija bit će pozvana točno jednom po primjeru.

## Primjeri

### Prvi primjer

Promatrajte sljedeći poziv funkcije:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

Ovaj primjer ilustriran je na sljedećoj slici.

![Tree](beechtree-ex1.png "350")

$T(1)$, $T(2)$, i $T(3)$ sastoje se od jednog čvora i stoga su lijepi.
$T(0)$ nije lijepo podstablo.
Stoga, funkcija bi trebala vratiti $[0, 1, 1, 1]$.

### Drugi primjer

Promatrajte sljedeći poziv funkcije:

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

Primjer je ilustriran u tekstu zadatka.

Funkcija bi trebala vratiti $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$.

### Treći primjer

Promatrajte sljedeći poziv funkcije:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

Ovaj primjer ilustriran je na sljedećoj slici.

![Tree](beechtree-ex3.png "400")

$T(0)$ je jedino postablo koje nije lijepo.
Funkcija bi trebala vratiti $[0, 1, 1, 1, 1, 1, 1]$.


## Ograničenja

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[i] \lt i$ (za svaki $i$ takav da $1 \le i \lt N$)
* $1 \le C[i] \le M$ (za svaki $i$ takav da $1 \le i \lt N$)
* $P[0] = -1$ i $C[0] = 0$

## Podzadatci

1. (9 bodova) $N \le 8$ i $M \le 500$
1. (5 bodova) Brid $i$ povezuje čvor $i$ s čvorom $i-1$. Točnije, za svaki $i$ takav da $1 \le i \lt N$, vrijedi $P[i] = i-1$.
1. (9 bodova) Za svaki čvor, osim čvora $0$, ili je spojen na čvor $0$, ili je spojen na čvor koji je spojen na čvor $0$.
  Točnije, za svaki $i$ takav da $1 \le i \lt N$, ili $P[i]=0$ ili $P[P[i]]=0$.
1. (8 bodova) Za svaki $c$ takav da $1 \le c \le M$, postoje najviše dva brida boje $c$.
1. (14 bodova) $N \le 200$ i $M \le 500$
1. (14 bodovaz) $N \le 2\,000$ i $M = 2$
1. (12 bodova) $N \le 2\,000$
1. (17 bodova) $M = 2$
1. (12 bodova) Nema dodatnih ograničenja.

## Probni ocjenjivač

Probni ocjenjivač učitava unos u sljedećem obliku.

* $1.$ redak: $N \; M$
* $2.$ redak: $P[0] \; P[1] \; \ldots \; P[N-1]$
* $3.$ redak: $C[0] \; C[1] \; \ldots \; C[N-1]$

Neka $b[0], \; b[1], \; \ldots$ označavaju članove niza koji je vratila funkcija `beechtree`.
Probni ocjenjivač ispisat će Vaš odgovor u jednom retku, u sljedećem formatu
* $1.$ redak: $b[0] \; b[1] \; \ldots$

