# Beech Tree

Vétyem Woods er frægt skóglendi fyllt af litríkum trjám.
Eitt elsta og hæsta beykitréð heitir Ős Vezér.

Tréið Ős Vezér má tákna sem mengi af $N$ **hnútum** og $N-1$ **leggjum**.
Hnútar eru númeraðar frá $0$ upp í $N-1$ og leggirnir eru númeraðir frá $1$ upp í $N-1$.
Sérhver leggur tengir tvo mismunandi hnúta trésins.
Nánar tiltekið, leggur $i$, þar sem $1 \le i \lt N$, tengir hnút $v$ við hnút $P[i]$, þar sem $0 \le P[i] \lt v$.
Hnútur $P[i]$ er sagður vera **beinn undanfari** hnúts $i$ og hnútur $i$ er **beinn eftirfari** hnúts $P[i]$.

Sérhver leggur hefur lit.
Það eru $M$ mögulegir litir á leggjum sem eru númeraðir frá $1$ upp í $M$.
Liturinn á legg $v$ er $C[v]$.
Mismunandi leggir mega hafa sama lit.

Athugaðu að í skilgreiningunum að ofan, þá á tilvikið $v = 0$ ekki við legg í trénu.
Við látum $P[0] = -1$ og $C[0] = 0$ því það er þægilegt.

Til dæmis, segjum að Ős Vezér sé með $N = 18$ hnúta og $M = 3$ mögulega liti fyrir leggina sína.
Þá eru $17$ leggir sem lýsa tengingunum $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ og litunum $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$.
Tréð má sjá á eftirfarandi mynd:

![Tree](beechtree-tree.png "550")

Árpád er hæfileikaríkur skógarmaður sem er áhugasamur um að skoða sérstaka hluta trésins sem kallast **hluttré**.
Fyrir sérhvert $r$ þar sem $0 \le r \lt N$ er hluttré hnúts $r$ mengið $T(r)$ af hnútum með eftirfarandi eiginleika: 
* Hnútur $s$ tilheyrir $T(r)$
* Skyldi hnútur $x$ tilheyra $T(r)$, þá tilheyra allir beinir eftirfarar $x$ einnig $T(r).
* Engir aðrir hnútar tilheyra $T(r)$.

Stærðin á menginu $T(r)$ er táknað með $|T(r)|$.

Árpád uppgötvaði nýlega áhugavert, en flókið einkenni hluttrjáa.
Uppgötvun Arpáds krefst þess að fikta mikið á blaði og með blýant og grunar hann að þú þurfir einnig að gera hið sama til að skilja það. Hann mun sýna þér mörg sýnidæmi sem þú getur þá greint vel.

Segjum að við festum gildið á $r$ og umröðun $v_0, v_1, \ldots, v_{|T(r)|-1}$ af hnútunum í hluttrénu $T(r)$.

Fyrir sérhvert $i$ þar sem $1 \le i \lt |T(r)|$, látum við $f(i)$ vera fjölda skipta sem liturinn $C[v_i]$ hefur komið fyrir í eftirfarandi runu af $i-1$ litum: $C[v_1], C[v_2], \ldots, C[v_{i-1}]$.

Athugaðu að $f(1)$ er ávallt $0$ þar sem litarunan í skilgreiningunni er tóm.

Umröðunin $v_0, v_1, \ldots, v_{|T(r)|-1}$ er sögð vera **falleg umröðun** þá og því aðeins að eftirfarandi gilda:
* $v_0 = r$.
* Fyrir sérhvert $i$ þar sem $1 \le i \lt |T(r)|$ er $v_{f(i)}$ beinn undanfari $v_i$.

Fyrir hvaða $r$ sem er, þar sem $0 \le r \lt N$, þá segjum við að hluttréð $T(r)$ sé **fallegt hluttré** þá og því aðeins að það sé til falleg umröðun af hnútunum í $T(r)$.

Íhugaðu tréð í sýnidæminu að ofan.
Sýna má fram á að hluttrén $T(0)$ og $T(3)$ í þessu tréi séu ekki falleg.
Hluttréð $T(14)$ er fallegt þar sem það samanstendur af einungis einum hnút.
Við munum sýna að hluttréð $T(1)$ sé einnig fallegt að neðan.

Íhugaðu rununa af ólíku heitölunum $[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$.
Runan er umröðun af hnútunum í $T(1)$.
Rununa má tákna með eftirfarandi mynd.
Miðarnir sem hanga á hverjum hnút sýna vísi þeirra í umröðuninni.

![Tree](beechtree-label1.png "500")

Við munum núna staðfesta að þetta sé *falleg umröðun*.

* $v_0 = r = 1$.
* $f(1) = 0$ þar sem $C[v_1] = C[4] = 1$ kemur $0$ sinnum fyrir í rununni $[]$, og $P[v_1] = P[4] = 1 = v_0$.
	* Samsvarandi er $v_0$ beinn undanfari $v_1$. Það er, beinn undanfari hnúts $4$ er hnútur $1$, eða $P[4] = 1$.
* $f(2) = 0$ þar sem $C[v_2] = C[5] = 2$ kemur $0$ sinnum fyrir í rununni $[1]$, og $P[v_2] = P[5] = 1 = v_0$.
	* Samsvarandi er $v_0$ beinn undanfari $v_2$. Það er, beinn undanfari hnúts $5$ er hnútur $1$.
* $f(3) = 1$ þar sem $C[v_3] = C[12] = 1$ kemur $1$ sinni fyrir í rununni $[1, 2]$, og $P[v_3] = P[12] = 4 = v_1$.
  * Samsvarandi er $v_1$ beinn undanfari $v_3$. Það er, beinn undanfari hnúts $12$ er hnútur $4$.
* $f(4) = 1$ þar sem $C[v_4] = C[13] = 2$ kemur $1$ sinni fyrir í rununni $[1, 2, 1]$, og $P[v_4] = P[13] = 4 = v_1$.
	* Samsvarandi er $v_1$ beinn undanfari $v_4$. Það er, beinn undanfari hnúts $13$ er hnútur $4$.
* $f(5) = 0$ þar sem $C[v_5] = C[6] = 3$ kemur $0$ sinnum fyrir í rununni $[1, 2, 1, 2]$, og $P[v_5] = P[6] = 1 = v_0$.
	* Samsvarandi er $v_0$ beinn undanfari $v_5$. Það er, beinn undanfari hnúts $6$ er hnútur $1$.
* $f(6) = 2$ þar sem $C[v_6] = C[14] = 2$ kemur $2$ sinnum fyrir í rununni $[1, 2, 1, 2, 3]$, og $P[v_6] = P[14] = 5 = v_2$.
	* Samsvarandi er $v_2$ beinn undanfari $v_6$. Það er, beinn undanfari hnúts $14$ er hnútur $5$.

Þar sem við gátum fundið *fallega umröðun* af hnútunum í $T(1)$ þá er hluttréð $T(1)$ *fallegt hluttré*.

Verkefnið þitt er að aðstoða Árpád við að ákvarða fyrir sérhvert hluttré Ős Vezér hvort það sé fallegt.

## Útfærsluatriði

Þú skalt útfæra eftirfarandi fall.

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: fjöldi hnúta í trénu.
* $M$: fjöldi mögulegra lita á leggjum.
* $P$, $C$: fylki (í fleirtölu) af stærð $N$ sem lýsa leggjum trésins.
* Þetta fall skal skila fylki $b$ af stærð $N$.
  Fyrir sérhver $r$ þar sem $0 \le r \lt N$ skal $b[r]$ vera $1$ ef $T(r)$ er fallegt, en $0$ annars.
* Kallað er í þetta fall nákvæmlega einu sinni í sérhverju prufutilviki.

## Sýnidæmi

### Sýnidæmi 1

Íhugaðu eftirfarandi kall í fallið:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

Tréð er sýnt á eftirfarandi mynd:

![Tree](beechtree-ex1.png "350")

Hér má sjá að $T(1)$, $T(2)$ og $T(3)$ samanstanda af einungis einum hnút hvert og eru því falleg.
Hins vegar er $T(0)$ ekki fallegt.
Þess vegna skal fallið skila $[0, 1, 1, 1]$.

### Sýnidæmi 2

Íhugaðu eftirfarandi kall í fallið:

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

Þetta sýnidæmi er sýnt í verkefnalýsingunni að ofan.

Fallið skal skila $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$.

### Example 3

Íhugaðu eftirfarandi kall í fallið:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

Þetta sýnidæmi er sýnt á eftirfarandi mynd.

![Tree](beechtree-ex3.png "400")

Hér er $T(0)$ eina hluttréð sem er ekki fallegt.
Fallið skal skila $[0, 1, 1, 1, 1, 1, 1]$.
The procedure should return $[0, 1, 1, 1, 1, 1, 1]$.

## Skorður

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[i] \lt i$, fyrir sérhvert $i$ þar sem $1 \le i \lt N$.
* $1 \le C[i] \le M$, fyrir sérhvert $i$ þar sem $1 \le i \lt N$.
* $P[0] = -1$ og $C[0] = 0$

## Hlutverkefni

1. (9 stig) $N \le 8$ og $M \le 500$
1. (5 stig) Leggur $i$ tengir hnút $v$ við hnút $i-1$. Það er, fyrir sérhvert $i$ þar sem $1 \le i \lt N$, gildir að $P[i] = i-1$.
1. (9 stig) Sérhver hnútur annar en hnútur $0$ er annaðhvort tengdur við hnút $0$ eða er tengdur við hnút sem er tengdur við hnút $0$. Það er, fyrir sérhvern hnút $i$ þar sem $1 \le i \lt N$, gildir annaðhvort $P[i] = 0$ eða $P[P[i]] = 0$.
1. (8 stig) Fyrir sérhvert $c$ þar sem $1 \le c \le M$ eru mest tveir leggir með litinn $c$.
1. (14 stig) $N \le 200$ og $M \le 500$
1. (14 stig) $N \le 2\,000$ og $M = 2$
1. (12 stig) $N \le 2\,000$
1. (17 stig) $M = 2$
1. (12 stig) Engar frekari skorður.

## Sýnisyfirferðarforrit

Sýnisyfirferðarforritið les inntak á eftirfarandi sniði:

* lína $1$: $N \; M$
* lína $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* lína $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

Látum $b[0], \; b[1], \; \ldots$ tákna stökin í fylkinu sem `beechtree` skilar.
Sýnisyfirferðarforritið skrifar út svarið þitt á einni línu á eftirfarandi sniði:
* line $1$: $b[0] \; b[1] \; \ldots$
