 # עץ אשור
 
יער ויטיים הוא יער מפורסם עם עצים צבעוניים רבים.
אחד מעצי האשור העתיקים והגבוהים ביותר נקרא אוס וזר.

העץ אוס וזר ניתן לתיאור כאוסף של $N$ **צמתים** ו-$N-1$ **קשתות**. הצמתים ממוספרים מ-$0$ עד $N-1$ והקשתות ממוספרות מ-$1$ עד $N-1$.
כל קשת מחברת שני צמתים שונים בעץ.
בפרט, הקשת $i$ ($1\leq i \lt N$) מחברת את הצומת $i$ לצומת $P[i]$, כאשר $0\leq P[i] \lt i$. הצומת $P[i]$ נקרא ה**הורה** של הצומת $i$, והצומת $i$ נקרא **בן** של הצומת $P[i]$.

לכל קשת יש צבע. ישנם $M$ צבעים אפשריים הממוספרים מ-$1$ עד $M$. צבע הקשת $i$ הוא $C[i]$.
קשתות שונות יכולות להיות באותו הצבע.

שימו לב שבהגדרות לעיל, המקרה $i=0$ לא מתאים לאף קשת של העץ. מטעמי נוחות, נגדיר $P[0]=-1$ ו-$C[0]=0$.

לדוגמה, נניח שלאוס וזר יש $N = 18$ צמתים ו-$M=3$ צבעי קשתות אפשריים, עם $17$ קשתות המתוארות באמצעות החיבורים $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ והצבעים $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$. העץ מוצג באיור הבא:

![Tree](beechtree-tree.png "550")

אלון הוא יערן מוכשר שאוהב לחקור חלקים מסוימים של העץ הנקראים **תתי עצים**.
 לכל $r$ המקיים $0\leq r \lt N$, תת העץ של הצומת $r$ הוא הקבוצה $T(r)$ של צמתים בעלת התכונות הבאות:
 * הצומת $r$ שייך ל-$T(r)$.
 * כשצומת $x$ נמצא ב-$T(r)$, כל הבנים של $x$ נמצאים ב-$T(r)$ גם כן.
 * אין צמתים נוספים ב-$T(r)$.

גודל הקבוצה $T(r)$ מסומן ב-$|T(r)|$.

אלון גילה לאחרונה תכונה מורכבת אבל מעניינת של תתי עצים. התגלית של אלון כללה הרבה ניסויים עם דף ועט, והוא חושד שגם אתם עלולים להצטרך לפעול בצורה דומה כדי להבין אותה. הוא גם יציג לכם מספר דוגמאות שתוכלו לנתח לפרטים בהמשך.

נניח שיש לנו $r$ מקובע ופרמוטציה $v_0, v_1, \ldots, v_{|T(r)|-1}$ של צמתי תת העץ $T(r)$.

לכל $i$ המקיים $1\le i \lt |T(r)|$, נגדיר את $f(i)$ להיות מספר הפעמים שהצבע $C[v_i]$ מופיע בסדרה הבאה בת $i-1$ הצבעים: $C[v_1], C[v_2], \ldots, C[v_{i-1}]$.

(שימו לב ש-$f(1)$ הוא תמיד $0$ כי סדרת הצבעים היא ריקה בהגדרתה).

הפרמוטציה $v_0, v_1, \ldots, v_{|T(r)|-1}$ היא **פרמוטציה מרהיבה** אם ורק אם כל התכונות הבאות מתקיימות:
 * $v_0 = r$
 * לכל $i$ המקיים $1\le i \lt |T(r)|$, האב של הצומת $v_i$ הוא הצומת $v_{f(i)}$.

לכל $r$ המקיים $0\le r \lt N$, תת העץ $T(r)$ הוא **תת עץ מרהיב** אם ורק אם קיימת פרמוטציה מרהיבה של הצמתים ב-$T(r)$.
שימו לב שעל פי הגדרה זו כל תת עץ שמכיל צומת אחד בלבד הוא מרהיב.

הביטו בעץ לדוגמה לעיל. ניתן להראות שתתי העצים $T(0)$ ו-$T(3)$ של עץ זה אינם מרהיבים.
תת העץ $T(14)$ מרהיב, כי הוא כולל צומת אחד בלבד.
למטה נראה שתת העץ $T(1)$ גם כן מרהיב.

הביטו בסדרת המספרים השלמים השונים $[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$. הסדרה הזאת היא פרמוטציה של הצמתים שב-$T(1)$.
האיור מטה מתאר פרמוטציה זו.
התגיות המחוברות לצמתים מייצגות את האינדקסים שבהם הצמתים מופיעים בפרמוטציה.

![Tree](beechtree-label1.png "500")

עכשיו נוודא שזו *פרמוטציה מרהיבה*.
* $v_0 = 1$.
* $f(1) = 0$ משום ש-$C[v_1] = C[4] = 1$ מופיע $0$ פעמים בסדרה $[]$.
 - בהתאם, האב של $v_1$ הוא $v_0$, כלומר האב של צומת $4$ הוא $1$. (פורמלית, $P[4]=1$).
* $f(2) = 0$ משום ש-$C[v_2] = C[5] = 2$ מופיע $0$ פעמים בסדרה $[1]$.
 - בהתאם, האב של $v_2$ הוא $v_0$, כלומר האב של צומת $5$ הוא $1$.
* $f(3) = 1$ משום ש-$C[v_3] = C[12] = 1$ מופיע פעם אחת בסדרה $[1, 2]$.
 - בהתאם, האב של $v_3$ הוא $v_1$, כלומר האב של $12$ הוא $4$.
* $f(4) = 1$ משום ש-$C[v_4] = C[13] = 2$ מופיע פעם אחת בסדרה $[1, 2, 1]$.
 - בהתאם, האב של $v_4$ הוא $v_1$, כלומר האב של $13$ הוא $4$.
* $f(5) = 0$ משום ש-$C[v_5] = C[6] = 3$ מופיע $0$ פעמים בסדרה $[1, 2, 1, 2]$.
 - בהתאם, האב של $v_5$ הוא $v_0$, כלומר האב של $6$ הוא $1$.
* $f(6) = 2$ משום ש-$C[v_6] = C[14] = 2$ מופיע $2$ פעמים בסדרה $[1, 2, 1, 2, 3]$.
 - בהתאם, האב של $v_6$ הוא $v_2$, כלומר האב של $14$ הוא $5$.

מכיוון שהצלחנו למצוא *פרמוטציה מרהיבה* של צמתי $T(1)$, תת העץ $T(1)$ הוא *תת עץ מרהיב*.

משימתכם היא לעזור לאלון להחליט עבור כל תת עץ של אוס וזר האם הוא מרהיב.

## פרטי מימוש

עליכם לממש את הפונקציה הבאה.

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: מספר הצמתים בעץ.
* $M$: מספר צבעי הקשתות האפשריים.
* $P$, $C$: מערכים באורך $N$ המתארים את קשתות העץ.
* על פונקציה זו להחזיר מערך $b$ באורך $N$. 
לכל $r$ המקיים $0 \le r \lt N$, $b[r]$ צריך להיות $1$ אם $T(r)$ מרהיב, ו-$0$ אחרת.
* הפונקציה תיקרא בדיוק פעם אחת לכל טסטקייס.

## דוגמאות

### דוגמה 1
הביטו בקריאה הבאה:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

העץ מוצג באיור הבא:

![Tree](beechtree-ex1.png "350")

$T(1)$, $T(2)$, ו-$T(3)$ מכילים צומת אחד כל אחד ולכן הם מרהיבים.
$T(0)$ אינו מרהיב.
לכן, הפונקציה צריכה להחזיר $[0,1,1,1]$.

### דוגמה 2

הביטו בקריאה הבאה:
```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

הדוגמה הזאת מאוירת בתיאור השאלה למעלה.

הפונקציה צריכה להחזיר $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$.

### דוגמה 3

הביטו בקריאה הבאה:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

הדוגמה הזאת מומחשת באיור הבא.

![Tree](beechtree-ex3.png "400")

$T(0)$ הוא תת העץ היחיד שאינו מרהיב.
הפונקציה צריכה להחזיר $[0, 1, 1, 1, 1, 1, 1]$.


## מגבלות

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[i] \lt i$ (לכל $i$ המקיים $1 \le i \lt N$)
* $1 \le C[i] \le M$ (לכל $i$ המקיים $1 \le i \lt N$)
* $P[0] = -1$ ו-$C[0] = 0$

## תתי משימות

1. (9 נקודות) $N \le 8$ ו-$M \le 500$
1. (5 נקודות) קשת $i$ מחברת את צומת $i$ לצומת $i-1$. כלומר, לכל $i$ המקיים $1 \le i \lt N$, $P[i] = i-1$.
1. (9 נקודות) כל צומת מלבד צומת $0$ או מחובר לצומת $0$, או מחובר לצומת שמחובר לצומת $0$.
  כלומר, לכל $i$ המקיים $1 \le i \lt N$, או ש-$P[i]=0$ או ש-$P[P[i]]=0$.
1. (8 נקודות) לכל $c$ המקיים $1 \le c \le M$, קיימות לכל היותר שתי קשתות בצבע $c$.
1. (14 נקודות) $N \le 200$ ו-$M \le 500$
1. (14 נקודות) $N \le 2\,000$ ו-$M = 2$
1. (12 נקודות) $N \le 2\,000$
1. (17 נקודות) $M = 2$
1. (12 נקודות) ללא מגבלות נוספות.

## גריידר לדוגמה

הגריידר לדוגמה קורא את הקלט בפורמט הבא:

* שורה $1$: $N \; M$
* שורה $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* שורה $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

נסמן ב-$b[0], \; b[1], \; \ldots$ את איברי המערך המוחזר על ידי `beechtree`.
הגריידר לדוגמה מדפיס את תשובתכם בשורה אחת, בפורמט הבא:
* שורה $1$: $b[0] \; b[1] \; \ldots$









