# Beech Tree

Vétyem Woods - көптеген түрлі-түсті ағаштары бар әйгілі орман алқабы.
Ең көне және ең биік шамшат ағаштарының бірі Ős Vezér деп аталады.

Ős Vezér $N$ **төбеcі** және $N-1$ **қыры** бар дарағы ретінде қарастыруға болады.
Төбелер $0$-ден $N-1$-ге дейін, ал қырлар $1$-ден $N-1$-ге дейін нөмірленген.
Әр қыр дарақтың екі әр түрлі төбеcін байланыстырады.
Атап айтқанда, $i$ші ($1 \le i \lt N$) қыр  $i$ төбеcімен $P[i]$ ($0 \le P[i] \lt i$) төбеcін байланыстырады. $P[i]$ төбеcі $i$ төбеcінің әкеcі және $i$ төбеcі $P[i]$ төбеcінің перзенті деп аталады.

Әр қырдың түсі бар. Барлығы $1$-ден $M$-ге дейін нөмірленген $M$ түс бар.
$v$ қырының түсі $C[v]$.
Әртүрлі қырларда бірдей түс болуы мүмкін.

Жоғарыда келтірілген анықтамаларда $i = 0$ жағдайы дарақтың қырына сәйкес келмейтінін ескеріңіз. Ыңғайлылық үшін біз $P[0] = -1$ және $C[0] = 0$ деп есептейміз.

Мысалы, Ős Vezér-де $N = 18$ төбеcі, $M = 3$ мүмкін түсі және келесі $17$ қыры болсын: $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ және $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$. Дарақ келесі суретте көрсетілген:

![Tree](beechtree-tree.png "550")

Árpád - дарақтың ішкі дарақтар деп аталатын бөліктерін зерттейтін ағаш өсіруші.
Әр $r$ ($0 \le r \lt N$) төбеcі үшін $r$ ішкі дарағы $T(r)$ арқылы белгіленген төбелер жиыны және оның келесі қасиеттері бар:
* $r$ төбеcі $T(r)$ мүшесі.
* Әр $T(r)$ мүшесі $x$ үшін барлық $x$тің перзенттері де $T(r)$ мүшесі.

$T(r)$ жиынтықтың өлшемі $|T(r)|$ арқылы белгіленеді.

Árpád ішкі дарақтың күрделі, бірақ қызықты қасиетін ашқан. Árpád ашылуында көптеген қалам мен қағаз жұмысы қатысқан және ол мұны түсіну үшін сізге де солай істеу керек болуы мүмкін деп ескерткен. Сондай-ақ, ол сізге егжей-тегжейлі талдауға болатын бірнеше мысалдарды көрсетеді.

Айталық, бізде тіркелген $r$ және $T(r)$ ішкі дарақ төбелер $v_0, v_1, \ldots, v_{|T(r)|-1}$ алмастыруы бар. 

Әр $i$ ($1 \le i \lt |T(r)|$) үшін $f(i)$ деп $C[v_i]$ санының $[C[v_1], C[v_2], \ldots, C[v_{i-1}]]$ тізбегіндегі қайталанулар саның анықтаймыз. Ескеріңіз, $f(1)$ әрқашан $0$ өйткені оның анықтамасындағы тізбег бос.

$v_0, v_1, \ldots, v_{|T(r)|-1}$ алмастыруы **керемет** егер:
* $v_0 = r$.
* Әр $i$ ($1 \le i \lt |T(r)|$) үшін  $v_i$ әкеcі $v_{f(i)}$.

Әр $r$ ($0 \le r \lt N$,) үшін  $T(r)$ ішкі дарақ **керемет** егер $T(r)$ ішкі дарақтар төбелерінің керемет алмастыруы болса. Ескеріңіз, анықтамаға сәйкес, бір төбеден тұратын әрбір ішкі дарақ керемет.

Жоғарыдағы дарақ мысалын қарастырайық.
 $T(0)$ және $T(3)$ ішкі дарақтары керемет емес екенін көрсетуге болады.
$T(14)$  ішкі дарағы керемет өйткені бір төбеден тұрады.
Төменде біз $T(1)$  ішкі дарағы да керемет екенін көрсетеміз.

$[[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$ тізбегін қарастырайық. Бұл тізбег $T(1)$ ішкі дарақ төбелер алмастыруы болып табылады. Төмендегі суретте бұл алмастыруы көрсетілген. Төбелерге бекітілген белгілер - бұл төбелердің алмастырудағы индекстері.

![Tree](beechtree-label1.png "500")

Әлбетте, жоғарыдағы тізбег $T(1)$ ішкі дарақ төбелер алмастыруы. Енді біз оның *керемет* екенін көрсетеміз.

* $v_0 = 1$.
* $f(1) = 0$ өйткені $C[v_1] = C[4] = 1$,  $0$ рет $[]$ тізбегіндегі кездеседі.
  * Cәйкес, $v_1$ әкеcі $v_0$. Яғни, $4$ төбеcінің әкеcі $1$ төбеcі. (Формалды, $P[4] = 1$.)
* $f(2) = 0$ өйткені $C[v_2] = C[5] = 2$, $0$ рет $[1]$  тізбегіндегі кездеседі.
  * Cәйкес, $v_2$ әкеcі $v_0$. Яғни, $5$ төбеcі $1$.
* $f(3) = 1$ өйткені $C[v_3] = C[12] = 1$, $1$ рет $[1, 2]$ тізбегіндегі кездеседі.
  * Cәйкес, $v_3$ әкеcі $v_1$. Яғни, $12$ төбеcі $4$.
* $f(4) = 1$ since $C[v_4] = C[13] = 2$, $1$ рет $[1, 2, 1]$ тізбегіндегі кездеседі.
  * Cәйкес, $v_4$ әкеcі $v_1$. Яғни, $13$ төбеcі $4$.
* $f(5) = 0$ өйткені $C[v_5] = C[6] = 3$, $0$ рет $[1, 2, 1, 2]$ тізбегіндегі кездеседі.
  * Cәйкес, $v_5$ әкеcі $v_0$. Яғни, $6$ төбеcі $1$.
* $f(6) = 2$ өйткені $C[v_6] = C[14] = 2$, $2$ рет $[1, 2, 1, 2, 3]$ тізбегіндегі кездеседі.
  * Cәйкес, $v_6$ әкеcі $v_2$. Яғни, $14$ төбеcі $5$.


$T(1)$ ішкі дарақ төбелерінің керемет алмастыруы бар. Сондықтан $T(1)$ ішкі дарағы керемет.

Сіздің есебіңіз Ős Vezér әрбір ішкі дарағын керемет па, әлде жоқ па екенің анықтау.

## Implementation Details

Сізге келесі функцияны іске асыру қажет.

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: төбелер саны.
* $M$: қырлар саны.
* $P$, $C$: дарақ қырларың сипаттайтын, ұзындығы $N$ жиымдар.
* Бұл функция $b$ ұзындығы $N$ жиымды қайтару қажет.
	Әр $r$ ($0 \le r \lt N$) үшін  $b[r]$ $T(r)$ ішкі дарағы керемет болса $1$-ге тең, басқаша $0$-ге
* Бұл функция әр тестте **бір рет** шақыртылады.

## Examples

### Example 1

Келесі шақыртуды қарастырыйық:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

Бұл келесі дараққа сәйкес келеді:

![Tree](beechtree-ex1.png "350")

$T(1)$, $T(2)$, және $T(3)$ керемет өйткені бір төбеден тұрат.
$T(0)$ керемет емес.
Функция $[0, 1, 1, 1]$ жиымын қайтару қажет.

### Example 2

Келесі шақыртуды қарастырыйық:

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

Бұл жоғарыдағы дараққа сәйкес келеді:


Функция $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$ жиымын қайтару қажет.

### Example 3

Келесі шақыртуды қарастырыйық:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

Бұл келесі дараққа сәйкес келеді:

![Tree](beechtree-ex3.png "400")

Тек $T(0)$ керемет емес.
Функция $[0, 1, 1, 1, 1, 1, 1]$ жиымын қайтару қажет.


## Constraints

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[i] \lt i$ ($1 \le i \lt N$ орындалатын әр $i$ үшін)
* $1 \le C[i] \le M$ ($1 \le i \lt N$ орындалатын әр $i$ үшін)
* $P[0] = -1$ және $C[0] = 0$

## Subtasks

1. (9 points) $N \le 8$ және $M \le 500$
1. (5 points) $i$ қыры  $i$ төбеcін $i-1$ төбеcіне байланыстырады. Яғни, әр $i$ ($1 \le i \lt N$) үшін, $P[i] = i-1$.
1. (9 points) Әр төбе, $0$-ден басқа, $0$ төбеcіне байланысты, немесе $0$ төбеcіне байланысқан төбеге байланысты.
  Яғни, әр $v$ ($1 \le i \lt N$) үшін, $P[v]=0$ немесе $P[P[v]]=0$.
1. (8 points) Әр $c$ ($1 \le c \le M$) үшін, $c$ түсті қырлар саны екіден аспайды.
1. (14 points) $N \le 200$ және $M \le 500$
1. (14 points) $N \le 2\,000$ және $M = 2$
1. (12 points) $N \le 2\,000$
1. (17 points) $M = 2$
1. (12 points) Қосымша шектеулер жоқ.

## Sample Grader

Сынақ бағалаушы тестін сипаттамасын келесі форматта оқиды:

* line $1$: $N \; M$
* line $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* line $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

$b[0], \; b[1], \; \ldots$ жиымы `beechtree` функциясы қайтарған жиымы болсын.
Сынақ бағалаушы тест үшін бір қатарды келесі форматта шағарды:
* line $1$: $b[0] \; b[1] \; \ldots$