# Bukas

Vétyem Woods yra garsus miškas su daugybe spalvingų medžių.
Vienas iš seniausių ir aukščiausių bukų yra pavadintas Ős Vezér.

Ős Vezér medis gali būti pavaizduotas  $N$ **viršūnių** ir $N-1$ **briaunų** rinkiniu. Viršūnės sunumeruotos nuo $0$ iki $N-1$, o briaunos sunumeruotos nuo $1$ iki $N-1$.
Kiekviena briauna jungia dvi skirtingas medžio viršūnes.
T. y. briauna $i$ ($1 \le i \lt N$) jungia viršūnę $i$ su viršūne $P[i]$, kur $0 \le P[i] \lt i$. Viršūnė $P[i]$ vadinama viršūnės $i$ **tėvine viršūne**, o viršūnė  $i$ vadinama  viršūnės $P[i]$ **vaiku**.

Kiekviena briauna turi spalvą. Yra $M$ galimų briaunų spalvų, sunumeruotų nuo $1$ iki $M$.
Briaunos $i$ spalva yra $C[i]$.
Skirtingos briaunos gali būti tos pačios spalvos.

Atkreipkite dėmesį, kad pagal pateiktą apibrėžimą $i = 0$ nėra briauna. Tačiau  patogumo dėlei žymėsime $P[0] = -1$ ir $C[0] = 0$.

Pavyzdžiui, kai Ős Vezér sudaro $N = 18$ viršūnių, yra galimos $M = 3$ briaunų spalvos, ir yra $17$ briaunų, kurias nusako sujungimai  $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ ir spalvos $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$, medis atrodo taip:

![Tree](beechtree-tree.png "550")

Árpád yra talentingas miškininkas, kuriam patinka tyrinėti medžio  **pomedžius**.
Kiekvienam $r$, kur $0 \le r \lt N$, viršūnės $r$ pomedis yra viršūnių aibė $T(r)$, pasižyminti šiomis savybėmis:
* Viršūnė $r$ priklauso $T(r)$
* Jei viršūnė $x$ priklauso $T(r)$, tai ir visi $x$ vaikai taip pat priklauso $T(r)$.
* Jokios kitos viršūnjės nepriklauso $T(r)$.

$T(r)$ aibės dydis žymimas $|T(r)|$.

Árpád neseniai atrado sudėtingą, bet įdomią pomedžių savybę. Árpádo atradimas reikalavo daug braižymo ant popieriaus ir jis įtaria, kad jums irgi reikės tai daryti, kad suprastumėte savybę. Jis taip pat parodys jums keletą pavyzdžių, kuriuos galite detaliai išanalizuoti.

Tarkime, kad turime fiksuotą $r$ bei aibei $T(r)$ priklausančių viršūnių permutaciją $v_0, v_1, \ldots, v_{|T(r)|-1}$.

Kiekvienam $i$, kuriam $1 \le i \lt |T(r)|$, tegul $f(i)$ žymi, kiek kiek kartų spalva $C[v_i]$ pasikartoja $i-1$ spalvų sekoje $C[v_1], C[v_2], \ldots, C[v_{i-1}]$.

(Atkreipkite dėmesį, kad $f(1)$ visuomet lygus $0$, nes šios reikšmės apibrėžime spalvų seka yra tuščia.)

Viršūnių permutacija $v_0, v_1, \ldots, v_{|T(r)|-1}$ yra **graži permutacija** tada ir tik tada, jei galioja šios abi savybės:
* $v_0 = r$.
* Kiekvienam $i$, kuriam $1 \le i \lt |T(r)|$, viršūnės $v_i$ tėvinė viršūnė yra $v_{f(i)}$.

Bet kokiam $r$, kuriam $0 \le r \lt N$, pomedis $T(r)$ yra **gražus pomedis** tada ir tik tada, jei egzistuoja graži $T(r)$ priklausančių viršūnių permutacija.
Atkreipkite dėmesį, kad pagal apibrėžimą kiekvienas pomedis sudarytas tik iš vienos viršūnės yra gražus.

Panagrinėkime medį aukščiau pateiktame pavyzdyje.
Galima įrodyti, kad pomedžiai $T(0)$ ir $T(3)$ nėra gražūs.
Pomedis $T(14)$ yra gražus, nes jį sudaro tik viena viršūnė.
Žemiau įrodysime, kad pomedis $T(1)$ irgi yra gražus.

Panagrinėkime skirtingų sveikųjų skaičių seką $[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$. Ši seka yra  $T(1)$ viršūnių permutacija.
Permutacija pavaizduota žemiau esančiame paveikslėlyje.
Kiekvienos viršūnės indeksas šioje permutacijoje yra užrašytas ant šalia viršūnės esančios kortelės.

![Tree](beechtree-label1.png "500")

Įrodysime, kad tai yra *graži permutacija*.

* $v_0 = 1$.
* $f(1) = 0$, nes $C[v_1] = C[4] = 1$ sekoje $[]$ pasikartoja $0$ kartų
	* Atitinkamai, viršūnės $v_1$ tėvinė viršūnė yra  $v_0$, t. y. 4-os viršūnės tėvinė viršūnė yra 1 ($P[4] = 1$).
* $f(2) = 0$, nes $C[v_2] = C[5] = 2$ sekoje $[1]$ pasikartoja $0$ kartų.
	* Atitinkamai, viršūnės $v_2$ tėvinė viršūnė yra $v_0$, t. y. 5-os viršūnės tėvinė viršūnė yra 1.
* $f(3) = 1$, nes $C[v_3] = C[12] = 1$ sekoje $[1, 2]$ pasikartoja $1$ kartą.
	* Atitinkamai, viršūnės $v_3$ tėvinė viršūnė yra $v_1$, t. y. 12-os viršūnės tėvinė viršūnė yra 4.
* $f(4) = 1$, nes $C[v_4] = C[13] = 2$ sekoje $[1, 2, 1]$ pasikartoja $1$ kartą.
	* Atitinkamai, viršūnės $v_4$ tėvinė viršūnė yra $v_1$, t. y. 13-os viršūnės tėvinė viršūnė yra 4.
* $f(5) = 0$, nes $C[v_5] = C[6] = 3$ sekoje $[1, 2, 1, 2]$ pasikartoja $0$ kartų.
	* Atitinkamai, viršūnės $v_5$ tėvinė viršūnė yra $v_0$, t. y., 6-os viršūnės tėvinė viršūnė yra 1.
* $f(6) = 2$, nes $C[v_6] = C[14] = 2$ sekoje $[1, 2, 1, 2, 3]$ pasikartoja $2$ kartus.
	* Atitinkamai, viršūnės $v_6$ tėvinė viršūnė yra $v_2$, t. y. 14-os viršūnės tėvinė viršūnė yra 5.

Kadangi $T(1)$ priklausančioms viršūnėms suradome *gražią permutaciją*, pomedis $T(1)$ yra *gražus pomedis*.

Padėkite Árpád nustatyti, kurie Ős Vezér pomedžiai yra gražūs.


## Realizacija

Parašykite šią funkciją.

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: viršūnių skaičius medyje.
* $M$: galimų briaunų spalvų kiekis.
* $P$, $C$: $N$ dydžio masyvai, nusakantys medžio briaunas.
* Ši funkcija turėtų grąžinti $N$ dydžio masyvą $b$. 
  Kiekvienam $r$, kuriam $0 \le r \lt N$, $b[r]$ turėtų būti $1$, jei $T(r)$ yra gražus, ir $0$ kitu atveju.
* Ši funkcija bus iškviesta lygiai vieną kartą kiekvienam testui.

## Pavyzdžiai

### Pavyzdys nr. 1

Panagrinėkime šį iškvietimą:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

Šis medis pavaizduotas paveikslėlyje žemiau:

![Tree](beechtree-ex1.png "350")

Kiekvienas iš $T(1)$, $T(2)$, ir $T(3)$ sudaryti iš vienos viršūnės, taigi jie yra gražūs.
$T(0)$ nėra gražus.
Taigi, funkcija turėtų grąžinti $[0, 1, 1, 1]$.

### Pavyzdys nr. 2

Panagrinėkime šį iškvietimą:

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

Šis pavyzdys pateiktas uždavinio sąlygoje aukščiau.

Funkcija turėtų grąžinti $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$.

### Pavyzdys nr. 3

Panagrinėkime šį iškvietimą:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

Šis pavyzdys pavaizduotas paveikslėlyje žemiau.

![Tree](beechtree-ex3.png "400")

$T(0)$ yra vienintelis pomedis, kuris nėra gražus.
Funkcija turėtų grąžinti $[0, 1, 1, 1, 1, 1, 1]$.


## Ribojimai

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[i] \lt i$ (kiekvienam $i$, kur $1 \le i \lt N$)
* $1 \le C[i] \le M$ (kiekvienam $i$, kur $1 \le i \lt N$)
* $P[0] = -1$ ir $C[0] = 0$

## Dalinės užduotys

1. (9 taškai) $N \le 8$ ir $M \le 500$
1. (5 taškai) Briauna $i$ jungia viršūnę $i$ su viršūne $i-1$. Kitaip tariant, kiekvienam $i$, kuriam $1 \le i \lt N$, galioja $P[i] = i-1$.
1. (9 taškai) Kiekviena viršūnė išskyrus viršūnę $0$ yra arba prijungta prie viršūnės $0$, arba prijungta prie viršūnės, kuri prijungta prie viršūnės $0$.
  Kitaip tariant, kiekvienam $i$, kuriam $1 \le i \lt N$, galioja arba $P[i]=0$, arba $P[P[i]]=0$.
1. (8 taškai) Kiekvienam $c$, kuriam $1 \le c \le M$, yra daugiausiai dvi spalvos $c$ briaunos.
1. (14 taškų) $N \le 200$ ir $M \le 500$
1. (14 taškų) $N \le 2\,000$ ir $M = 2$
1. (12 taškų) $N \le 2\,000$
1. (17 taškų) $M = 2$
1. (12 taškų) Papildomų ribojimų nėra.

## Pavyzdinė vertinimo programa

Pavyzdinė vertinimo programa skaito duomenis šiuo formatu:

* $1$-a eilutė: $N \; M$
* $2$-a eilutė: $P[0] \; P[1] \; \ldots \; P[N-1]$
* $3$-a eilutė: $C[0] \; C[1] \; \ldots \; C[N-1]$

Pažymėkime $b[0], \; b[1], \; \ldots$ funkcijos `beechtree` grąžinto masyvo narius.
Pavyzdinė vertinimo programa atsakymą išveda vienoje eilutėje šiuo formatu:
* $1$-a eilutė: $b[0] \; b[1] \; \ldots$
