# Dižskabārža koks

Vétyem ir slavens mežš ar daudz krāsainiem kokiem.
Viens no vecākajiem un garākajiem dižskabārža kokiem ir nosaukts par Ős Vezér.

Koks Ős Vezér var tikt modelēts kā kopa no $N$ **virsotnēm** un $N-1$ **šķautnēm**.
Virsotnes ir numurētas no $0$ līdz $N-1$ un šķautnes ir numurētas no $1$ līdz $N-1$.
Katra šķautne savieno divas atšķirīgas koka virsotnes.
Konkrēti, šķautne $i$ ($1 \le i \lt N$) savieno virsotni $i$ ar virsotni $P[i]$, kur $0 \le P[i] \lt i$. Virsotne $P[i]$ tiek saukta par virsotnes $i$ **vecāku**, un virsotne $i$ tiek saukta par virsotnes $P[i]$ **bērnu**.

Katrai šķautnei ir krāsa. Ir $M$ dažādas iespējamās šķautņu krāsas, kas ir numurētas no $1$ līdz $M$.
Šķautnes $i$ krāsa ir $C[i]$.
Atšķirīgas šķautnes var būt vienādā krāsā.

Ievērojiet, ka iepriekš sniegtajās definīcijās, gadījums $i = 0$ neatbilst šķautnei kokā. Ērtībai mēs pieņemam, ka $P[0] = -1$ un $C[0] = 0$.

Piemēram, pieņemsim, ka Ős Vezér kokā ir $N = 18$ virsotnes un $M = 3$ iespējamās šķautņu krāsās, tas satur $17$ šķautnes $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ ar krāsām $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$. Šāds koks ir attēlots zīmējumā:

![Koks](beechtree-tree.png "550")

Árpád ir talantīgs mežzinis, kuram patīk pētīt noteiktas koka daļas, kuras sauc par **apakškokiem**.
Katram $r$, kuram $0 \le r \lt N$, virsotnes $r$ apakškoks ir virsotņu kopa $T(r)$ ar sekojošām īpašībām:
* Virsotne $r$ pieder kopai $T(r)$.
* Vienmēr, kad virsotne $x$ pieder $T(r)$, visi virsotnes $x$ bērni arī pieder $T(r)$.
* Neviena cita virsotne nepieder $T(r)$.

Kopas $T(r)$ izmērs tiek apzīmēts ar $|T(r)|$.

Árpád nesen atklāja sarežģītu, bet interesantu apakškoka īpašību.
Arpád, atklājot īpašību, ļoti daudz spēlējās ar papīru un pildspalvu. Viņam šķiet, ka jums būs jādara tas pats, lai to saprastu. Viņš jums arī parādīs vairākus piemērus, kurus jūs varat detalizēti analizēt.

Pieņemsim, ka ir fiksēts $r$ un permutācija $v_0, v_1, \ldots, v_{|T(r)|-1}$ no virsotnēm apakškokā $T(r)$.

Visiem $i$, kuriem $1 \le i \lt |T(r)|$, $f(i)$ vērtība ir vienāda ar reižu skaitu, cik krāsa $C[v_i]$ parādās sekojošajā krāsu virknē no $i-1$ krāsām: $C[v_1], C[v_2], \ldots, C[v_{i-1}]$.

(Ievērojiet, ka $f(1)$ ir vienmēr $0$, jo krāsu virkne tās definīcijā ir vienmēr tukša.)

Permutācija $v_0, v_1, \ldots, v_{|T(r)|-1}$ ir **skaista permutācija** tad un tikai tad, ja ir spēkā visas šādas īpašības:
* $v_0 = r$.
* Visiem $i$, kuriem $1 \le i \lt |T(r)|$, virsotnes $v_i$ vecāks ir virsotne $v_{f(i)}$.


Visiem $r$, kuriem $0 \le r \lt N$, apakškoks $T(r)$ ir **skaists apakškoks**, tad un tikai tad, ja eksistē skaista kopas $T(r)$ virsotņu permutācija. Ievērojiet, ka pēc definīcijas visi apakškoki, kas sastāv no vienas virsotnes, ir skaisti.

Aplūkosim iepriekš dotā koka piemēru:
Var pierādīt, ka koka $T(0)$ un $T(3)$ apakškoki nav skaisti.
Apakškoks $T(14)$ ir skaists, ja tas sastāv no vienas virsotnes.
Zemāk tiks paradīts, ka apakškoks $T(1)$ ir arī skaists.

Aplūkosim virkni no atšķirīgiem veseliem skaitļiem $[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$.
Šī virkne ir permutācija ar kopas $T(1)$ virsotnēm. Bilde zemāk attēlo šo permutāciju. Karodziņi, kas pievienoti virsotnēm ir indeksi kārtas numuriem, ar kuriem virsotnes parādās permutācijā.

![Koks](beechtree-label1.png "500")

Mēs tagad pārbaudīsim, ka tā ir *skaista permutācija*.

* $v_0 = 1$.
* $f(1) = 0$, jo $C[v_1] = C[4] = 1$ parādās $0$ reizes virknē $[]$.
  * Attiecīgi, virsotnes $v_1$ vecāks ir $v_0$. Tas ir, virsotnes $4$ vecāks ir $1$. (Formāli, $P[4] = 1$.)
* $f(2) = 0$, jo $C[v_2] = C[5] = 2$ parādās $0$ reizes virknē $[1]$.
  * Attiecīgi, virsotnes $v_2$ vecāks ir $v_0$. Tas ir, virsotnes $5$ vecāks ir $1$.
* $f(3) = 1$, jo $C[v_3] = C[12] = 1$ parādās $1$ reizes virknē $[1, 2]$.
  * Attiecīgi, virsotnes $v_3$ vecāks ir $v_1$. Tas ir, virsotnes $12$ vecāks ir $4$.
* $f(4) = 1$, jo $C[v_4] = C[13] = 2$ parādās $1$ reizes virknē $[1, 2, 1]$.
  * Attiecīgi, virsotnes $v_4$ vecāks ir $v_1$. Tas ir, virsotnes $13$ vecāks ir $4$.
* $f(5) = 0$, jo $C[v_5] = C[6] = 3$ parādās $0$ reizes virknē $[1, 2, 1, 2]$.
  * Attiecīgi, virsotnes $v_5$ vecāks ir $v_0$. Tas ir, virsotnes $6$ vecāks ir $1$.
* $f(6) = 2$, jo $C[v_6] = C[14] = 2$ parādās $2$ reizes virknē $[1, 2, 1, 2, 3]$.
  * Attiecīgi, virsotnes $v_6$ vecāks ir $v_2$. Tas ir, virsotnes $14$ vecāks ir $5$.

Tā kā mēs varējām atrast *skaistu* virsotņu kopas $T(1)$ *permutāciju*, *apakškoks* $T(1)$ ir *skaists*.

Jūsu uzdevums ir palīdzēt Árpád izlemt par katru Ős Vezér apakškoku, vai tas ir skaists.

## Implementācijas detaļas

Jums ir jāimplementē šī procedūra:

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: virsotņu skaits kokā.
* $M$: iespējamo sķautņu krāsu skaits.
* $P$, $C$: masīvi garumā $N$, kas apraksta koka šķautnes.
* Šajai procedūrai jāatgriež masīvs $b$ garumā $N$.
  Visiem $r$, kuriem $0 \le r \lt N$, $b[r]$ jābūt $1$, ja $T(r)$ ir skaists, un $0$ citādi.
* Šī procedūra tiek izsaukta tieši vienu reizi katrā testā.

## Piemēri

### 1. Piemērs

Aplūkosim šādu funkcijas izsaukumu:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

Šī piemēra attēls:

![Tree](beechtree-ex1.png "350")

$T(1)$, $T(2)$, un $T(3)$ katrs sastāv no vienas virsotnes, tādēļ tie ir skaisti.
$T(0)$ nav skaists.
Tāpēc procedūrai jāatgriež $[0, 1, 1, 1]$.

### 2. Piemērs

Aplūkosim šādu funkcijas izsaukumu:

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

Šis piemērs ir attēlots uzdevuma aprakstā.

Procedūrai jāatgriež $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$.

### 3. Piemērs

Aplūkosim šādu funkcijas izsaukumu:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

Šī piemēra attēls:

![Tree](beechtree-ex3.png "400")

$T(0)$ ir vienīgais apakškoks, kas nav skaists.
Procedūrai jāatgriež $[0, 1, 1, 1, 1, 1, 1]$.


## Ierobežojumi

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[i] \lt i$ (visiem $i$, kuriem $1 \le i \lt N$)
* $1 \le C[i] \le M$ (visiem $i$, kuriem $1 \le i \lt N$)
* $P[0] = -1$ un $C[0] = 0$

## Apakšuzdevumi

1. (9 punkti) $N \le 8$ un $M \le 500$
1. (5 punkti) Šķautne $i$ savieno virsotni $i$ ar virsnotni $i-1$. Tas ir, visiem $i$, kuriem $1 \le i \lt N$, $P[i] = i-1$.
1. (9 punkti) Katra virsotne, izņemot virsotni $0$, ir savienota ar virsotni $0$ vai ir savienota ar virsotni, kura ir savienota ar virsotni $0$.
  Tas ir, visiem $i$, kuriem $1 \le i \lt N$, vai nu $P[i]=0$, vai $P[P[i]]=0$.
1. (8 punkti) Visiem $c$, kuriem $1 \le c \le M$, kokā ir ne vairāk kā divas šķautnes ar krāsu $c$.
1. (14 punkti) $N \le 200$ un $M \le 500$
1. (14 punkti) $N \le 2\,000$ un $M = 2$
1. (12 punkti) $N \le 2\,000$
1. (17 punkti) $M = 2$
1. (12 punkti) Bez papildus ierobežojumiem.

## Piemēra vērtētājprogramma

Piemēra vērtētājprogramma ielasa ievaddatus šādā formātā:

* $1.$ rinda: $N \; M$
* $2.$ rinda: $P[0] \; P[1] \; \ldots \; P[N-1]$
* $3.$ rinda: $C[0] \; C[1] \; \ldots \; C[N-1]$

Pieņemsim, ka $b[0], \; b[1], \; \ldots$ apraksta masīva elementus, ko atgriež `beechtree`.
Piemēra vērtētājprogramma izdrukā jūsu atbildi vienā rindā šādā formātā:
* $1.$ rinda: $b[0] \; b[1] \; \ldots$
