# Буково дрво

Vétyem Woods е позната шума со многу шарени дрва.
Едно од најстарите и највисоките букови дрва е дрвото наречено Ős Vezér.

Дрвото Ős Vezér може да се моделира како множество од $N$ **јазли** и $N-1$ **ребра**.
Јазлите се нумерирани со целите броеви од $0$ до $N-1$, а ребрата се нумерирани со целите броеви од $1$ до $N-1$.
Секое ребро поврзува два различни јазли од дрвото.
Конкретно, реброто $i$ ($1 \le i \lt N$) го поврзува јазолот $i$ со јазолот $P[i]$, каде што $0 \le P[i] \lt i$. Јазолот $P[i]$ се нарекува **родител** на јазолот $i$, а јазолот $i$ се нарекува **дете** на јазолот $P[i]$.

Секое ребро си има боја. Постојат $M$ можни бои на ребра, нумерирани со целите броеви од $1$ до $M$.
Бојата на реброто $i$ е $C[i]$.
Различни ребра може да имаат иста боја.

Да забележиме дека во дефинициите погоре, случајот $i = 0$ не соодветствува на ребро од дрвото. Заради погодност, ќе земеме $P[0] = -1$ и $C[0] = 0$.

На пример, да претпоставиме дека Ős Vezér има $N = 18$ јазли и $M = 3$ можни бои на ребра, каде $17$-те ребра се опишани со врските $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ и боите $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$. Дрвото е прикажано на следната слика:

![Tree](beechtree-tree.png "550")

Иван е талентиран шумар кој сака да проучува одредени делови од дрвото наречени **поддрва**.
За секое $r$ такво што $0 \le r \lt N$, поддрвото на јазолот $r$ е поддрвото $T(r)$ од јазли со следните својства:
* Јазолот $r$ припаѓа на $T(r)$.
* Секогаш кога некој јазол $x$ припаѓа на $T(r)$, сите деца на $x$ исто така припаѓаат на $T(r)$.
* Ниту еден друг јазол не припаѓа на $T(r)$.

Големината на множеството $T(r)$ се означува со $|T(r)|$.

Иван неодамна открил едно комплицирано но интересно својство на поддрвата. Откритието на Иван вклучувало многу играње со пенкало и хартија, и тој се сомнева дека и вие ќе треба да го правите истото за да го разберете. Тој исто така ќе ви прикаже повеќе примери кои можете детално да ги анализирате.

Да претпоставиме дека имаме фиксно $r$ и пермутација $v_0, v_1, \ldots, v_{|T(r)|-1}$ на јазлите во поддрвото $T(r)$.

За секое $i$ такво што $1 \le i \lt |T(r)|$, нека $f(i)$ е бројот на појавувања на бојата $C[v_i]$ во следната секвенца од  $i-1$ бои: $[C[v_1], C[v_2], \ldots, C[v_{i-1}]]$.

(Да забележиме дека $f(1)$ е секогаш $0$ бидејќи секвенцата од бои во неговата дефиниција е празна).

Пермутацијата $v_0, v_1, \ldots, v_{|T(r)|-1}$ е **убава пермутација** ако и само ако важат сите следни својства:
* $v_0 = r$.
* За секое $i$ такво што $1 \le i \lt |T(r)|$, родителот на јазолот $v_i$ е јазолот $v_{f(i)}$.

За кое било $r$ така што $0 \le r \lt N$, поддрвото $T(r)$ е **убаво поддрво** ако и само ако постои убава пермутација на јазлите во $T(r)$. Да забележиме дека според дефиницијата секое поддрво што се состои од еден јазол е убаво.

Да го разгледаме примерот со дрвото од погоре.
Може да се покаже дека поддрвата $T(0)$ и $T(3)$ на ова дрво не се убави.
Поддрвото $T(14)$ е убаво, бидејќи се состои од еден јазол.
Подолу, ќе покажеме дека поддрвото $T(1)$ е исто така убаво.

Да ја разгледаме секвенцата од различни цели броеви $[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$.
Оваа секвенца е пермутација на јазлите во $T(1)$. Сликата подолу ја прикажува оваа пермутација. Лабелите прикачени на јазлите се индексите на коишто тие јазли се појавуваат во пермутацијата.

![Tree](beechtree-label1.png "500")

Сега ќе се увериме дека ова е *убава пермутација*.
* $v_0 = 1$.
* $f(1) = 0$ бидејќи $C[v_1] = C[4] = 1$ се појавува $0$ пати во секвенцата $[]$.
* Соодветно, родителот на $v_1$ е $v_0$. Односно, родител на јазолот 4 е јазолот 1. (Формално, $P[4] = 1$.)
* $f(2) = 0$ бидејќи $C[v_2] = C[5] = 2$ се појавува $0$ пати во секвенцата $[1]$.
* Соодветно, родителот на $v_2$ е $v_0$. Односно, родител на 5 е 1.
* $f(3) = 1$ бидејќи $C[v_3] = C[12] = 1$ се појавува $1$ пат во секвенцата $[1, 2]$.
* Соодветно, родителот на $v_3$ е $v_1$. Односно, родител на 12 е 4.
* $f(4) = 1$ бидејќи $C[v_4] = C[13] = 2$ се појавува $1$ пат во секвенцата $[1, 2, 1]$.
* Соодветно, родителот на $v_4$ е $v_1$. Односно, родител на 13 е 4.
* $f(5) = 0$ бидејќи $C[v_5] = C[6] = 3$ се појавува $0$ пати во секвенцата $[1, 2, 1, 2]$.
* Соодветно, родителот на $v_5$ е $v_0$. Односно, родител на 6 е 1.
* $f(6) = 2$ бидејќи $C[v_6] = C[14] = 2$ се појавува $2$ пати во секвенцата $[1, 2, 1, 2, 3]$.
* Соодветно, родителот на $v_6$ е $v_2$. Односно, родител на 14 е 5.

Бидејќи можевме да најдеме *убава пермутација* на јазлите во $T(1)$, поддрвото $T(1)$ е *убаво поддрво*.

Ваша задача е да му помогнете на Иван за секое поддрво на Ős Vezér да одлучи дали е убаво.

## Имплементациски детали

Треба да ја имплементирате следната процедура:

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: бројот на јазли во дрвото.
* $M$: бројот на можни бои на ребра.
* $P$, $C$: низи со должина $N$ кои ги опишуваат ребрата на дрвото.
* Оваа процедура треба да врати низа $b$ со должина $N$. 
  За секое $r$ такво што $0 \le r \lt N$, $b[r]$ треба да биде $1$ ако $T(r)$ е убаво, и $0$ во спротивно.
* Оваа процедура се повикува точно еднаш за секој тест случај.

## Примери

### Пример 1

Да го разгледаме следниот повик:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

Дрвото е прикажано на следната слика:

![Tree](beechtree-ex1.png "350")

$T(1)$, $T(2)$ и $T(3)$ се состојат од по еден јазол, па значи тие се убави.
$T(0)$ не е убаво.
Според тоа, процедурата треба да врати $[0, 1, 1, 1]$.

### Пример 2

Да го разгледаме следниот повик:

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

Овој пример е илустриран во описот на задачата погоре.

Процедурата треба да врати $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$.

### Пример 3

Да го разгледаме следниот повик:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

Овој пример е илустриран на следната слика.

![Tree](beechtree-ex3.png "400")

$T(0)$ е единственото поддрво кое не е убаво.
Процедурата треба да врати $[0, 1, 1, 1, 1, 1, 1]$.


## Ограничувања

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[i] \lt i$ (за секое $i$ такво што $1 \le i \lt N$)
* $1 \le C[i] \le M$ (за секое $i$ такво што $1 \le i \lt N$)
* $P[0] = -1$ и $C[0] = 0$

## Подзадачи

1. (9 поени) $N \le 8$ и $M \le 500$
1. (5 поени) Реброто $i$ го поврзува јазолот $i$ со јазолот $i-1$. Со други зборови, за секое $i$ такво што $1 \le i \lt N$, $P[i] = i-1$.
1. (9 поени) Секој јазол освен јазолот $0$, или е поврзан со јазолот $0$, или пак е поврзан со јазол којшто е поврзан со јазолот $0$.
  Со други зборови, за секое $i$ такво што $1 \le i \lt N$, или $P[i]=0$, или пак $P[P[i]]=0$.
1. (8 поени) За секое $c$ такво што $1 \le c \le M$, постојат најмногу две ребра со боја $c$.
1. (14 поени) $N \le 200$ и $M \le 500$
1. (14 поени) $N \le 2\,000$ и $M = 2$
1. (12 поени) $N \le 2\,000$
1. (17 поени) $M = 2$
1. (12 поени) Без дополнителни ограничувања.

## Пример-оценувач

Пример-оценувачот го чита влезот во следниот формат:

* линија $1$: $N \; M$
* линија $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* линија $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

Нека $b[0], \; b[1], \; \ldots$ се елементите на низата вратена од процедурата `beechtree`.
Пример-оценувачот го печати вашиот одговор во една линија, во следниот формат:
* линија $1$: $b[0] \; b[1] \; \ldots$
