# Beech мод

Vétyem Woods бол олон өнгийн модоороо алдартай ойн модон төгөл юм.  

Хамгийн эртний бөгөөд хамгийн өндөр beech модны нэгийг Ős Vezér гэдэг.

Ос Везер хэмээх модыг $N$ **зангилаа** болон $N-1$ **ирмэг**-ийн цогц байхаар загварчилж болно.
Зангилааг $0$-ээс $N-1$, ирмэгийг $1$-ээс $N-1$ хүртэл дугаарлая. 
Ирмэг бүр нь уг модны хоёр ялгаатай зангилааг холбоно. 
Тухайлбал, $i$ ($1 \le i \lt N$) ирмэг нь $i$ зангилааг $P[i]$ зангилаатай холбох ба энд $0 \le P[i] \lt i$ байна. $P[i]$ зангилааг $i$.$ зангилааны **эцэг**, $i$ зангилааг $P[i]$ зангилааны **хүүхэд** гэж нэрлэдэг.

Ирмэг бүр өөрийн гэсэн өнгөтэй. Ирмэгийн өнгө нь $1$-ээс $M$ хүртэл дугаарлагдсан $M$ тооны боломжит өнгө байдаг. 
$i$ ирмэгийн өнгө нь $C[i]$ байна. Ялгаатай ирмэгүүд ижил өнгөтэй байж болно.

Дээрх тодорхойлолтуудад $v = 0$ тохиолдол нь модны ирмэгтэй тохирохгүй байгааг анхаарна уу. Үүнийг зохицуулах үүднээс $P[0] = -1$ ба $C[0] = 0$ гэж үзнэ.

Жишээлбэл, Ős Vezér нь $N = 18$ зангилаатай ба $M = 3$ боломжит өнгөтэй, $17$ ирмэг нь $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ гэсэн холболтоор дүрслэгдсэн ба тэдгээрийн өнгө нь $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2 , 1, 1, 2, 2, 1, 2, 3]$ байг. Уг модыг дараах зурагт үзүүлэв.

![Tree](beechtree-tree.png "550")

Арпад (Árpád) бол **дэд мод** хэмээх модны тусгай хэсгийг судлах дуртай авъяаслаг ойчин юм.

$0 \le r \lt N$ байх $r$ бүрийн хувьд $r$ зангилааны дэд мод нь дараах шинж чанартай $T(r)$ зангилааны багц юм.
* $r$ зангилаа нь $T(r)$-д хамаарна.
* $x$ зангилаа $T(r)$-д хамаарах бүрд $x$-ын бүх хүүхдүүд мөн $T(r)$-д хамаарна.
* Өөр ямар ч зангилаа $T(r)$-д хамаарахгүй.

$T(r)$ багцын хэмжээг $|T(r)|$ гэж тэмдэглэнэ.

Арпад саяхан дэд модны нарийн төвөгтэй боловч сонирхолтой шинж чанарыг олж нээсэн. Арпадын нээлт нь цаас үзэг ихээр үрж байгаа тул ингэж байгааг ойлгохын тулд таныг үүнийг хийж үзжх хэрэгтэй гэж тэр бодож байгаа. Тэрээр танд нарийвчилсан дүн шинжилгээ хийх боломжтой олон жишээг үзүүлэх болно.

Бидэнд сонгон авсан $r$ зангилаа ба $T(r)$ дэд модны зангилаануудын $v_0, v_1, \ldots, v_{|T(r)|-1}$ сэлгэмэл байна гэе.

$1 \le i \lt |T(r)|$ байх $i$ бүрийн хувьд $C[v_i]$ өнгөний $C[v_1], C[v_2], \ldots, C[v_{i-1}]$ дараалал ($i-1$ элементтэй)-д гарч ирэх тоог $f(i)$ гэж үзье. 

(Өнгөний дараалалд хоосон байхаар тодорхойлсон тул $f(1)$ нь үргэлж $0$ байдгийг анхаарна уу.)

$v_0, v_1, \ldots, v_{|T(r)|-1}$ сэлгэмлийг нь дараах шинж чанаруудыг хангаж байгаа тохиолдолд л **үзэсгэлэнт сэлгэмэл** гэнэ.
* $v_0 = r$.
* $1 \le i \lt |T(r)|$ байх $i$ бүрийн хувьд $v_i$ зангилааны эцэг нь $v_{f(i)}$ зангилаа байх.

$0 \le r \lt N$ байх $r$ бүрийн хувьд $T(r)$-ийн зангилаанууд нь үзэсгэлэнт сэлгэмэл байх тохиолдолд л $T(r)$ дэд модыг **үзэсгэлэнт дэд мод** гэнэ. Тодорхойлолтын дагуу нэг зангилаанаас бүрдэх дэд мод бүр үзэсгэлэнтэй гэдгийг анхаарна уу.

Дээр авч үзсэн модны жишээг авч үзье.
Энэ модны $T(0)$ болон $T(3)$ дэд моднууд нь үзэсгэлэнтэй биш.
$T(14)$ дэд мод нь нэг зангилаа агуулсан тул үзэсгэлэнтэй.
Доор бид $T(1)$ дэд мод мөн үзэсгэлэнтэй болохыг харуулна.

$[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$ гэсэн ялгаатай бүхэл тоонуудын дарааллыг авч үзье. Энэ дараалал нь $T(1)$-ийн зангилаануудын сэлгэмэл юм. Доорх зурагт уг сэлгэмэлийг дүрсэллээ. Зангилаануудад хавсаргасан шошгууд нь эдгээр зангилаанууд сэлгэмэлд гарч ирэх индексүүд юм.

![Tree](beechtree-label1.png "500")

Одоо бид үүнийг *сайхан сэлгэмэл* болох эсэхийг шалгах болно.
* $v_0 = r = 1$.
* $C[v_1] = C[4] = 1$ нь $[]$ дараалалд $0$ удаа гарч ирсэн тул $f(1) = 0$. 
	* Эндээс $v_1$-ийн эцэг нь $v_0$ байна. Өөрөөр хэлбэл $4$ зангилааны эцэг нь $1$ зангилаа юм (Тиймээс $P[4] = 1$.)
* $C[v_2] = C[5] = 2$ нь $[1]$ дараалалд $0$ удаа гарч ирсэн тул $f(2) = 0$.
	*  Эндээс $v_2$-ийн эцэг нь $v_0$ байна. Өөрөөр хэлбэл $5$-ын эцэг нь $1$ байна.
* $C[v_3] = C[12] = 1$ нь $[1, 2]$, дараалалд $1$ удаа гарч ирсэн тул $f(3) = 1$.
	* Эндээс $v_3$-н эцэг нь $v_1$ байна. Өөрөөр хэлбэл, $12$-ын эцэг нь $4$ байна.
* $C[v_4] = C[13] = 2$ нь $[1, 2, 1]$ дараалалд $1$ удаа гарч ирсэн тул $f(4) = 1$.
	* Эндээс $v_4$-ийн эцэг нь $v_1$ байна. Өөрөөр хэлбэл, $13$-ын эцэг нь $4$ байна.
* $C[v_5] = C[6] = 3$ нь $[1, 2, 1, 2]$ дараалалд $0$ удаа гарч ирсэн тул$f(5) = 0$.
	* Эндээс $v_5$-ийн эцэг нь $v_0$ байна. Өөрөөр хэлбэл, $6$-ын эцэг нь $1$ байна.
* $C[v_6] = C[14] = 2$ нь $[1, 2, 1, 2, 3]$ дараалалд $2$ удаа гарч ирсэн тул $f(6) = 2$ ба $P[v_6] = P[14] = 5 = v_2$.
	* Эндээс $v_6$-ийн эцэг нь $v_2$ байна. Өөрөөр хэлбэл, $14$-ын эцэг нь $5$ байна.

Бид $T(1)$-ийн зангилаануудын *сайхан сэлгэмэл*-ийг олж чадсан тул $T(1)$ дэд мод нь *сайхан дэд мод* байна.

Таны даалгавар бол Ős Vezér-ийн дэд мод бүрийг сайхан эсэхийг шийдэхэд Арпад туслах явдал юм.

## Хэрэгжүүлэлтийн мэдээлэл

Та дараах процедурыг хэрэгжүүлэх ёстой.

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: Модны зангилааны тоо.
* $M$: Ирмэгийн өнгөний тоо.
* $P$, $C$: модны зангилааг тодорхойлох $N$ урттай массив.
* Энэ процедур нь $N$ урттай $b$ массивыг буцаана. 
  $0 \le r \lt N$ байх $r$ бүрийн хувьд $b[r]$ нь хэрэв $T(r)$ сайхан дэд мод бол $1$, бусад үед $0$ байна. 
* Уг процедурыг тестийн тохиолдол бүрийн хувьд яг нэг удаа дуудна.

## Жишээ

### Жишээ 1

Дараах дуудалтыг авч үзье:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

Модыг дараах байдлаар дүрсэлнэ. 

![Tree](beechtree-ex1.png "350")

$T(1)$, $T(2)$, $T(3)$ тус бүр нь нэг зангилаа агуулсан тул сайхан дэд мод юм.
$T(0)$ нь сайхан биш. Тиймээс процедур нь $[0, 1, 1, 1]$-ийг буцаана.

### Жишээ 2

Дараах дуудалтыг авч үзье:

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

Энэ жишээг дээр бодлогын өгүүлбэрт дүрслэн үзүүлсэн.

Процедур нь $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$ гэсэн утга буцаана.

### Жишээ 3

Дараах дуудалтыг авч үзье:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```


Жишээний модыг дараах зурагт дүрслэв.

![Tree](beechtree-ex3.png "400")

Зөвхөн $T(0)$ дэд мод л сайхан биш юм. 
Тиймээс процедур $[0, 1, 1, 1, 1, 1, 1]$ гэсэн утга буцаана.


## Хязгаарлалт

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[v] \lt v$ ($1 \le v \lt N$ байх $v$ бүрийн хувьд )
* $1 \le C[v] \le M$ ($1 \le v \lt N$ байх $v$ бүрийн хувьд)
* $P[0] = -1$ ба $C[0] = 0$

## Дэд бодлогууд

1. (9 оноо) $N \le 8$ ба $M \le 500$
1. (5 оноо) $v$ ирмэг нь $v$ зангилааг $v-1$ зангилаатай холбодог. Өөрөөр хэлбэл, $v$ бүрийн хувьд $1 \le v \lt N$, $P[v] = v-1$ байна.
1. (9 оноо) $0$ зангилаанаас бусад зангилаа бүр нь $0$ зангилаатай холбогдсон эсвэл $0$ зангилаатай холбогдсон өөр зангилаатай холбогдсон байна.
   Өөрөөр хэлбэл, $1 \le v \lt N$ байх $v$ бүрийн хувьд $P[v]=0$ эсвэл $P[P[v]]=0$ байна. 
1. (8 оноо) $1 \le c \le M$ байх $c$ бүрийн хувьд $c$ өнгөтэй ирмэг хамгийн ихдээ хоёр байна. 
1. (14 оноо) $N \le 200$ ба $M \le 500$
1. (14 оноо) $N \le 2\,000$ ба $M = 2$
1. (12 оноо) $N \le 2\,000$
1. (17 оноо) $M = 2$
1. (12 оноо) нэмэлт хязгаарлалт байхгүй.

## Жишээ грейдер

Жишээ грейдер нь оролтыг дараах форматаар уншина:

* мөр $1$: $N \; M$
* мөр $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* мөр $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

$b[0], \; b[1], \; \ldots$ нь `beechtree`-ээр буцаасан массивын элементүүд байг.
Жишээ грейдер таны хариултыг дараах форматаар нэг мөрөнд гаргана.

* мөр $1$: $b[0] \; b[1] \; \ldots$
