# Bukový les

Bukový les Vétyem je známy les plný pestrofarebných stromov. Jeden z najstarších a najvyšších bukov sa nazýva Ős Vezér.

Strom Ős Vezér môžeme popísať ako množiny $N$ **uzlov** a $N-1$ **vetiev**.
	Uzly sú očíslované od $0$ do $N-1$  a vetvy od $1$ do $N-1$. každá vetva spája dva rôzne uzly stromu. Presnejšie, vetva $v$ ($1 \le v \lt N$) spája uzol $v$ s uzlom $P[v]$, kde $0 \le P[v] \lt v$. Uzol $P[i]$ sa nazýva **rodič** uzla $i$ a uzol $i$ sa nazýva **potomkom** uzla $P[i]$.

Všetky vetvy sú ofarbené. K dispozícii je $M$ možných farieb vetiev označených $1$ až $M$.
Farba vetvy $v$ je $C[v]$.
Rôzne vetvy môžu mať rovnakú farbu.

Upozorňujeme, že v prípade $v = 0$ uvedené definície nezodpovedajú žiadnej vetve stromu. Pre jednoduchosť zadefinujme $P[0] = -1$ a $C[0] = 0$.

Na príklade ukážeme strom s $N = 18$ uzlami, s $M = 3$ možnými farbami a so $17$ vetvami zapísanými v poliach $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ a $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$. Uvedený strom je zobrazený na obrázku:

![Tree](beechtree-tree.png "550")

Árpád je talentovaný lesník, ktorý rád študuje špecifické časti stromu nazývané  **podstromy**.
Pre každé $r$ také, že $0 \le r \lt N$, podstrom uzla $r$ je množina $T(r)$ uzlov s nasledovnými vlastnosťami:
* uzol $r$ patrí do podstromu $T(r)$
* vždy, keď nejaký uzol $x$ patrí do podstromu $T(r)$, všetci jeho potomkovia tiež patria do podstromu $T(r)$
* žiadne ďalšie uzly do podstromu $T(r)$ nepatria

Veľkosť podstromu $T(r)$ budeme označovať $|T(r)|$.

Árpád nedávno objavil komplikované, ale zaujímavé vlastnosti podstromu. Jeho objavovanie zahŕňalo množstvo pozorovaní a značení si rôznych stromov perom na papier a odporúča vám rovnaký postup na pochopenie. Ponúka vám tiež niekoľko príkladov, ktoré môžete detailne preskúmať.

Predpokladajme, že máme fixné $r$ a permutáciu $v_0, v_1, \ldots, v_{|T(r)|-1}$ uzlov podstromu $T(r)$.

Pre každé $i$ také, že $1 \le i \lt |T(r)|$, označme $f(i)$ počet výskytov farby $C[v_i]$ v nasledovnej postupnosti $i-1$ farieb: $C[v_1], C[v_2], \ldots, C[v_{i-1}]$.

(Je zrejmé, že $f(1)$ je vždy $0$, keďže postupnosť farieb z definície je prázdna.)

Permutácia $v_0, v_1, \ldots, v_{|T(r)|-1}$ sa nazýva **nádherná** práve vtedy, keď platia všetky nasledovné podmienky:
* $v_0 = r$
* Pre každé $i$ také, že $1 \le i \lt |T(r)|$ rodič uzla $v_i$ je uzol $v_{f(i)}$.

Pre ľubovoľné $r$ také, že $0 \le r \lt N$ podstrom $T(r)$ je **nádherný podstrom** práve vtedy, keď existuje nádherná permutácia uzlov podstromu  $T(r)$. Vzhľadom na definíciu, každý podstrom obsahujúci iba jeden uzol je nádherný.

Uvažujme príklad uvedený vyššie.
Dá sa ukázať, že podstromy $T(0)$ a $T(3)$ tohto stromu nie sú nádherné.
Podstrom $T(14)$ je nádherný, keďže pozostáva iba z jedného uzla.
Nižšie ukážeme, že podstrom $T(1)$ je tiež nádherný.

Uvažujme postupnosť navzájom rôznych celých čísel $[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$. Táto postupnosť je permutáciou uzlov podstromu $T(1)$. Túto permutáciu reprezentuje nasledujúci obrázok. Index každého uzlu v tejto permutácii je zobrazený na "štítku" pri danom uzle.

![Tree](beechtree-label1.png "500")

Ukážeme, že postupnosť uvedená permutácia je nádherná:
* $v_0 = 1$.
* $f(1) = 0$ keďže $C[v_1] = C[4] = 1$ sa vyskytuje $0$ krát v postupnosti $[]$.
  * A naozaj, rodičom uzla  $v_1$ je uzol $v_0$, t.j. rodičom uzla 4 je uzol 1. (Formálne, $P[4] = 1$.)
* $f(2) = 0$ keďže $C[v_2] = C[5] = 2$ sa vyskytuje $0$ krát v postupnosti $[1]$.
	* A naozaj, rodičom uzla $v_2$ je uzol $v_0$, t.j. rodičom uzla 5 je uzol 1.
* $f(3) = 1$ keďže $C[v_3] = C[12] = 1$ sa vyskytuje $1$ krát v postupnosti $[1, 2]$.
	* A naozaj, rodičom uzla $v_3$ je uzol $v_1$, t.j. rodičom uzla 12 je uzol 4.
* $f(4) = 1$ keďže $C[v_4] = C[13] = 2$ sa vyskytuje $1$ krát v postupnosti $[1, 2, 1]$.
	* A naozaj, rodičom uzla $v_4$ je uzol $v_1$, t.j. rodičom uzla 13 je uzol 4.
* $f(5) = 0$ keďže $C[v_5] = C[6] = 3$ sa vyskytuje $0$ krát v postupnosti $[1, 2, 1, 2]$.
	* A naozaj, rodičom uzla $v_5$ je uzol $v_0$, t.j. rodičom uzla 6 je uzol 1.
* $f(6) = 2$ keďže $C[v_6] = C[14] = 2$ sa vyskytuje $2$ krát v postupnosti $[1, 2, 1, 2, 3]$.
	* A naozaj, rodičom uzla $v_6$ je uzol $v_2$, t.j. rodičom uzla 14 je uzol 5.

Keďže sme našli nádhernú permutáciu uzlov podstromu $T(1)$, tak podstrom $T(1)$ je tiež nádherný.


Vašou úlohou je pomôcť Árpádovi pre každý podstrom zadaného stromu rozhodnúť, či je nádherný alebo nie.

## Implementačné detaily

Vašou úlohou je implementovať nasledujúcu funkciu.

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: počet uzlov stromu
* $M$: počet dostupných farieb vetiev
* $P$, $C$: polia dĺžky $N$ popisujúce vetvy stromu
* Táto funkcia má vrátiť pole $b$ dĺžky $N$. 
  Pre každé $r$ také, že $0 \le r \lt N$, $b[r]$ má byť hodnota $1$, ak $T(r)$ je nádherný, ináč hodnota $0$.
* Táto funkcia bude v každej testovacej sade volaná práve raz.

## Príklady

### Príklad 1

Uvažujme nasledovné volanie:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

Uvedený strom je zobrazený na obrázku:

![Tree](beechtree-ex1.png "350")

Podstromy $T(1)$, $T(2)$ a $T(3)$ pozostávajú z jedného uzla a teda sú nádherné.
$T(0)$ nie je nádherný.
Teda, správny výsledok funkcie je $[0, 1, 1, 1]$.

### Príklad 2

Uvažujme nasledovné volanie:

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

Tento príklad je zobrazený na prvom obrázku v zadaní.

Správny výstup funkcie je $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$.

### Príklad 3

Uvažujme nasledujúce volanie:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

Tento príklad popisuje obrázok.

![Tree](beechtree-ex3.png "400")

$T(0)$ je jediný podstrom, ktorý nie je nádherný.
Správny výstup funkcie teda je $[0, 1, 1, 1, 1, 1, 1]$.


## Obmedzenia

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[i] \lt i$ (pre každé $i$ také, že $1 \le i \lt N$)
* $1 \le C[i] \le M$ (pre každé $i$ také, že $1 \le i \lt N$)
* $P[0] = -1$ a $C[0] = 0$

## Podúlohy

1. (09 bodov) $N \le 8$ a $M \le 500$
1. (05 bodov) Vetva $i$ spája uzol $i$ s uzlom $i-1$. Teda pre každé $i$ také, že  $1 \le i \lt N$, platí $P[i] = i-1$.
1. (09 bodov) Všetky uzly (okrem uzla $0$) sú buď spojené s uzlom $0$ alebo s uzlom, ktorý je spojený s uzlom $0$.
  Teda pre každé $i$ také, že $1 \le i \lt N$ platí buď $P[i]=0$ alebo $P[P[i]]=0$.
1. (08 bodov) Pre každé $c$ také, že $1 \le c \le M$ existujú najviac dve vetvy farby $c$.
1. (14 bodov) $N \le 200$ a $M \le 500$
1. (14 bodov) $N \le 2\,000$ a $M = 2$
1. (12 bodov) $N \le 2\,000$
1. (17 bodov) $M = 2$
1. (12 bodov) bez ďalších obmedzení

## Ukážkový testovač

 Ukážkový testovač číta vstup v nasledovnom formáte:

* riadok $1$: $N \; M$
* riadok $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* riadok $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

Nech $b[0], \; b[1], \; \ldots$ označujú prvky poľa vo výsledku volania funkcie `beechtree`.
Ukážkový testovač vypíše jeden riadok v nasledovnom formáte:
* riadok $1$: $b[0] \; b[1] \; \ldots$
