# Lindar

Det var en afton i början av maj. 
Syrenerna väntade på sydlig vind för att gå i blom, men lindarna bjödo ännu kärleksfilter i sina obrustna knoppar åt bofinkarna.
I staden sågo bofinkarna en lind av förfärlig vidd, som tycktes väcka de unga fåglarnas intresse, ty deras kvitter vid var gång de flögo förbi linden liknade måsarnes skri.

Nu hände sig, att i linden blevo efter åren $N$ **noder** och $N - 1$ **kanter** till.
Det tillkännagavs dessutom, att noderna skulle tilldelas individuella nummer, av vilka det första är $0$, varpå till följande noder nummer lika med det föregående, utökat med ett, ska ges. På ett sådant vis kan härledas, att den sista av noder ges numret $N - 1$. Ehuru kanterna är ett färre till antalet, kan förfarandet likaledes tillämpas på dessa, med skillnaden att den första av kanterna ges numet $1$, varpå man kan anta, att likaledes får den kant som sist numreras just numret $N - 1$.

Varje kant i linden ansluter precis två av lindens noder.
För att vara precis, ansluter kant $i$ ($1 \le i \lt N$) nod $i$ till nod $P[i]$, där $0 \le P[i] \lt i$.
Noden $P[i]$ är **förälder** till nod $i$, och nod $i$ betraktas på motsvarande sätt vara avkomma till $P[i]$.

I linden kan skådas som mest $M$ möjliga färger på dess kanter, givna till värdet olika heltal emellan $1$ och $M$.
Stadens yngligar har nämligen i ett stort nidningsdåd begått ett brott: de har helt sonika målat lindens kanter! - så att kant $i$ har färg $C[i]$.
Bland färgerne som lindens grenar har, så är det möjligt att ynglingarna målade två olika kanter med samma färg.

Iakttaga att i den ovanstående definitionen så motsvaras av $i = 0$ inte någon av lindens kanter.
Denna banalitet kan undslippas genom att vi låter $P[0] = -1$ och $C[0] = 0$.

Till exempel, ponera att i linden kan synas $N = 18$ noder och $M = 3$ möjliga färger, med $17$ kanter som beskrivs av anslutningarna  $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ och färgerna $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$. Trädet kan skönjas i avbildningen som följer:

![Tree](beechtree-tree.png "550")


Carl Nicolaus är ett snille med stor talang i konsten att bruka skog, men han vill inte arbeta. Han är filosof, och föredrager att studera i stor detalj utmärkande delar av trädet som benämns **delträd**.
För varje $r$, sådant att $0 \le r \lt N$, så betecknas delträdet för nod $r$ med $T(r)$, och i denna äro en mängd av noder.
Varje $T(r)$ bestäms så att följande villkor håller sanna:
* Nod $r$ är i $T(r)$.
* Om nod $x$ är i $T(r)$ är samtliga avkommer till $x$ i $T(r)$.
* Någon annan nod höra icke till $T(r)$.

Storleken på mängden $T(r)$ betecknas med $|T(r)|$.

Efter långa studier tycktes Carl Nicolaus hava upptäckt en egenhet i somliga av delträden, vilken krävt stor möda och nedtecknande på papper för att begripa sig på. Carl Nicolaus är en kamratlig typ! Han ämnar presentera flertalet exempel, vilka du kan nogrannt undersöka.

Vi förutsätter att $r$ är bestämt, och noderna i $T(r)$ har permuterats så att de är lika med $v_0, v_1, \ldots, v_{|T(r)|-1}$.

För varje $i$ så att $1 \le i \lt |T(r)|$, låt $f(i)$ vara antalet gånger färgen $C[v_i]$ förekommer i sekvensen av färger $C[v_1], C[v_2], \ldots, C[v_{i-1}]$.

(Ta här i beaktning att $f(1)$ nödvändigtvis är $0$, ty sekvensen av färger i dess definition är tom!)

Permutationen $v_0, v_1, \ldots, v_{|T(r)|-1}$ är **praktfull**  om och endast om de båda nedan egenskaper uppfylls:
* $v_0 = r$.
* För varje $i$ sådant att $1 \le i \lt |T(r)|$, så är föräldern till nod $v_i$ noden $v_{f(i)}$.

För varje $r$ så att $0 \le r \lt N$, så är delträdet $T(r)$ **praktfullt** om och endast om det finns en praktfull permutation av noderna i $T(v)$. Under det att nya tankar grodde i hans huvud, förvissade sig Carl Nicolaus att ett delträd beståendes av en enda nod är praktfullt.

Betrakta den lind i illustrationen ovan.
Delträden $T(0)$ och $T(3)$ i linden är inte praktfulla.
Delträdet $T(14)$ är invecklat, emedan det innehåller en enda nod.
Nedan påvisar vi att även delträdet $T(1)$ är praktfullt.

Betrakta sekvensen av distinkta heltal $[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$.
Denna sekvens är en permutation av de noder vilka utgör $T(1)$.
I följande figur finns denna permutation representerad.
Vid varje nod i delträdet befinner sig en etikett, som visar de index som noderna infinner sig på i permutation.

![Tree](beechtree-label1.png "500")

Låt oss vidare försäkra oss om att permutationen är *praktfull*.

* $v_0 = 1$.
* $f(1) = 0$ emedan $C[v_1] = C[4] = 1$ förekommer $0$ gånger i sekvensen $[]$.
  * Analogt, så är $v_1$:s förälder $v_0$. D.v.s, 4:s förälder är 1. (I formell mening, så är $P[4] = 1$)
* $f(2) = 0$ emedan $C[v_2] = C[5] = 2$ förekommer $0$ gånger i sekvensen $[1]$.
  * Analogt, så är $v_2$:s förälder $v_0$. D.v.s, 5:s förälder är 1.
* $f(3) = 1$ emedan $C[v_3] = C[12] = 1$ förekommer $1$ gång i sekvensen $[1, 2]$.
  * Analogt, så är $v_3$:s förälder $v_1$. D.v.s, 12:s förälder är 4.
* $f(4) = 1$ emedan $C[v_4] = C[13] = 2$ förekommer $1$ gång i sekvensen $[1, 2, 1]$.
  * Analogt, så är $v_4$:s förälder $v_1$. D.v.s, 13:s förälder är 4.
* $f(5) = 0$ emedan $C[v_5] = C[6] = 3$ förekommer $0$ gånger i sekvensen $[1, 2, 1, 2]$.
  * Analogt, så är $v_5$:s förälder $v_0$. D.v.s, 6:s förälder är 1.
* $f(6) = 2$ emedan $C[v_6] = C[14] = 2$ förekommer $2$ gånger i sekvensen $[1, 2, 1, 2, 3]$.
  * Analogt, så är $v_6$:s förälder $v_2$. D.v.s, 14:s förälder är 5.

Då en *praktfull permutation* av noderna i $T(1)$ kunde hittas, så är onekligen delträdet $T(1)$ praktfullt.

Därpå tågade Carl Nicolaus ner till Berns Salong för att tillkännage sin upptäckt.
Här samlades vid sjutiden skaror av ungt folk, vilka anhållo att Carl Nicolaus yttrar sig om vilka av lindens delträd äro praktfulla.

## Implementation Details

You should implement the following procedure.

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: the number of nodes in the tree.
* $M$: the number of possible edge colors.
* $P$, $C$: arrays of length $N$ describing the edges of the tree.
* This procedure should return an array $b$ of length $N$. 
  For each $r$ such that $0 \le r \lt N$, $b[r]$ should be $1$ if $T(r)$ is convoluted, and $0$ otherwise.
* This procedure is called exactly once for each test case.

## Examples

### Example 1

Consider the following call:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

The tree is displayed in the following figure:

![Tree](beechtree-ex1.png "350")

$T(1)$, $T(2)$, and $T(3)$ each contain a single node and are therefore convoluted.
$T(0)$ is not convoluted.
Therefore, the procedure should return $[0, 1, 1, 1]$.

### Example 2

Consider the following call:

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

This example is illustrated in the task description above.

The procedure should return $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$.

### Example 3

Consider the following call:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

This example is illustrated in the following figure.

![Tree](beechtree-ex3.png "400")

$T(0)$ is the only subtree that is not convoluted.
The procedure should return $[0, 1, 1, 1, 1, 1, 1]$.


## Constraints

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[v] \lt v$ (for each $v$ such that $1 \le v \lt N$)
* $1 \le C[v] \le M$ (for each $v$ such that $1 \le v \lt N$)
* $P[0] = -1$ and $C[0] = 0$

## Subtasks

1. (9 points) $N \le 8$ and $M \le 500$
1. (5 points) Edge $v$ connects node $v$ to node $v-1$. That is, for each $v$ such that $1 \le v \lt N$, $P[v] = v-1$.
1. (9 points) Each node other than node $0$ is either connected to node $0$, or is connected to a node which is connected to node $0$.
  That is, for each $v$ such that $1 \le v \lt N$, either $P[v]=0$ or $P[P[v]]=0$.
1. (8 points) For each $c$ such that $1 \le c \le M$, there are at most two edges of color $c$.
1. (14 points) $N \le 200$ and $M \le 500$
1. (14 points) $N \le 2\,000$ and $M = 2$
1. (12 points) $N \le 2\,000$
1. (17 points) $M = 2$
1. (12 points) No additional constraints.

## Sample Grader

The sample grader reads the input in the following format:

* line $1$: $N \; M$
* line $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* line $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

Let $b[0], \; b[1], \; \ldots$ denote the elements of the array returned by `beechtree`.
The sample grader prints your answer in a single line, in the following format:
* line $1$: $b[0] \; b[1] \; \ldots$
