# شجرة الزان

غابات الفيتين هي غابات مشهورة مليئة بأشجار الزان الملونة. 
تعد شجرة الفيزر واحدة من أقدم وأطول أشجار الزان.

يمكن اعتبار شجرة الفيزر على أنها شجرة مكونة من $N$ **عقدة** و $N-1$ **وصلة**. العقد مرقمة من $0$ إلى $N-1$ والوصلات مرقمة من $1$ إلى $N-1$. وكل وصلة تصل بين عقدتين مختلفتين من الشجرة.
بشكل خاص، الوصلة $i$ (حيث $1 \le i \lt N$) تصل العقدة $i$ مع العقدة $P[i]$، حيث $0 \le P[i] \lt i$.
ونسمي $P[i]$ بالعقدة **الأب** للعقدة $i$، و$i$ بالعقدة **الابن** للعقدة $P[i]$.

كل وصلة لها لون. هناك $M$ لون ممكن للعقدة، مرقمة من $1$ إلى $M$.
لون العقدة $i$ هو $C[i]$. وقد يكون للعقد المختلفة نفس اللون.

بملاحظة الشروط المذكورة أعلاه، حالة $i = 0$ لا تتبع لوصلة من الشجرة. للسهولة، نعتبر $P[0] = -1$ و $C[0] = 0$.

على سبيل المثال، لتكن الشجرة مكون من $N = 18$ عقدة و $M = 3$ لون ممكن للوصلات، مع $17$ وصلة موصوفة بالتوصيلات $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ والألوان $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$. الشجرة موضحة في الشكل أدناه:


![Tree](beechtree-tree.png "550")

أرباد عامل أشجار موهوب، يريد دراسة أجزاء محددة من الشجرة تدعى **أشجار جزئية**.
من أجل كل $r$ حيث $0 \le r \lt N$، الشجرة الجزئية للعقدة $r$ هي مجموعة العقد $T(r)$ التي تحقق:
* العقدة $r$ تقع ضمن $T(r)$.
* أياً تكن العقدة $x$ والتي تقع ضمن المجموعة $T(r)$,  على جميع أولاد العقدة $x$ أن تقع ضمن $T(r)$ أيضاَ.
* لا يوجد أي عقد إضافية تقع ضمن $T(r)$.

يرمز لحجم المجموعة $T(r)$ بالرمز $|T(r)|$.

اكتشف أرباد خاصية معقدة لكن ممتعة للشجرة الجزئية. يعتمد اكتشاف أرباد على اللعب بالورقة والقلم كثيراً، ويعتقد أنه عليك القيام بذلك أيضاً لفهمه. سوف يقدم لك عدة أمثلة لتتمكن من القيام بتحليل التفاصيل.

لنعتبر أنه لديك عقدة $r$ ثابتة والتبديلة  $v_0, v_1, \ldots, v_{|T(r)|-1}$ الخاصة بعقد الشجرة الجزئية $T(r)$.

من أجل أي $i$ حيث $1 \le i \lt |T(r)|$، نعرف $f(i)$ بأنه عدد المرات التي ظهر اللون $C[v_i]$  فيها ضمن السلسلة المكونة من $i-1$  لون: $C[v_1], C[v_2], \ldots, C[v_{i-1}]$. 

(لاحظ أن $f(1)$ هي دائماً $0$ لأن سلسلة الألوان هنا هي سلسلة فارغة بتعريفها)

يكون التبديل $v_0, v_1, \ldots, v_{|T(r)|-1}$  **تبديلاً جميلاً** إذا وفقط إذا تحققت الشروط التالية:
* $v_0 = r$.
* من اجل كل $i$ بحيث $1 \le i \lt |T(r)|$, العقدة الأب للعقدة $v_i$ هي العقدة $v_{f(i)}$.

من أجل أي $r$ بحيث $0 \le r \lt N$, تكون الشجرة الجزئية $T(r)$  **شجرة جزئية جميلة** إذا وفقط إذا وجد تبديل جميل للعقد ضمن هذه الشجرة الجزئية $T(r)$. 
انتبه أنه بالتعريف أي شجرة جزئية تحوي عنصراً وحيداً هي شجرة جميلة.

لننظر إلى الشجرة المثال في الأعلى. يمكن إيجاد أن الشجرتان الجزئيتان 
$T(0)$ و $T(3)$ من الشجرة ليستا جميلتين.
الشجرة الجزئية $T(14)$ هي شجرة جميلة لأنها تحوي عنصر وحيد.
والآن سنثبت أيضاً أن الشجرة $T(1)$ هي أيضاً جميلة.

ليكن لدينا السلسلة التالية من الأعداد الصحيحة
$[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$. 
هذه السلسلة هي تبديل للعقد ضمن الشجرة الجزئية 
 $T(1)$. 
يوضح الشكل التالي هذا التبديل. التسميات المرتبطة مع كل عقدة هي الأدلة التي تقع فيها هذه العقد في التبديل.


![Tree](beechtree-label1.png "500")


 سنبرهن الآن أنها تبديلة *جميلة*:

* $v_0 = 1$.
* $f(1) = 0$ لأن $C[v_1] = C[4] = 1$ يظهر $0$ مرة في السلسلة $[]$.
  * بشكل موافق, العقدة الأب للعقدة $v_1$ هي $v_0$. ذلك يعني أن أب العقدة $4$ هو العقدة $1$ ( $P[4] = 1$)
* $f(2) = 0$ لأن $C[v_2] = C[5] = 2$ يظهر $0$ مرة في السلسلة $[1]$.
  * وبشكل موافق لذلك, أب العقدة $v_2$ هو $v_0$. ذلك يعني أن أب العقدة $5$ هو $1$.
* $f(3) = 1$ لأن $C[v_3] = C[12] = 1$ يظهر $1$ مرة في السلسلة $[1, 2]$.
  * وبشكل موافق لذلك, العقدة الأب للعقدة $v_3$ هي $v_1$. ذلك يعني أن أب العقدة $12$ هو $4$.
* $f(4) = 1$ لأن $C[v_4] = C[13] = 2$ يظهر $1$ مرة في السلسلة $[1, 2, 1]$.
  * بشكل موافق لذلك, أب العقدة $v_4$ هو $v_1$.ذلك يعني أن أب العقدة $13$ هو $4$.
* $f(5) = 0$ لأن $C[v_5] = C[6] = 3$ يظهر $0$ مرة في السلسلة $[1, 2, 1, 2]$.
  * بشكل موافق لذلك, العقدة الأب للعقدة $v_5$ هو $v_0$. ذلك يعني أن أب العقدة $6$ هو $1$.
* $f(6) = 2$ لأن $C[v_6] = C[14] = 2$ يظهر $2$ مرة في السلسلة $[1, 2, 1, 2, 3]$.
  * بشكل موافق لذلك, tالعقدة الأب للعقدة $v_6$ هو $v_2$. ذلك يعني أن العقدة الأب للعقدة $14$ هي $5$.

وبما أننا وجدنا  *تبديل جميل* للعقد في 
$T(1)$ فهي *شجرة جزئية جميلة*.

مهمتك هي مساعدة أرباد ليقرر من أجل كل شجرة جزئية من فيزر فيما إذا كانت جميلة ام لا.


## تفاصيل البرمجة

يجب عليك برمجة الإجرائية التالية.

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: عدد العقد ضمن الشجرة.
* $M$: عدد ألوان الوصلات الممكنة.
* $P$, $C$: مصفوفتان طولهما $N$ تحددان وصلات الشجرة .
* يجب أن تعيد هذه الإجرائية مصوفة $b$ طولها $N$. 
  من أجل كل $r$ بحيث $0 \le r \lt N$, $b[r]$ يجب أن تكون $1$ إذا كانت $T(r)$ شجرة جزئية جميلة, و $0$ فيما عدا ذلك.
* سيتم طلب هذه الإجرائية مرة واحدة تماماً في كل حالة اختبار.

## أمثلة

### مثال 1

لنفترض الاستدعاء التالي:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```
الشجرة معروضة في الشكل التالي:

![Tree](beechtree-ex1.png "350")

$T(1)$, $T(2)$, و $T(3)$ كلهم مؤلفين من عقدة واحدة ولذلك كلهم جميلون.
$T(0)$ ليست جميلة.
لذلك على الإجرائية أن تعيد $[0, 1, 1, 1]$.

### مثال 2

لنفترض الاستدعاء التالي:

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

هذا هو المثال المعروض في نص السؤال في الأعلى.

يجب على الإجرائية أن تعيد ما يلي $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$.

### مثال 3

لنفترض الاستدعاء التالي:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

هذا المثال موضح في الشكل التالي.

![Tree](beechtree-ex3.png "400")

$T(0)$ هي الشجرة الجزئية الوحيدة التي ليست جميلة.

يجب على هذه الإجرائية أن تعيد $[0, 1, 1, 1, 1, 1, 1]$.


## القيود

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[i] \lt i$ (من أجل كل $i$ بحيث $1 \le i \lt N$)
* $1 \le C[i] \le M$ (من أجل كل $i$ بحيث $1 \le i \lt N$)
* $P[0] = -1$ و $C[0] = 0$

## المسائل الجزئية

1. (9 نقاط) $N \le 8$ و $M \le 500$
1. (5 نقاط) الوصلة $i$ تصل بين العقدة $i$ والعقدة $i-1$. ذلك يعني أنه من أجل كل $i$ يكون $1 \le i \lt N$, $P[i] = i-1$.
1. (9 نقاط) أي عقدة ليست العقدة $0$ إما مرتبطة مع العقدة $0$, أو مرتبطة مع عقدة مرتبطة مع العقدة صفر $0$.
  ذلك يعني أنه من أجل أي $v$ بحيث $1 \le v \lt N$, يكون إما $P[v]=0$ أو $P[P[v]]=0$.
1. (8 نقاط) من أجل أي  $c$ بحيث $1 \le c \le M$, يوجد على الأكثر وصلتين لونهما $c$.
1. (14 نقطة) $N \le 200$ و $M \le 500$
1. (14 نقطة) $N \le 2\,000$ و $M = 2$
1. (12 نقطة) $N \le 2\,000$
1. (17 نقطة) $M = 2$
1. (12 نقطة) لا يوجد قيود إضافية.

## Sample Grader

The sample grader reads the input in the following format:

* line $1$: $N \; M$
* line $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* line $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

Let $b[0], \; b[1], \; \ldots$ denote the elements of the array returned by `beechtree`.
The sample grader prints your answer in a single line, in the following format:
* line $1$: $b[0] \; b[1] \; \ldots$




