# ต้นบีช

ป่าเวทแย็ม (Vétyem Woods) เป็นพื้นที่ป่าที่อุดมไปด้วยต้นไม้หลากสีสัน
หนึ่งในต้นบีชที่เก่าแก่และสูงที่สุดมีชื่อว่าเอิชแวเซร์ (Ős Vezér)

ต้นเอิชแวเซร์จำลองได้เป็นเซตของ**จุดยอด** $N$ จุด และ**เส้นเชื่อม** $N-1$ เส้น
จุดยอดกำหนดด้วยหมายเลขตั้งแต่ $0$ ถึง $N-1$ และเส้นเชื่อมกำหนดด้วยหมายเลขตั้งแต่ $1$ ถึง $N-1$
เส้นเชื่อมแต่ละเส้นจะเชื่อมจุดยอดสองจุดที่แตกต่างกันในต้นไม้
กล่าวโดยเจาะจงคือ เส้นเชื่อม $i$ ($1 \le i \lt N$) เชื่อมจุดยอด $i$ และจุดยอด $P[i]$ ซึ่ง $0 \le P[i] \lt i$ และเรียกจุดยอด $P[i]$ ว่า **พ่อแม่** ของจุดยอด $i$ และเรียกจุดยอด $i$ ว่า **ลูก** ของจุดยอด $P[i]$

เส้นเชื่อมแต่ละเส้นมีสี โดยมีสีเส้นเชื่อมที่เป็นไปได้ $M$ สี กำหนดด้วยหมายเลขตั้งแต่ $1$ ถึง $M$
ซึ่งสีของเส้นเชื่อม $i$ คือ $C[i]$
เส้นเชื่อมต่างเส้นกันก็อาจมีสีเหมือนกันได้

สังเกตว่าตามนิยามด้านบน กรณี $i = 0$ ไม่ตรงกับเส้นเชื่อมใดของต้นไม้เลย แต่เพื่อความสะดวก จึงกำหนดให้ $P[0] = -1$ และ $C[0] = 0$

ตัวอย่างเช่น สมมติให้เอิชแวเซร์มีจุดยอด $N = 18$ จุด มีสีเส้นเชื่อม $M = 3$ สีที่เป็นไปได้ มีเส้นเชื่อม $17$ เส้น โดยมีรูปแบบการเชื่อมเป็น $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ และสีเป็น $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$ ต้นไม้ดังกล่าวแสดงในรูปต่อไปนี้:

![Tree](beechtree-tree.png "550")

อาร์พาด (Árpád) เป็นนักวนศาสตร์เปี่ยมความสามารถผู้ชอบศึกษาส่วนของต้นไม้ที่เรียกว่า**ต้นไม้ย่อย**
สำหรับแต่ละ $r$ ซึ่ง $0 \le r \lt N$ นั้น ต้นไม้ย่อยของจุดยอด $r$ คือเซต $T(r)$ ของจุดยอด โดยเซตดังกล่าวมีสมบัติต่อไปนี้
* จุดยอด $r$ อยู่ใน $T(r)$
* เมื่อใดก็ตามที่จุดยอด $x$ อยู่ใน $T(r)$ จะได้ว่า ลูกทั้งหมดของ $x$ ก็จะอยู่ใน $T(r)$ เช่นกัน
* ไม่มีจุดยอดอื่นนอกจากนี้อยู่ใน $T(r)$

ขนาดของเซต $T(r)$ เขียนว่า $|T(r)|$

อาร์พาดเพิ่งค้นพบสมบัติบางประการของต้นไม้ย่อยที่ถึงแม้จะซับซ้อนแต่ก็น่าสนใจ การค้นพบของอาร์พาดนั้นมีการใช้กระดาษและปากกาในการลองเล่นลองเขียนอย่างหนัก และเขาก็คาดว่าคุณก็คงต้องใช้วิธีเดียวกันในการทำความเข้าใจ เขาจะยกตัวอย่างหลายตัวอย่างเพื่อช่วยให้คุณได้ลองวิเคราะห์อย่างละเอียด

สมมติว่าเราได้เลือกค่า $r$ ไว้ และมี $v_0, v_1, \ldots, v_{|T(r)|-1}$ เป็นการเรียงสับเปลี่ยนของจุดยอดในต้นไม้ย่อย $T(r)$

สำหรับแต่ละ $i$ ซึ่ง $1 \le i \lt |T(r)|$ กำหนดให้ $f(i)$ แทนจำนวนครั้งที่สี $C[v_i]$ ปรากฏในลำดับของสี $i-1$ สี ดังต่อไปนี้: $C[v_1], C[v_2], \ldots, C[v_{i-1}]$

(สังเกตว่า $f(1)$ จะมีค่าเป็น $0$ เสมอ เพราะลำดับของสีตามในนิยามนี้เป็นลำดับที่ว่างเปล่า)

การเรียงสับเปลี่ยน $v_0, v_1, \ldots, v_{|T(r)|-1}$ เป็น **การเรียงสับเปลี่ยนที่งดงาม** ก็ต่อเมื่อสมบัติต่อไปนี้เป็นจริงทั้งหมด:
* $v_0 = r$
* สำหรับแต่ละ $i$ ซึ่ง $1 \le i \lt |T(r)|$ จะได้ว่า พ่อแม่ของจุดยอด $v_i$ คือจุดยอด $v_{f(i)}$

สำหรับแต่ละ $r$ ซึ่ง $0 \le r \lt N$ นั้น ต้นไม้ย่อย $T(r)$ เป็น **ต้นไม้ย่อยที่งดงาม** ก็ต่อเมื่อมีการเรียงสับเปลี่ยนของจุดยอดของ $T(r)$ ที่งดงาม สังเกตว่าตามนิยามนี้ ทุกต้นไม้ย่อยที่ประกอบด้วยจุดยอดเพียงจุดเดียวจะงดงามเสมอ

พิจารณาต้นไม้ตามตัวอย่างด้านบน
ต้นไม้ย่อย $T(0)$ และ $T(3)$ ของต้นไม้นี้ สามารถแสดงได้ว่าไม่งดงาม
ส่วนต้นไม้ย่อย $T(14)$ นั้นงดงามเพราะประกอบด้วยจุดยอดเพียงจุดเดียว
และจากนี้เราจะแสดงให้เห็นว่า $T(1)$ นั้นก็งดงามเช่นกัน

พิจารณาลำดับของจำนวนเต็มที่แตกต่างกันต่อไปนี้ $[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$ ลำดับนี้เป็นการเรียงสับเปลี่ยนของจุดยอดใน $T(1)$
รูปต่อไปนี้แสดงลำดับดังกล่าว โดยดัชนี (index) ของแต่ละจุดยอดในลำดับนี้แสดงในรูปเป็นตัวเลขในป้ายที่ติดอยู่บนจุดยอดจุดนั้น ๆ

![Tree](beechtree-label1.png "500")

จากนี้เราจะตรวจสอบให้ดูว่าลำดับนี้เป็น *การเรียงสับเปลี่ยนที่งดงาม*

* $v_0 = 1$
* $f(1) = 0$ เพราะ $C[v_1] = C[4] = 1$ ปรากฏ $0$ ครั้งในลำดับ $[]$
  * สอดคล้องกับที่ว่า พ่อแม่ของ $v_1$ คือ $v_0$ หรือก็คือ พ่อแม่ของจุดยอด $4$ คือจุดยอด $1$ (กล่าวอย่างทางการคือ $P[4] = 1$)
* $f(2) = 0$ เพราะ $C[v_2] = C[5] = 2$ ปรากฏ $0$ ครั้งในลำดับ $[1]$
  * สอดคล้องกับที่ว่า พ่อแม่ของ $v_2$ คือ $v_0$ หรือก็คือ พ่อแม่ของ $5$ คือ $1$
* $f(3) = 1$ เพราะ $C[v_3] = C[12] = 1$ ปรากฏ $1$ ครั้งในลำดับ $[1, 2]$
  * สอดคล้องกับที่ว่า พ่อแม่ของ $v_3$ คือ $v_1$ หรือก็คือ พ่อแม่ของ $12$ คือ $4$
* $f(4) = 1$ เพราะ $C[v_4] = C[13] = 2$ ปรากฏ $1$ ครั้งในลำดับ $[1, 2, 1]$
  * สอดคล้องกับที่ว่า พ่อแม่ของ $v_4$ คือ $v_1$ หรือก็คือ พ่อแม่ของ $13$ คือ $4$
* $f(5) = 0$ เพราะ $C[v_5] = C[6] = 3$ ปรากฏ $0$ ครั้งในลำดับ $[1, 2, 1, 2]$
  * สอดคล้องกับที่ว่า พ่อแม่ของ $v_5$ คือ $v_0$ หรือก็คือ พ่อแม่ของ $6$ คือ $1$
* $f(6) = 2$ เพราะ $C[v_6] = C[14] = 2$ ปรากฏ $2$ ครั้งในลำดับ $[1, 2, 1, 2, 3]$
  * สอดคล้องกับที่ว่า พ่อแม่ของ $v_6$ คือ $v_2$ หรือก็คือ พ่อแม่ของ $14$ คือ $5$

เนื่องจากว่าเราสามารถหา *การเรียงสับเปลี่ยนที่งดงาม* ของจุดยอดใน $T(1)$ ได้ จึงสรุปได้ว่าต้นไม้ย่อย $T(1)$ นั้นเป็น *ต้นไม้ย่อยที่งดงาม*

งานของคุณคือ ช่วยอาร์พาดตัดสินว่าแต่ละต้นไม้ย่อยของเอิชแวเซร์ จัดว่างดงามหรือไม่

## รายละเอียดการเขียนโปรแกรม

คุณจะต้องเขียนฟังก์ชันต่อไปนี้

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: จำนวนจุดยอดในต้นไม้
* $M$: จำนวนสีเส้นเชื่อมที่เป็นไปได้
* $P$, $C$: อาร์เรย์ความยาว $N$ อธิบายรายละเอียดของเส้นเชื่อม
* ฟังก์ชันนี้ต้องคืนค่าเป็นอาร์เรย์ $b$ ความยาว $N$
 โดยสำหรับแต่ละ $r$ ซึ่ง $0 \le r \lt N$ ค่าของ $b[r]$ ควรเป็น $1$ ถ้า $T(r)$ นั้นงดงาม มิฉะนั้นเป็น $0$
* ฟังก์ชันนี้จะถูกเรียกเพียงหนึ่งครั้งสำหรับแต่ละชุดทดสอบ

## ตัวอย่าง

### ตัวอย่างที่ 1

พิจารณาการเรียกฟังก์ชันต่อไปนี้

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

ต้นไม้ดังกล่าวแสดงในรูปต่อไปนี้

![Tree](beechtree-ex1.png "350")

$T(1)$, $T(2)$ และ $T(3)$ แต่ละต้นประกอบด้วยจุดยอดเพียงจุดเดียว จึงจัดว่างดงามทั้งหมด
ส่วน $T(0)$ นั้นไม่งดงาม
ดังนั้น ฟังก์ชันต้องคืนค่า $[0, 1, 1, 1]$

### ตัวอย่างที่ 2

พิจารณาการเรียกฟังก์ชันต่อไปนี้

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

ต้นไม้ดังกล่าวแสดงในรูปตามคำอธิบายโจทย์ด้านบน

ฟังก์ชันต้องคืนค่า $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$

### ตัวอย่างที่ 3

พิจารณาการเรียกฟังก์ชันต่อไปนี้

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

ต้นไม้ดังกล่าวแสดงในรูปต่อไปนี้

![Tree](beechtree-ex3.png "400")

$T(0)$ เป็นต้นไม้ย่อยเพียงต้นเดียวที่ไม่งดงาม
ดังนั้น ฟังก์ชันต้องคืนค่า $[0, 1, 1, 1, 1, 1, 1]$


## ข้อจำกัด

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[i] \lt i$ (สำหรับแต่ละ $i$ ซึ่ง $1 \le i \lt N$)
* $1 \le C[i] \le M$ (สำหรับแต่ละ $i$ ซึ่ง $1 \le i \lt N$)
* $P[0] = -1$ และ $C[0] = 0$

## ปัญหาย่อย

1. (9 คะแนน) $N \le 8$ และ $M \le 500$
1. (5 คะแนน) เส้นเชื่อม $i$ เชื่อมจุดยอด $i$ กับจุดยอด $i-1$ นั่นคือ สำหรับแต่ละ $i$ ซึ่ง $1 \le i \lt N$ จะได้ว่า $P[i] = i-1$
1. (9 คะแนน) จุดยอดแต่ละจุดนอกจากจุดยอด $0$ ถ้าไม่เชื่อมกับจุดยอด $0$ ก็จะเชื่อมกับจุดยอดที่เชื่อมกับจุดยอด $0$
  นั่นคือ สำหรับแต่ละ $i$ ซึ่ง $1 \le i \lt N$ จะได้ว่า $P[i]=0$ หรือ $P[P[i]]=0$
1. (8 คะแนน) สำหรับแต่ละ $c$ ซึ่ง $1 \le c \le M$ จะมีเส้นเชื่อมที่มีสี $c$ อย่างมากสองเส้น
1. (14 คะแนน) $N \le 200$ และ $M \le 500$
1. (14 คะแนน) $N \le 2\,000$ และ $M = 2$
1. (12 คะแนน) $N \le 2\,000$
1. (17 คะแนน) $M = 2$
1. (12 คะแนน) ไม่มีข้อจำกัดใดเพิ่มเติม

## เกรดเดอร์ตัวอย่าง

เกรดเดอร์ตัวอย่างจะอ่านค่าอินพุตในรูปแบบดังนี้

* บรรทัดที่ $1$: $N \; M$
* บรรทัดที่ $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* บรรทัดที่ $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

ให้ $b[0], \; b[1], \; \ldots$ แทนสมาชิกของอาร์เรย์ที่คืนค่ามาจากฟังก์ชัน `beechtree`
เกรดเดอร์ตัวอย่างจะแสดงคําตอบของคุณบนบรรทัดเดียวในรูปแบบต่อไปนี้:
* บรรทัดที่ $1$: $b[0] \; b[1] \; \ldots$
