# Kayın Ağacı

Vétyem Ormanı, birçok rengarenk ağacın bulunduğu ünlü bir ormanlık bölgedir.
En eski ve en uzun kayın ağacına Ős Vezér adı verilir.

Ős Vezér ağacı, $N$ **düğüm** ve $N-1$ **kenar** kümesi olarak modellenebilir.
Düğümler $0$ ile $N-1$ arasında ve kenarlar $1$ ile $N-1$ arasında numaralandırılır.
Her kenar ağacın iki farklı düğümünü birbirine bağlar.
Spesifik olarak, kenar $i$ ($1 \le i \lt N$), $i$ düğümünü $P[i]$ düğümüne bağlar, burada $0 \le P[i] \lt i$. $P[i]$ düğümüne, $i$ düğümünün **ebebeyni** denir ve $i$ düğümüne, $P[i]$ düğümünün **çocuğu** denir.

Her kenarın bir rengi vardır. $1$'den $M$'ye kadar numaralandırılmış $M$ olası kenar rengi vardır.
$i$ kenarının rengi $C[i]$'dir.
Farklı kenarlar aynı renge sahip olabilir.

Yukarıdaki tanımlarda $i = 0$ durumunun ağacın bir kenarına karşılık gelmediğine dikkat edin. Kolaylık olması açısından $P[0] = -1$ ve $C[0] = 0$ olarak kabul ettik.

Örneğin, Ős Vezér $N = 18$ düğüm ve $M = 3$ olası kenar rengine sahip olsun. Bu ağaçta $17$ tane kenar $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ bağlantıları ile ve $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$ renkleri ile tanımlansın. Ağaç aşağıdaki şekilde görülmektedir:

![Tree](beechtree-tree.png "550")

Árpád, ağacın **alt ağaçlar** adı verilen özel kısımlarını incelemeyi seven yetenekli bir orman bilimcisidir.
$0 \le r \lt N$ şartını sağlayan her $r$ için, $r$ düğümünün alt ağacı, aşağıdaki özelliklere sahip düğümlerin $T(r)$ kümesidir:
* $r$ düğümü $T(r)$'a aittir.
* Ne zaman bir $x$ düğümü $T(r)$'a ait olursa, $x$'ın tüm çocukları da $T(r)$'a aittir.
* $T(r)$'a ait başka düğüm yoktur.

$T(r)$ kümesinin boyutu $|T(r)|$ ile gösterilir.

Arpád yakın zamanda karmaşık ama ilginç bir alt ağaç özelliği keşfetti. Arpád'ın keşfi, kalem ve kağıtla çok fazla karalama içerdiğinden bunu anlamak için sizin de aynısını yapmanız gerekebilir. Ayrıca size daha sonra ayrıntılı olarak analiz edebileceğiniz birden fazla örnek de gösterecektir.

Alt ağaç $T(r)$ içindeki düğümlerin sabit bir $r$'sine ve sabit bir $v_0, v_1, \ldots, v_{|T(r)|-1}$ permütasyonuna sahip olduğumuzu varsayalım.

$1 \le i \lt |T(r)|$ olacak şekilde her $i$ için, $f(i)$, $C[v_i]$ renginin takip eden $i-1$ renkli $C[v_1], C[v_2], \ldots, C[v_{i-1}]$ serisinde görünme sayısı olsun. 

(Tanımındaki renk serisi boş olduğundan $f(1)$'ın her zaman $0$ olduğunu unutmayın.)

$v_0, v_1, \ldots, v_{|T(r)|-1}$ permütasyonu **güzel permütasyondur** ancak ve ancak aşağıdaki özelliklerin tümü sağlanırsa:
* $v_0 = r$.
* $1 \le i \lt |T(r)|$ olacak şekilde her $i$ için, $v_i$ düğümünün ebeveyni $v_{f(i)}$ düğümüdür.

$0 \le r \lt N$ olacak şekilde herhangi bir $r$ için, $T(r)$ alt ağacı **güzel bir alt ağaçtır** ancak ve ancak $T(r)$ içindeki düğümlerin güzel bir permütasyonu varsa. Tanıma göre tek bir düğümden oluşan her alt ağacın güzel olduğunu unutmayın.

Yukarıdaki örnekte verilen ağacı göz önüne alın.
Bu ağacın $T(0)$ ve $T(3)$ alt ağaçlarının güzel olmadığı gösterilebilir. $T(14)$ alt ağacı tek bir düğümden oluştuğu için güzeldir. Aşağıda $T(1)$ alt ağacının da güzel olduğunu göstereceğiz.

$[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$ farklı tamsayı serisini düşünün.
Bu seri aşağıdaki şekilde gösterilmektedir.
Bu serideki her düğümün indisi, düğüme iliştirilen etiketteki numarayla gösterilir.

![Tree](beechtree-label1.png "500")

Şimdi bunun *güzel bir permütasyon* olduğunu doğrulayacağız.

* $v_0 = 1$.
* $f(1) = 0$ çünkü $C[v_1] = C[4] = 1$, $[]$ dizisinde $0$ kez görünür.
   * Buna uygun olarak, $v_1$'ın ebeveyni $v_0$'dır. Yani $4$ düğümünün ebeveyni $1$ düğümüdür. (Biçimsel olarak $P[4] = 1$.)
* $f(2) = 0$ çünkü $C[v_2] = C[5] = 2$, $[1]$ dizisinde $0$ kez görünür.
   * Buna uygun olarak, $v_2$'ın ebeveyni $v_0$'dır. Yani $5$'ın ebeveyni $1$'dır.
* $f(3) = 1$ çünkü $C[v_3] = C[12] = 1$, $1$ kez $[1, 2]$ dizisinde görünür.
   * Buna uygun olarak, $v_3$'ın ebeveyni $v_1$'dır. Yani $12$'ın ebeveyni $4$'dır.
* $f(4) = 1$ çünkü $C[v_4] = C[13] = 2$, $[1, 2, 1]$ dizisinde $1$ kez göründüğünden.
   * Buna uygun olarak, $v_4$'ın ebeveyni $v_1$'dır. Yani $13$'ın ebeveyni $4$'dır.
* $f(5) = 0$ çünkü $C[v_5] = C[6] = 3$, $[1, 2, 1, 2]$ dizisinde $0$ kez görünür.
   * Buna uygun olarak, $v_5$'ın ebeveyni $v_0$'dır. Yani $6$'ın ebeveyni $1$'dır.
* $f(6) = 2$ çünkü $C[v_6] = C[14] = 2$, $[1, 2, 1, 2, 3]$ dizisinde $2$ kez görünür.
   * Buna uygun olarak, $v_6$'ın ebeveyni $v_2$'dır. Yani $14$'ın ebeveyni $5$'dır.

$T(1)$'da düğümlerin *güzel bir permütasyonunu* bulabildiğimiz için, $T(1)$ alt ağacı *güzel bir alt ağaçtır*.

Göreviniz Árpád'a Ős Vezér'in her alt ağacının güzel olup olmadığına karar vermesinde yardımcı olmaktır.

## Kodlama Detayları

Aşağıdaki prosedürü kodlamalısınız.

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: Ağaçtaki düğüm sayısı.
* $M$: Olası kenar renklerinin sayısı.
* $P$, $C$: Ağacın kenarlarını tanımlayan $N$ uzunluğundaki diziler.
* Bu prosedür $N$ uzunluğunda $b$ dizisini dönmelidir.
  $0 \le r \lt N$ olacak şekilde her $r$ için, $T(r)$ güzelse $b[r]$, $1$ olmalı ve aksi takdirde $0$ olmalıdır.
* Her bir test senaryosu için bu prosedür tam olarak bir kere çağrılır. 

## Örnekler

### Örnek 1

Aşağıdaki çağrıyı gözönüne alın:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

Ağaç aşağıdaki figürde verilmiştir:

![Tree](beechtree-ex1.png "350")

$T(1)$, $T(2)$ ve $T(3)$'ın her biri tek bir düğüm içerir ve bu nedenle güzeldir.
$T(0)$ güzel değildir.
Bu nedenle prosedür $[0, 1, 1, 1]$ dönmelidir.

### Örnek 2

Aşağıdaki çağrıyı gözönüne alın:

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

Bu örnek yukarıdaki görev tanımında gösterilmiştir.

Prosedür şunu dönmelidir: $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$.

### Örnek 3

Aşağıdaki çağrıyı gözönüne alın:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

Bu örnek aşağıdaki figürde verilmişdir.

![Tree](beechtree-ex3.png "400")

$T(0)$ güzel olmayan tek alt ağaçtır.
Prosedür $[0, 1, 1, 1, 1, 1, 1]$ dönmelidir. 

## Kısıtlar

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[i] \lt v$ ($1 \le i \lt N$ olacak şekilde her $i$ için)
* $1 \le C[i] \le M$ ($1 \le i \lt N$ olacak şekilde her $i$ için)
* $P[0] = -1$ ve $C[0] = 0$

## Altgörevler

1. (9 puan) $N \le 8$ and $M \le 500$
1. (5 puan) $i$ kenarı, $i$ düğümünü $i-1$ düğümüne bağlar. Yani, $1 \le i \lt N$ olacak şekilde her $i$ için $P[i] = i-1$.
1. (9 puan) $0$ düğümü dışındaki her düğüm ya $0$ düğümüne bağlıdır ya da $0$ düğümüne bağlı bir düğüme bağlıdır. Yani, $1 \le v \lt N$ olacak şekilde her $v$ için ya  $P[v]=0$ ya da $P[P[v]]=0$.
1. (8 puan) $1 \le c \le M$ olacak şekilde her $c$ için, $c$ renginin en fazla iki kenarı vardır.
1. (14 puan) $N \le 200$ ve $M \le 500$
1. (14 puan) $N \le 2\,000$ ve $M = 2$
1. (12 puan) $N \le 2\,000$
1. (17 puan) $M = 2$
1. (12 puan) Ek kısıt yoktur.

## Örnek Değerlendirici (Sample Grader)

Örnek değerlendirici girdiyi aşağıdaki formatta okur:

* satır $1$: $N \; M$
* satır $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* satır $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

`beechtree`  tarafından döndürülen dizinin elemanları $b[0], \; b[1], \; \ldots$ ile belirtilsin.
Örnek değerlendirici cevabınızı aşağıdaki formatta görüldüğü gibi tek bir satırda yazar:
* satır $1$: $b[0] \; b[1] \; \ldots$
