# Бук

Вейтем Вудс -  ліс відомий великою кількістю кольорових дерев.
Один з найстаріших і найвищих гібридних буків називається Ош Везер.

Дерево Ош Везер можна представити як множину з $N$ **вершин** та $N-1$ **ребер**.
Вершини пронумеровані від $0$ до $N-1$, а ребра пронумеровані від $1$ до $N-1$.
Кожне ребро з'єднує дві різні вершини дерева.
Зокрема, ребро $i$ ($1 \le i \lt N$) з'єднує вершину $i$ з вершиною $P[i]$, де $0 \le P[i] \lt i$. Вершина $P[i]$ називається **батьком** вершини $i$, а вершина $i$ називається **дитиною** вершини $P[i]$.


Кожне ребро має колір. Існують $M$ можливих кольорів ребер, які пронумеровані від $1$ до $M$.
Ребро $i$ має колір $C[i]$.
Різні ребра можуть мати однаковий колір.

Зверніть увагу, що в цьому випадку $i = 0$ не відповідає ребру дерева. Для зручності будемо вважати, що $P[0] = -1$ та $C[0] = 0$.

Наприклад, припустимо, що Ош Везер має $N = 18$ вершин, $M = 3$ можливих кольорів ребер та $17$ ребер, описаних масивом $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ та кольорами $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$. Дерево відображено на наступному малюнку:

![Tree](beechtree-tree.png "550")

Арпад є талановитим лісником, який любить вивчати конкретні частини дерева, які називаються **піддеревами**.
Для кожного $r$ такого, що $0 \le r \lt N$, піддерево вершини $r$ - це множина вершин $T(r)$ з такими властивостями:
* Вершина $r$ належить до $T(r)$.
* Якщо вершина $x$ належить до $T(r)$, всі діти вершини $x$ також належать до $T(r)$.
* Інші вершини не належать до $T(r)$.

Розмір множини $T(r)$ позначається як $|T(r)|$.

Арпад недавно відкрив складну, але цікаву властивість піддерев. Для зрозуміння цього відкриття Арпад провів багато часу, граючись з олівцем та папером, і він підозрює, що вам може знадобитись зробити те ж саме, щоб зрозуміти це. Він також покаже вам кілька прикладів, які ви потім зможете детально проаналізувати.

Припустимо, у нас є фіксоване $r$ та послідовність $v_0, v_1, \ldots, v_{|T(r)|-1}$ вершин у піддереві $T(r)$.

Для кожного $i$ такого, що $1 \le i \lt |T(r)|$, нехай $f(i)$ - це кількість разів, коли колір $C[v_i]$ зустрічається у наступній послідовності з $i-1$ кольорів: $C[v_1], C[v_2], \ldots, C[v_{i-1}]$.

(Зверніть увагу, що $f(1)$ завжди дорівнює $0$, оскільки послідовність кольорів у його випадку є порожньою.)

Послідовність $v_0, v_1, \ldots, v_{|T(r)|-1}$ є **красивою послідовністю** тоді і лише тоді, коли виконуються всі наступні властивості:
* $v_0 = r$.
* Для кожного $i$ такого, що $1 \le i \lt |T(r)|$, батьком вершини $v_i$ є вершина $v_{f(i)}$.

Для будь-якого $r$ такого, що $0 \le r \lt N$, піддерево $T(r)$ є **красивим піддеревом** тоді і лише тоді, коли існує красива послідовність вершин у $T(r)$. Зауважте, що згідно з визначенням кожне піддерево, яке складається з однієї вершини, є красивим.

Розглянемо приклад дерева вище.
Можна показати, що піддерева $T(0)$ і $T(3)$ цього дерева не є красивими.
Піддерево $T(14)$ є красивим, оскільки воно складається з однієї вершини.
Нижче ми покажемо, що піддерево $T(1)$ також є красивим.

Розглянемо послідовність різних цілих чисел $[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$. Ця послідовність є перестановкою вершин у $T(1)$. На малюнку нижче зображена ця перестановка. Прапорці, прикріплені до вершин, показують індекси, в яких ці вершини з'являються у перестановці.

![Tree](beechtree-label1.png "500")

Очевидно, вищезазначена послідовність є перестановкою вершин у $T(1)$. Тепер ми перевіримо, чи є вона *красивою*.

* $v_0 = 1$.
* $f(1) = 0$, оскільки $C[v_1] = C[4] = 1$ з'являється $0$ разів у послідовності $[]$.
  * Відповідно, батьком $v_1$ є $v_0$. Іншими словами, батьком вершини $4$ є вершина $1$. (Формально, $P[4] = 1$.)
* $f(2) = 0$, оскільки $C[v_2] = C[5] = 2$ з'являється $0$ разів у послідовності $[1]$.
  * Відповідно, батьком $v_2$ є $v_0$. Іншими словами, батьком $5$ є $1$.
* $f(3) = 1$, оскільки $C[v_3] = C[12] = 1$ з'являється $1$ раз у послідовності $[1, 2]$.
  * Відповідно, батьком $v_3$ є $v_1$. Іншими словами, батьком $12$ є $4$.
* $f(4) = 1$, оскільки $C[v_4] = C[13] = 2$ з'являється $1$ раз у послідовності $[1, 2, 1]$.
  * Відповідно, батьком $v_4$ є $v_1$. Іншими словами, батьком $13$ є $4$.
* $f(5) = 0$, оскільки $C[v_5] = C[6] = 3$ з'являється $0$ разів у послідовності $[1, 2, 1, 2]$.
  * Відповідно, батьком $v_5$ є $v_0$. Іншими словами, батьком $6$ є $1$.
* $f(6) = 2$, оскільки $C[v_6] = C[14] = 2$ з'являється $2$ рази у послідовності $[1, 2, 1, 2, 3]$.
  * Відповідно, батьком $v_6$ є $v_2$. Іншими словами, батьком $14$ є $5$.

Оскільки ми змогли знайти красиву перестановку вершин у $T(1)$, піддерево $T(1)$ дійсно є красивим.

Ваше завдання - допомогти Арпаду визначити, чи кожне піддерево Ош Везера є красивим.


## Деталі імплементації

Вам потрібно імплементувати наступну функцію:

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: кількість вершин у дереві.
* $M$: кількість можливих кольорів ребер.
* $P$, $C$: масиви довжиною $N$, що описують ребра дерева.
* Ця функція повинна повернути масив $b$ довжиною $N$.
  Для кожного $r$ такого, що $0 \le r \lt N$, $b[r]$ повинно бути $1$, якщо $T(r)$ є красивим, і $0$ у протилежному випадку.
* Цю функцію викликають рівно один раз для кожного тестового випадку.


## Приклади

### Приклад 1

Розглянемо наступний виклик:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

Дерево відображено на наступному малюнку:
 
![Tree](beechtree-ex1.png "350")

$T(1)$, $T(2)$ та $T(3)$ кожна складається з однієї вершини, отже, є красивими.
$T(0)$ не є красивою.
Отже, функція повинна повернути $[0, 1, 1, 1]$.


### Приклад 2

Розглянемо наступний виклик:

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

Цей приклад проілюстровано в описі завдання вище.

Функція повинна повернути $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$.

### Приклад 3

Розглянемо наступний виклик:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

Цей приклад проілюстровано на наступному малюнку.

![Tree](beechtree-ex3.png "400")

$T(0)$ є єдиним піддеревом, яке не є красивим.
Функція повинна повернути $[0, 1, 1, 1, 1, 1, 1]$.


## Обмеження

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[i] \lt i$ (для кожного $i$ такого, що $1 \le i \lt N$)
* $1 \le C[i] \le M$ (для кожного $i$ такого, що $1 \le i \lt N$)
* $P[0] = -1$ та $C[0] = 0$

## Підзадачі

1. (9 балів) $N \le 8$ та $M \le 500$
2. (5 балів) Ребро $i$ з'єднує вершину $i$ з вершиною $i-1$. Тобто, для кожного $i$ такого, що $1 \le i \lt N$, $P[i] = i-1$.
3. (9 балів) Кожна вершина, крім вершини $0$, з'єднана або з вершиною $0$, або з вершиною, яка з'єднана з вершиною $0$. Тобто, для кожного $i$ такого, що $1 \le i \lt N$, або $P[i]=0$, або $P[P[i]]=0$.
4. (8 балів) Для кожного $c$ такого, що $1 \le c \le M$, існує не більше двох ребер кольору $c$.
5. (14 балів) $N \le 200$ та $M \le 500$
6. (14 балів) $N \le 2\,000$ та $M = 2$
7. (12 балів) $N \le 2\,000$
8. (17 балів) $M = 2$
9. (12 балів) Немає додаткових обмежень.

## Приклад градера

Градер зчитує дані у наступному форматі:

* Рядок $1$: $N \; M$
* Рядок $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* Рядок $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

Позначимо $b[0], \; b[1], \; \ldots$ елементи масиву, який повернула функція `beechtree`.
Градер виводить масив у наступному форматі:
* Рядок $1$: $b[0] \; b[1] \; \ldots$

