# Beech Tree

Vétyem Woods là một khu rừng nổi tiếng với nhiều cây cối có đủ sắc màu.
Một trong những cây sồi cổ nhất và cao nhất có tên là Ős Vezér.

Cây Ős Vezér có thể được mô hình bằng một tập hợp $N$ **đỉnh** và $N-1$ **cạnh**.
Các đỉnh được đánh số từ $0$ đến $N-1$ và các cạnh được đánh số từ $1$ đến $N-1$.
Mỗi cạnh nối hai đỉnh khác nhau trong cây.
Cụ thể, cạnh $i$ ($1 \le i \lt N$) nối đỉnh $i$ đến đỉnh $P[i]$, với $0 \le P[i] \lt i$. Đỉnh $P[i]$ được gọi là **cha** của đỉnh $i$, và đỉnh $i$ được gọi là  **con** của đỉnh $P[i]$.

Mỗi cạnh có một màu. Có tất cả $M$ màu cho các cạnh đánh số từ $1$ đến $M$.
Màu của cạnh $i$ là $C[i]$.
Các cạnh khác nhau có thể có cùng màu.

Lưu ý rằng trong định nghĩa trên, trường hợp $i = 0$ không tương ứng với cạnh nào trong cây. Để thuận tiện, ta đặt $P[0] = -1$ và $C[0] = 0$.

Ví dụ, giả sử cây Ős Vezér có $N = 18$ đỉnh và $M = 3$ màu cho các cạnh, với $17$ cạnh mô tả bởi các kết nối $P = [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11]$ và các màu $C = [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3]$. Cây này được mô tả ở hình dưới đây:

![Tree](beechtree-tree.png "550")

Árpád là một người lính kiểm lâm giỏi. Anh ấy thích nghiên cứu các phần của cây gọi là các **cây con**.
Với mỗi $r$ mà $0 \le r \lt N$, cây con của đỉnh  $r$  là  tập  $T(r)$ các đỉnh có tính chất sau
* Đỉnh $r$ thuộc $T(r)$.
* Khi một đỉnh $x$ thuộc $T(r)$ thì mọi đỉnh con của $x$ cũng thuộc $T(r)$.
* Không có đỉnh nào khác thuộc $T(r)$.

Kích thước của tập  $T(r)$ được kí hiệu là $|T(r)|$.

Gần đây, Árpád phát hiện ra một tính chất phức tạp nhưng thú vị của cây con. Phát hiện của Árpád cần sử dụng rất nhiều giấy và bút, và anh ấy tin rằng bạn cũng phải làm như vậy để hiểu được tính chất này. Anh ấy sẽ cho bạn thấy nhiều ví dụ để bạn có thể phân tích chi tiết.

Giả sử chúng ta có một đỉnh $r$ và một hoán vị  $v_0, v_1, \ldots, v_{|T(r)|-1}$ của các đỉnh trong cây con $T(r)$.

Với mỗi $i$ mà $1 \le i \lt |T(r)|$, gọi $f(i)$ là số lần màu $C[v_i]$ xuất hiện trong dãy gồm $i-1$ màu: $C[v_1], C[v_2], \ldots, C[v_{i-1}]$.

(Lưu ý rằng $f(1)$ luôn bằng 0 bởi vì dãy các màu trong định nghĩa của nó là rỗng.)

Hoán vị $v_0, v_1, \ldots, v_{|T(r)|-1}$ là **hoán vị đẹp** khi và chỉ khi có tất cả các tính chất sau:
* $v_0 = r$.
* Với mỗi $i$ mà $1 \le i \lt |T(r)|$, cha của đỉnh $v_i$ là đỉnh $v_{f(i)}$.

Với $r$ bất kì mà $0 \le r \lt N$, cây con $T(r)$ là **cây con đẹp** khi và chỉ khi tồn tại một hoán vị đẹp của các đỉnh trong $T(r)$. Lưu ý rằng theo định nghĩa này thì mọi cây con có một đỉnh đều là cây con đẹp.

Xét cây ví dụ ở trên.
Có thể chứng minh cây con $T(0)$ và $T(3)$ của cây này không là cây con đẹp.
Cây con $T(14)$ là cây con đẹp vì chỉ có một đỉnh.
Dưới đây, ta sẽ chứng minh cây con $T(1)$ cũng là cây con đẹp.

Xét dãy số nguyên khác nhau $[v_0, v_1, v_2, v_3, v_4, v_5, v_6] = [1, 4, 5, 12, 13, 6, 14]$. Dãy số này là một hoán vị của các đỉnh trong $T(1)$. Hình dưới đây mô tả hoán vị này. Nhãn gán trên mỗi đỉnh là các chỉ số mà đỉnh đó xuất hiện trong hoán vị trên.

![Tree](beechtree-label1.png "500")

Bây giờ ta sẽ chứng minh đây là một *hoán vị đẹp*.
* $v_0 = 1$.
* $f(1) = 0$ vì $C[v_1] = C[4] = 1$ xuất hiện $0$ lần trong dãy $[]$.
  * Tương ứng, đỉnh cha của đỉnh $v_1$ là đỉnh $v_0$. Tức là cha của đỉnh 4 là đỉnh 1 (hay $P[4]=1$).
* $f(2) = 0$ vì $C[v_2] = C[5] = 2$ xuất hiện $0$ lần trong dãy $[1]$
  * Tương ứng,  đỉnh cha của đỉnh $v_2$ là đỉnh $v_0$. Tức là cha của đỉnh 5 là đỉnh 1.
* $f(3) = 1$ vì $C[v_3] = C[12] = 1$ xuất hiện $1$ lần trong dãy $[1, 2]$
  * Tương ứng,  đỉnh cha của đỉnh $v_3$ là đỉnh $v_1$. Tức là cha của đỉnh 12 là đỉnh 4.
* $f(4) = 1$ vì $C[v_4] = C[13] = 2$ xuất hiện $1$ lần trong dãy $[1, 2, 1]$
  * Tương ứng,  đỉnh cha của đỉnh $v_4$ là đỉnh $v_1$. Tức là  cha của đỉnh 13 là đỉnh 4.
* $f(5) = 0$ vì $C[v_5] = C[6] = 3$ xuất hiện $0$ lần trong dãy $[1, 2, 1, 2]$
  * Tương ứng,  đỉnh cha của đỉnh $v_5$ là đỉnh $v_0$. Tức là  cha của đỉnh 6 là đỉnh 1.
* $f(6) = 2$ vì $C[v_6] = C[14] = 2$ xuất hiện $2$ lần trong dãy $[1, 2, 1, 2, 3]$
  * Tương ứng,  đỉnh cha của đỉnh $v_6$ là đỉnh $v_2$. Tức là  cha của đỉnh 14 là đỉnh 5.

Do chúng ta có thể tìm được một *hoán vị đẹp* của các đỉnh trong $T(1)$, cây con $T(1)$ đúng là *cây con đẹp*.

Nhiệm vụ của bạn là giúp Árpád quyết định xem với mỗi cây con của cây Ős Vezér, cây con nào là đẹp.

## Chi tiết cài đặt

Bạn cần cài đặt hàm sau.

```
int[] beechtree(int N, int M, int[] P, int[] C)
```

* $N$: số đỉnh trong cây.
* $M$: số màu có thể có cho các cạnh.
* $P$, $C$: các mảng độ dài $N$ mô tả các cạnh của cây.
* Hàm này cần trả về mảng  $b$ có độ dài $N$. 
  Với mỗi $r$ mà $0 \le r \lt N$, $b[r]$ là $1$ nếu $T(r)$ là cây con đẹp, và là $0$ nếu ngược lại.
* Hàm này được gọi đúng một lần cho mỗi test.

## Ví dụ

### Ví dụ 1

Xét lời gọi hàm sau:

```
beechtree(4, 2, [-1, 0, 0, 0], [0, 1, 1, 2])
```

Cây tương ứng được mô tả ở hình dưới:

![Tree](beechtree-ex1.png "350")

$T(1)$, $T(2)$, và $T(3)$ mỗi cây có đúng một đỉnh nên chúng là cây con đẹp.
$T(0)$ không là cây con đẹp.
Vì vậy, hàm cần trả về $[0, 1, 1, 1]$.

### Ví dụ 2

Xét lời gọi hàm sau:

```
beechtree(18, 3, 
          [-1, 0, 0, 0, 1, 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 10, 11, 11],
          [0, 1, 2, 3, 1, 2, 3, 1, 3, 3, 2, 1, 1, 2, 2, 1, 2, 3])
```

Ví dụ này được mô tả ở trong đề bài ở trên.

Hàm cần trả về $[0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]$.

### Ví dụ 3

Xét lời gọi hàm sau:

```
beechtree(7, 2, [-1, 0, 1, 1, 0, 4, 5], [0, 1, 1, 2, 2, 1, 1])
```

Ví dụ này được mô tả ở hình dưới:

![Tree](beechtree-ex3.png "400")

$T(0)$ là cây con duy nhất không là cây con đẹp.
Hàm cần trả về $[0, 1, 1, 1, 1, 1, 1]$.


## Các ràng buộc

* $3 \le N \le 200\,000$
* $2 \le M \le 200\,000$
* $0 \le P[i] \lt i$ (với mỗi $i$ mà $1 \le i \lt N$)
* $1 \le C[i] \le M$ (với mỗi $i$ mà $1 \le i \lt N$)
* $P[0] = -1$ và $C[0] = 0$

## Các subtask

1. (9 điểm) $N \le 8$ và $M \le 500$
1. (5 điểm) Cạnh $i$ nối đỉnh $i$ với đỉnh $i-1$. Nghĩa là, với mỗi $i$ mà $1 \le i \lt N$, $P[i] = i-1$.
1. (9 điểm) Với mỗi đỉnh khác đỉnh $0$ thì đỉnh đó hoặc được nối với đỉnh $0$, hoặc được nối với một đỉnh được nối với đỉnh $0$.
  Nghĩa là, với mỗi $i$ mà $1 \le i \lt N$, hoặc $P[i]=0$ hoặc $P[P[i]]=0$.
1. (8 điểm) Với mỗi $c$ mà $1 \le c \le M$, có nhiều nhất hai cạnh có màu $c$.
1. (14 điểm) $N \le 200$ và $M \le 500$
1. (14 điểm) $N \le 2\,000$ và $M = 2$
1. (12 điểm) $N \le 2\,000$
1. (17 điểm) $M = 2$
1. (12 điểm) Không có ràng buộc nào thêm.

## Trình chấm mẫu

Trình chấm mẫu đọc dữ liệu vào theo định dạng sau:

* Dòng $1$: $N \; M$
* Dòng $2$: $P[0] \; P[1] \; \ldots \; P[N-1]$
* Dòng $3$: $C[0] \; C[1] \; \ldots \; C[N-1]$

Gọi $b[0], \; b[1], \; \ldots$ là các phần tử của mảng trả về bởi `beechtree`.
Trình chấm mẫu in lời giải của bạn trên một dòng, theo định dạng sau:
* Dòng $1$: $b[0] \; b[1] \; \ldots$
